<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: adminsetup.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-admin' ;
	$tran = 'admin' ;
	include('../ck-api/ckapi.inc.php') ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report','confirm.tpl');
	$db_type = $ckapi[hostsys][dbtype] ;
	$float = ($db_type=="mysql") ? "double default 0" : "float default 0" ;
	$int = "int default 0" ;

/*---------------------------------------------------------------------------------*/

	if ($db_type == "mysql")	$id_field = $logid_field = "id int unsigned PRIMARY KEY auto_increment" ;
	if ($db_type == "pgsql")	{
		$comment = lang("sequence created") ;
		$sql =	"CREATE SEQUENCE id start 10000 increment 1 maxvalue 2147483647 minvalue 1 cache 1" ;
		$phpgw->db->query($sql);
		$sql =	"SELECT nextval ('id')" ;
		$phpgw->db->query($sql);
			echo "<b>[id]</b> $comment<br>";
		$sql =	"CREATE SEQUENCE logid start 30000 increment 1 maxvalue 2147483647 minvalue 1 cache 1" ;
		$phpgw->db->query($sql);
		$sql =	"SELECT nextval ('logid')" ;
		$phpgw->db->query($sql);
			echo "<b>[logid]</b> $comment<br>";
		$id_field = "id int DEFAULT nextval('id')" ;
		$logid_field = "id int DEFAULT nextval('logid')" ;
		}

/*---------------------------------------------------------------------------------*/

	$trans_id = "trans_id $int" ;
	$contactid = "contactid $int" ;
	$transdate = "transdate date DEFAULT 'now'" ;
	$desc = "description text" ;
	$name = "name text" ;
	$control = "control int DEFAULT 100" ;
	$allowdelete = "allowdelete char DEFAULT 'n'" ;
	$preferred = "preferred char DEFAULT 'n'" ;
	$count = 0 ;
	$comment = lang("table(s) created") ;
	$sql =	"CREATE TABLE ${pre}md5 ($id_field,app text,script text,version text,checksum text)";
	$phpgw->db->query($sql);
		echo "<b>[${pre}md5]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE ${pre}category ($id_field,app text,type text,$name,$desc,parent $int,$allowdelete,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}category]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}makemodel ($id_field,parts_id $int,$name)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}makemodel]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}gl ($id_field,source text,$desc,$transdate,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}gl]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}il ($id_field,source text,$desc,to_from $int,$transdate,$control)";
	$phpgw->db->query($sql);
		echo "<b>[${pre}il]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}chart ($id_field,accno $int UNIQUE,$desc," ;
	$sql.=			"charttype char(1) DEFAULT 'A',gifi text," ;
	$sql.=			"category char(1),link text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}chart]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}fund ($id_field,$name,$desc,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}fund]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}project ($id_field,$name,$desc,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}project]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}achievement ($id_field,$name,$desc,min $float,max $float," ;
	$sql.=	"rate $float,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}achievement]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE ${pre}department ($id_field,$name,$desc,head $int,email text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}department]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE ${pre}remark ($id_field,$name,description text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}remark]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE ${pre}currency ($id_field,isocode varchar(3),$desc,exrate $float,$control)";
	$phpgw->db->query($sql);
		echo "<b>[${pre}currency]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE ${pre}defaults ($id_field,inventory_accno_id $int," ;
	$sql.=	"income_accno_id $int,expense_accno_id $int," ;
	$sql.=	"company varchar(35),addr1 varchar(35),addr2 varchar(35),addr3 varchar(35),";
	$sql.=	"addr4 varchar(35),contact varchar(35),phone varchar(30),fax varchar(20),";
	$sql.=	"aptax1cap text,aptax2cap text,aptax1pref char(1),aptax2pref char(1)," ;
	$sql.=	"artax1cap text,artax2cap text,artax1pref char(1),artax2pref char(1)," ;
	$sql.=	"postax1cap text,postax2cap text,postax1pref char(1),postax2pref char(1)," ;
	$sql.=	"attrib1cap text,attrib2cap text,attrib3cap text,";
	$sql.=	"attrib1tbl text,attrib2tbl text,attrib3tbl text," ;
	$sql.=	"attrib1sdesc text,attrib2sdesc text,attrib3sdesc text," ;
	$sql.=	"attrib1ldesc text,attrib2ldesc text,attrib3ldesc text," ;
	$sql.=	"attrib1tblmn text,attrib2tblmn text,attrib3tblmn text," ;
	$sql.=	"attrib1cnval text,attrib2cnval text,attrib3cnval text," ;
	$sql.=	"email text,inv_rmkid $int,rmd_rmkid $int,po_rmkid $int,quo_rmkid $int," ;
	$sql.=	"sm_rmkid $int,invnumber text,ponumber text,yearend date,nativecurr varchar(3),";
	$sql.=	"weightunit varchar(5),businessnumber text,version varchar(8),readonlygrp text," ;
	$sql.=	"photoyn text,addressyn text,phoneyn text,emailyn text,ecyn text," ;
	$sql.=	"mndfactor $int,smdfactor $int,wkdfactor $float," ;
	$sql.=	"mnhfactor $int,smhfactor $int,wkhfactor $int,dyhfactor $int,";
	$sql.=	"centeryn text,contactusyn text,ledreportyn text," ;
	$sql.=	"custinfoyn text,cttinfoyn text,helpcaseyn text,contractyn text,quoteyn text," ;
	$sql.=	"soyn text,invoiceyn text,ubsoyn text,osinvyn text,statementyn text,$control )" ;

	$phpgw->db->query($sql);
		echo "<b>[${pre}defaults]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}resourcelock (resource text,used_by text)";
	$phpgw->db->query($sql);
		echo "<b>[${pre}resourcelock]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE ${pre}acc_trans($id_field,$trans_id,chart_id $int," ;
	$sql.=			"attrib1 $int, attrib2 $int, attrib3 $int,amount $float,$transdate)";
	$phpgw->db->query($sql);
		echo "<b>[${pre}acc_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}bkr_trans($id_field,$trans_id,chart_id $int,source text,$desc," ;
	$sql.=			"cheque text,refnumber text,status char(1)," ;
	$sql.=			"amount $float,$transdate,$control)";
	$phpgw->db->query($sql);
		echo "<b>[${pre}bkr_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}inv_trans($trans_id,order_id $int,parts_id $int,qty $float,$transdate)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}inv_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}invoice ($id_field,$trans_id,inventory_accno_id $int," ;
	$sql.=		"income_accno_id $int,expense_accno_id $int,itemid $int,itemtype char(1)," ;
	$sql.=		"$desc,qty $float,price $float,cost $float,discount $float," ;
	$sql.=		"tax1 $float,tax2 $float,tax1_accno_id $int,tax2_accno_id $int," ;
	$sql.=		"unit varchar(5))";
	$phpgw->db->query($sql);
		echo "<b>[${pre}invoice]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}oitem ($id_field,$trans_id,itemid $int," ;
	$sql.=			"itemtype char(1),$desc,qty $float,price $float,cost $float," ;
	$sql.=			"discount $float,tax1 $float,tax2 $float,unit varchar(5))";
	$phpgw->db->query($sql);
		echo "<b>[${pre}oitem]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}vendor ($id_field,$contactid,$name,catid $int,taxincluded char," ;
	$sql.=			"terms $int,$control) " ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}vendor]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}customer ($id_field,$contactid,$name,catid $int,taxincluded char," ;
	$sql.=			"discount $float,creditlimit $float,terms $int,$control) " ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}customer]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}parts ($id_field,partnumber text,$desc," ;
	$sql.=			"unit varchar(5),listprice $float,price $float,cost $float," ;
	$sql.=			"notes text,bin text,priceupdate date DEFAULT 'now'," ;
	$sql.=			"weight $float,costupdate date DEFAULT 'now',rop $float," ;
	$sql.=			"inventory_accno_id $int,income_accno_id $int," ;
	$sql.=			"expense_accno_id $int,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}parts]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}assembly ($id_field,assembly_id $int,item_id $int,qty $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}assembly]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}alternate ($id_field,alternate_id $int,item_id $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}alternate]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}service ($id_field,servicenumber text,$desc,unit varchar(5)," ;
	$sql.=			"listprice $float,price $float,cost $float,notes text," ;
	$sql.=			"priceupdate date DEFAULT 'now',costupdate date DEFAULT 'now'," ;
	$sql.=			"income_accno_id $int,expense_accno_id $int,$control )" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}service]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}ar ($id_field,invnumber text,ar_accno_id $int," ;
	$sql.=			"$transdate,customer $int,taxincluded char," ;
	$sql.=			"amount $float,netamount $float,isocode varchar(3),exrate $float," ;
	$sql.=			"duedate date,notes text,ordnumber text," ;
	$sql.=			"shippingpoint text,terms $int,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}ar]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}ap ($id_field,invnumber text,ap_accno_id $int," ;
	$sql.=			"$transdate,vendor $int,taxincluded char," ;
	$sql.=			"amount $float,netamount $float,isocode varchar(3),exrate $float," ;
	$sql.=			"duedate date,ordnumber text,$control )" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}ap]</b> $comment<br>";			$count++ ;
	$sql ="CREATE TABLE ${pre}po ($id_field,ponumber text,$transdate,vendor $int,taxincluded char," ;
	$sql.=			"amount $float,netamount $float,isocode varchar(3),exrate $float," ;
	$sql.=			"duedate date,shipfrom text,notes text,$control )" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}po]</b> $comment<br>";			$count++ ;
	$sql ="CREATE TABLE ${pre}so ($id_field,sonumber text,$transdate,customer $int,taxincluded char,";
	$sql.=			"amount $float,netamount $float,isocode varchar(3),exrate $float," ;
	$sql.=			"duedate date,shipfrom text,notes text,$control )" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}so]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}quote ($id_field,quotenumber text,so_id $int," ;
	$sql.=			"$transdate,customer $int,taxincluded char," ;
	$sql.=			"amount $float,netamount $float,isocode varchar(3),exrate $float," ;
	$sql.=			"duedate date,shipfrom text,notes text,$control )" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}quote]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}tax ($id_field,chart_id $int,rate $float," ;
	$sql.=	"taxnumber text,taxgroup text,notes text,$control )" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}tax]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}customertax (customer_id $int,tax_id $int,taxtype char)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}customertax]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE ${pre}vendortax (vendor_id $int,tax_id $int,taxtype char)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}vendortax]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}itemtax (item_id $int,tax_id $int,taxtype char)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}itemtax]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}payment ($id_field,paynumber text,cheque text," ;
	$sql.=		"$transdate,vendor $int,amount $float,isocode varchar(3),exrate $float," ;
	$sql.=		"payee text,remark text,dr_accno_id $int,cr_accno_id $int,$control )" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}payment]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}receipt ($id_field,rptnumber text,cheque text," ;
	$sql.=		"$transdate,customer $int,amount $float,isocode varchar(3),exrate $float," ;
	$sql.=		"remark text,dr_accno_id $int,cr_accno_id $int,$control )" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}receipt]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}p_match (paymentid $int,invoiceid $int,s_amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}p_match]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}r_match (receiptid $int,invoiceid $int,s_amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}r_match]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}ipmatch (poid $int,invoiceid $int,b_amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}ipmatch]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}ismatch (soid $int,invoiceid $int,b_amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}ismatch]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}sqmatch (quoteid $int,soid $int,a_amount $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}sqmatch]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}qcash ($id_field,$name,value $float,minsale $float,maxsale $float," ;
	$sql.=		"minqty $int,maxqty $int,minvalue $float,maxvalue $float," ;
	$sql.=		"posacc_id $int,start date,endd date,splan_id $int,notes text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}qcash]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}addon ($id_field,$name,factor $float,basis char(1)," ;
	$sql.=			"mincount $int,maxcount $int,minsale $float,maxsale $float," ;
	$sql.=			"incacc_id $int,expacc_id $int,start date," ;
	$sql.=			"endd date,splan_id $int,notes text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}addon]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}sprice ($id_field,$name,itemid $int,price $float," ;
	$sql.=			"start date,endd date,splan_id $int,notes text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}sprice]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}cashbox($id_field,$name,cashier text,shift char(1)," ;
	$sql.=			"location text,maxcash $float,notes text,$control)";
	$phpgw->db->query($sql);
		echo "<b>[${pre}cashbox]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}pos ($id_field,posnumber text,cboxid $int,cashier text," ;
	$sql.=			"$transdate,shift char(1),customer $int," ;
	$sql.=			"taxincluded char,amount $float,netamount $float,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}pos]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}positem ($id_field,$trans_id," ;
	$sql.=		"invacc_id $int,incacc_id $int,expacc_id $int,posacc_id $int," ;
	$sql.=		"itemid $int,itemtype char(1),qty $float,price $float,cost $float," ;
	$sql.=		"value $float,factor $float,discount $float,unit varchar(5),";
	$sql.=		"tax1 $float,tax2 $float,tax1acc_id $int,tax2acc_id $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}positem]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}cbtran ($id_field,cbtnumber text,cboxid $int,manager text," ;
	$sql.=		"cashier text,trantype char(1),$transdate,shift char(1),amount $float," ;
	$sql.=		"posac_id $int,citac_id $int,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}cbtran]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}log ($logid_field,$trans_id,app text,script text,ip text," ;
	$sql.=		"iptime text,userid text,op text,header text,detail text,timestamp $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}log]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}errlog ($id_field,$trans_id,dbtype varchar(5),app text,script text,ip text," ;
	$sql.=		"userid text,timestamp $int,file varchar(255),line $int,type $int,message text)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}errlog]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}employee ($id_field,$name,prefix text,family text,given text," ;
	$sql.=	"suffix text,nationalid text,username text,title text,supervisor $int," ;
	$sql.=	"dept $int,grade text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}employee]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}hrcode ($id_field,type text,$name,$desc,$allowdelete,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}hrcode]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}address (contactid $int,line1 text,line2 text,line3 text,line4 text," ;
	$sql.=	"addresscode text,region text,country text,zip text,$preferred)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}address]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}phone (empid $int,prefix text,phone $int,suffix text,phonecode text)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}phone]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}email (empid $int,prefix text,suffix text,emailcode text)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}email]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}ec (empid $int,prefix text,family text,given text,suffix text," ;
	$sql.=	"contact text,relation text,eccode text)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}ec]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}dates (empid $int,empdate date,datecode text,notify $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}dates]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}leave (empid $int,$trans_id,leavefrom date,leaveto date," ;
	$sql.=	"leavecode text,duration $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}leave]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}pr (empid $int,prfrom date,prto date,prcode text,comment text,reviewer $int,pddate date)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}pr]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}role (empid $int,rolecode text)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}role]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}attendance ($id_field,empid $int,type text,reason text,$transdate," ;
	$sql.=	"time text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}attendance]</b> $comment<br>";		$count++ ;
	$sql =	"CREATE TABLE ${pre}timesheet ($id_field,empid $int,year $int,week $int," ;
	$sql.=	"hour_ttl $float,day_ttl $float,approved_by text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}timesheet]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}ts_trans ($id_field,$trans_id,$transdate,project $int,activity text," ;
	$sql.=	"hour $float,day $float,achieve $int,achival $float,achiunit $float)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}ts_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}leaveapp ($id_field,empid $int,leavefrom date,leaveto date," ;
	$sql.=	"leavecode text,duration $float,approved_by text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}leaveapp]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}payroll ($id_field,empid $int,salary $int,period char(2),chart_id $int," ;
	$sql.=	"bankacname text,bankac text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}payroll]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}pyrcode ($id_field,$name,$desc,basis text,minqty $float,maxqty $float," ;
	$sql.=	"minamt $float,maxamt $float,unitamt $float,unit text,rate $float,chart_id $int," ;
	$sql.=	"single char,allowssc char,$allowdelete,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}pyrcode]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}pyrc_trans ($id_field,pyroid $int,pyrcodeid $int,qty $float," ;
	$sql.=	"unit text,unitamt $float,rate $float,amount $float,comment text,chart_id $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}pyrc_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}pynr_trans ($id_field,empid $int,pyrcodeid $int,qty $float,unit text," ;
	$sql.=	"unitamt $float,rate $float,amount $float,comment text,chart_id $int,approved_by text," ;
	$sql.=	"$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}pynr_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}rdtn_trans ($id_field,pyroid $int,rdtnid $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}rdtn_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}cntr_trans ($id_field,pyroid $int,cntrid $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}cntr_trans]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}reductn ($id_field,$name,$desc,locality text,chart_id $int," ;
	$sql.=	"floor $int,min $int,actmin char(3),max $int,actmax char(3),$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}reductn]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}rdtnrate ($id_field,rdtnid $int,step $int,rate $float,subtract $int)";
	$phpgw->db->query($sql);
		echo "<b>[${pre}rdtnrate]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}rdtnexem ($id_field,rdtnid $int,pyrcodeid $int," ;
	$sql.=	"min $int,actmin char(3),max $int,actmax char(3))" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}rdtnexem]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}contri ($id_field,$name,$desc,locality text,ac_exp $int,ac_liab $int," ;
	$sql.=	"floor $int,min $int,actmin char(3),max $int,actmax char(3),$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}contri]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}cntrrate ($id_field,cntrid $int,step $int,rate $float,subtract $int)";
	$phpgw->db->query($sql);
		echo "<b>[${pre}cntrrate]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}cntrexem ($id_field,cntrid $int,pyrcodeid $int," ;
	$sql.=	"min $int,actmin char(3),max $int,actmax char(3))" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}cntrexem]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}pyrohist ($trans_id,empid $int,type char(4),codeid $int,basis text," ;
	$sql.=	"qty $float,unit text,unitamt $float,rate $float,amount $float,comment text," ;
	$sql.=	"approved_by text,chart_id $int,base $float,floor $int,subtract $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}pyrohist]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}cttcode ($id_field,catid $int,type text,$name,$desc,$allowdelete,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}category]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}org ($id_field,orgnumber text,orgname text," ;
	$sql.=	"username text,nationalorgid text,note text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}org]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}person ($id_field,prsnumber text,prefix text,family text,given text," ;
	$sql.=	"suffix text,nationalid text,username text,birthday date," ;
	$sql.=	"note text,pubkey text,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}person]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}person_org (contactid $int,orgid $int,orgcode text,title text,department text,$preferred)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}person_org]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}person_person (contactid $int,personid $int,personcode text,$preferred)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}person_person]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}org_person (contactid $int,personid $int,personcode text,title text,department text,$preferred)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}org_person]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}org_org (contactid $int,orgid $int,orgcode text,$preferred)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}org_org]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}comm (contactid $int,commcode text,commdata text,$preferred)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}comm]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}ctt_category (contactid $int,cttcode text,$preferred)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}ctt_category]</b> $comment<br>";			$count++ ;
	$sql =	"CREATE TABLE ${pre}others (contactid $int,description text,value text,$preferred)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}others]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}scontract ($id_field,cntnumber text,start date,endd date,customer $int,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}scontract]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}pcontract ($id_field,cntnumber text,start date,endd date,vendor $int,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}pcontract]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}stdterm ($id_field,contractid $int,stdpara text,catid $int)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}stdterm]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}spcterm ($id_field,contractid $int,spcpara text,detail text)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}spcterm]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}helpcase ($id_field,casenumber text,casecatid $int,customer $int,start date," ;
	$sql.=				"itemid $int,$desc,pricatid $int,billable char(1),monitor $int,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}helpcase]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}helpcall ($id_field,caseid $int,calldate date,calltime char(4),callcatid $int," ;
	$sql.=		"mediacatid $int,prsfrom text,prsto text,statecatid $int,assigned $int,actioned $int," ;
	$sql.=		"deadline date,hours $float,summary text)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}helpcall]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}salecase ($id_field,casenumber text,casecatid $int,customer $int,start date," ;
	$sql.=		"itemid $int,$desc,pricatid $int,amount $float,prospect $float,monitor $int,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}salecase]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}salecall ($id_field,caseid $int,calldate date,calltime char(4),callcatid $int," ;
	$sql.=		"mediacatid $int,prsfrom text,prsto text,statecatid $int,assigned $int,actioned $int," ;
	$sql.=		"deadline date,hours $float,summary text)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}salecall]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}vendcase ($id_field,casenumber text,casecatid $int,vendor $int,start date," ;
	$sql.=		"itemid $int,$desc,pricatid $int,amount $float,prospect $float,monitor $int,$control)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}vendcase]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}vendcall ($id_field,caseid $int,calldate date,calltime char(4),callcatid $int," ;
	$sql.=		"mediacatid $int,prsfrom text,prsto text,statecatid $int,assigned $int,actioned $int," ;
	$sql.=		"deadline date,hours $float,summary text)" ;
	$phpgw->db->query($sql);
		echo "<b>[${pre}vendcall]</b> $comment<br>";				$count++ ;
	$sql =	"CREATE TABLE ${pre}rights ($id_field,rgroup text,module text,rtable text,rfield text,rvalue text,$control)";
	$phpgw->db->query($sql);
		echo "<b>[${pre}rights]</b> $comment<br>";		$count++ ;

		echo "<br>$count $comment" ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',lang('Blank Data Tables Created'));
	$t->set_var('lang_yes',lang('Done'));
	$t->set_var('lang_no',lang('Done'));
	$t->set_var('yes_action',$phpgw->link("/$app/${tran}filter.php")) ;
	$t->set_var('no_action',$phpgw->link("/$app/${tran}filter.php")) ;
	$t->pparse('out','report');
//	ExecMethod('ck-api.process.process_footer') ;

?>

