<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.logo.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class logo {

//---- Image Read

    function logo_read() {
	global $ckapi,$phpgw ;

//	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * from $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	return $dt ;
	}

//---- Image Detail Validation Checks

    function logo_validate() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	$maxfile = 10240 ;
	$newimg = "/tmp/logo.ck-erp.img" ;
	if (!$dt[post] and !is_file($newimg))	$err = lang("Image must be previewed before update") ;
	if (is_file($newimg) and filesize($newimg)>$maxfile)
		$err = lang("File size too large (max-10K)") ;
	if ($dt['logotype']<>"image")
		$err = lang("Image must be of type (image), check if logo had been previewed") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Image Detail

    function logo_write() {
	global $ckapi,$phpgw ;

	$app = $ckapi[params][app] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_oldlogo',lang('Existing Logo'));
	$t->set_var('lang_browse',lang("Click [Browse] to choose new logo's file name, then click [Preview New Logo]"));
	$t->set_var('lang_newlogo',lang('New Logo'));

	$id = $dt[id] ;
	$t->set_var('id',$id);
	$t->set_var('control',$dt[control]);
	$t->set_var('logotype',$dt['logotype']);
	$imgdir = $ckapi[hostsys][dataarea]."/images" ;
	$oldimg = "$imgdir/logo.png" ;
	$t->set_var('oldlogo',$phpgw->link("/$app/logoview_image.php","imgfile=$oldimg"));
	if (!isset($dt[post]) and isset($_FILES['logofile'])) {
		$tempimg = $_FILES['logofile']['tmp_name'] ;
		$types = explode("/",$_FILES['logofile']['type']) ;
		$dt['logotype'] = $types[0] ;
		$t->set_var('logotype',$dt['logotype']);
		exec("rm -f /tmp/*.ck-erp.img") ;
		$newimg = "/tmp/logo.ck-erp.img" ;
		move_uploaded_file($tempimg, $newimg) ;
		}
	$t->set_var('newlogo',$phpgw->link("/$app/logoview_image.php","imgfile=$newimg"));
	$t->parse('out','report',True);
	}

//---- Reformat logo Data (logo Preview)

    function logo_transform() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$preview = &$ckapi[buttons][preview] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	if (isset($preview)) {
		$func = "${class}_validate" ;
		$err = $this->$func() ;
		if ($err) {
			$t->set_var('newlogo',$phpgw->link("/$app/logoview_image.php"));
			$t->set_var('message',$err) ;
			}
		}
	}

//---- logo Post - PreCommit Routine

    function logo_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	if ($op<>'delete') {
		$imgdir = $ckapi[hostsys][dataarea]."/images" ;
		umask(000) ;
		if (!is_dir($imgdir))	mkdir($imgdir,0700) ;
		$newimg = "/tmp/logo.ck-erp.img" ;
		$fd = fopen($newimg,"r");
		$contents = fread($fd,filesize($newimg)) ;
		fclose($fd) ;
		$logo = "$imgdir/logo.png" ;
		umask(000) ;
		if ($fp = fopen($logo, "w")) {fputs($fp, $contents); fclose($fp);}
		}
	}

    }

?>
