<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: multiled.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-admin' ;
	$tran = 'multiled' ;
	include('../ck-api/ckapi.inc.php') ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-api'));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file('report','index.tpl') ;
	$t->set_block('report','detail','detail_row');
	$t->set_block('report','ack','ack_row');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

$title = lang("Guide to Setting up Multiple Ledger") ;
$t->set_var('lang_caption',$title);
$t->set_var('lang_motto',"");
$msg1 = lang("Multiple ledger is best implemented using the virtual domain feature of phpgroupware.") ;
$msg2 = lang("This feature allows one database to hold one distinct ledger.") ;
$msg3 = lang("Please refer to the guideline below.") ;
$msg4 = lang("If all different ledgers are to be housed within one database and utilize the same Chart of Accounts,") ;
$msg5 = lang("they may be segregated using different values of a single attribute.") ;
$msg6 = lang("However, the relevant attribute's - Keep Value Constant within a single journal - setting will need to be set to (yes).") ;
$msg7 = lang("For detail, please refer to the test data set, which utilizes attribute 1 to segregate the accounting entries of different Funds within a company.") ;
$t->set_var('lang_welcome',"$msg1  $msg2  $msg3<br><br>$msg4 $msg5  $msg6  $msg7");
$t->set_var('lang_user_admin',lang('Steps to implement Virtual Domain'));
$t->set_var('lang_auditor',lang('Command (for Postgresql)'));
$t->set_var('lang_developer',lang('Other Info'));
$user1	= lang("Deploy phpgroupware as usual, making sure the header configuration page have 'Domain select box on login' set to (True)") ;
$user2a	= lang("For phpgroupware 0.9.16 or above, utilize the [Add a domain] feature of the header configuration page to create a virtual domain.") ;
$user2b = lang("For earlier versions of phpgroupware, refer to the guidelines below.") ;
$user2 = "$user2a  $user2b" ;
$user3	= lang("Assume, at this point, primary DB Name is set to 'phpgroupware'") ;
$user4	= lang("Complete other phpgroupware setup/deployment configuration.") ;
$user5a = lang("Edit header.inc.php.") ;
$user5b = lang("Uncomment the 'domain2.com' line and edit the associated data according to your site's setup.") ;
$user5c = lang("Refer to the default domain line as a template.");
$user5  = "$user5a  $user5b  $user5c" ;
$user6  = lang("At command window, log onto the database server.");
$user7  = lang("Create a duplicate of the primary database.");
$user8a = lang("Login as administrator to @default and @HKG individually, to set up 2 separate ledger structures;") ;
$user8b = lang("one kept in database phpgroupware, the other in database hkgledger.") ;
$user8c = lang("Users' access right and/or grouping can be set differently for each of the virtual domain/ledger.");
$user8  = "$user8a $user8b  $user8c" ;
$user9  = lang("Users can then log on @default or @HKG to access the separate ledgers in accordance to their access rights");
$auditor6= "# su -l postgres<br># psql phpgroupware" ;
$auditor7= "create database hkgledger with template=phpgroupware" ;
$developer1  = lang("'Domain select box on login' set to (True)");
$developer5  ='$phpgw_domain[\'HKG\'] = array (<br>';
$developer5 .="'db_host'=>'',<br>" ;
$developer5 .="'db_name'=>'hkgledger',<br>" ;
$developer5 .="'db_user'=>'phpgroupware',<br>" ;
$developer5 .="'db_pass'=>'their_password',<br>" ;
$developer5 .="'db_type'=>'pgsql',<br>" ;
$developer5 .="'config_passwd'=>'changeme'<br>" ;
$developer5 .=");" ;
$developer7 = lang("Name the duplicate database as hkgledger") ;
$developer9  = lang("More ledgers can be produced by creating more virtual domains in header.inc.php and duplicating the primary database");

For ($i=1;$i<=9;$i++) {
	$user='user'.$i;
	$auditor='auditor'.$i;
	$developer='developer'.$i;
	$t->set_var('user',$$user);
	$t->set_var('auditor',"");
	if ($i==5 or $i==6)	$t->set_var('auditor',$$auditor);
	$t->set_var('developer',$$developer);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_row','detail',True);
	}

$t->set_var('lang_ack','');
$t->set_var('ack_row','');
$t->set_var('lang_date','');
$t->set_var('lang_detail','');
$t->set_var('lang_contributor','');

$t->pparse('out','report', true);
ExecMethod('ck-api.process.process_footer') ;

?>

