<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.invoice.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class invoice {

//---- Invoice List SQL Formation

    function invoice_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if ($ckapi[params][tran]=="invoicent")	$where = "amount=netamount $where" ;	else	$where = "amount<>netamount $where";
	$last10 = substr($where,strlen($where)-10,10) ;
	$fields = "transdate,duedate,invnumber,ordnumber,name,isocode,amount,a.id" ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT $fields FROM ${pre}ap a, ${pre}vendor b WHERE $where AND a.vendor=b.id " ;
		$sql2 =	"SELECT $fields FROM ${pre}ap a, ${pre}vendor b, ${pre}p_match c " ;
		$sql2.=	"WHERE $where AND vendor=b.id AND a.id=c.invoiceid " ;
		$sql2.=	"GROUP BY $fields HAVING sum(s_amount)>=amount " ;
		if ($ckapi[hostsys][dbtype]=="mysql")	{
			$user = $ckapi[hostsys][username] ;
			$ckapi[params_sql][temp1] = $temp1 = "${pre}apwtl1".$user.time() ;
			$ckapi[params_sql][temp2] = $temp2 = "${pre}apwtl2".$user.time() ;
			$phpgw->db->query("CREATE TABLE $temp1 AS $sql1");
			$phpgw->db->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* from $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL ORDER BY $order $sort" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	else $sql="SELECT $fields FROM ${pre}ap a,${pre}vendor b WHERE $where AND vendor=b.id ORDER BY $order $sort";
	return $sql ;
	}

//---- Invoice List Link Adjustement

    function invoice_list_adjust() {
	global $ckapi,$phpgw ;

	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	$return = "/$app/${tran}list.php" ;
	$getstr = "id=$dt[id]&filter=$filter&return=$return" ;
	$t->set_var('edit_addtax',$phpgw->link("/$app/invoicewtedit.php",$getstr)) ;
	}

//---- Invoice Data Read

    function invoice_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$script = $ckapi[params_post][script] ;

	$phpgw->db->query("SELECT * FROM $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$dt[taxstatus] = ($tran=="invoicent") ? "e" : $phpgw->db->f('taxincluded') ;
	$dt[oldisocode] = $dt[isocode] ;
	if ($script=="po2invcopy") {
		$dt[transdate] = $dt[duedate] = "" ;
		$dt[ordnumber] = $dt[ponumber] ;
		}
	$table = ($script=="po2invcopy") ? "${pre}oitem" : "${pre}invoice" ;
	$phpgw->db->query("SELECT * FROM $table WHERE trans_id='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['itemid'.$i]		=	$phpgw->db->f('itemid') ;
		$dt['itemtype'.$i]		=	$phpgw->db->f('itemtype') ;
		$dt['description'.$i]		=	$phpgw->db->f('description') ;
		$dt['qty'.$i]=($script=="po2invcopy") ?	$phpgw->db->f('qty') : -$phpgw->db->f('qty') ;
		$dt['unit'.$i]			=	$phpgw->db->f('unit') ;
		$dt['cost'.$i]			=	$phpgw->db->f('cost') ;
		$dt['discount'.$i]		=	$phpgw->db->f('discount') ;
		$dt['inventory_accno_id'.$i]	=	$phpgw->db->f('inventory_accno_id');
		$dt['expense_accno_id'.$i]	=	$phpgw->db->f('expense_accno_id') ;
		$dt['tax1'.$i]			=	$phpgw->db->f('tax1') ;
		$dt['tax2'.$i]			=	$phpgw->db->f('tax2') ;
		$dt['tax1_accno_id'.$i]		=	$phpgw->db->f('tax1_accno_id') ;
		$dt['tax2_accno_id'.$i]		=	$phpgw->db->f('tax2_accno_id') ;
		}
	return $dt ;
	}

//---- Invoice Add Initialisation

    function invoice_add_init() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$dt['transdate'] = date("Y-m-d") ;
	$phpgw->db->query("SELECT nativecurr FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$dt['isocode'] = $dt['oldisocode'] = $phpgw->db->f('nativecurr') ;
	$phpgw->db->query("SELECT exrate FROM ${pre}currency WHERE isocode='$dt[isocode]'");
	$phpgw->db->next_record() ;
	$dt['exrate'] = $phpgw->db->f('exrate') ;
	}

//---- Invoice Detail Validation Checks

    function invoice_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	if ($dt[invnumber]=="")			$err=lang("Invoice Number Missing");
	if (input2date($dt[transdate])=="")	$err=lang("Invalid Invoice Date") ;
	if (input2date($dt[duedate])=="")	$err=lang("Invalid Due Date") ;
	if ($dt[exrate]<=0)			$err=lang("Invalid Exchange Rate") ;
	$phpgw->db->query("SELECT nativecurr FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	if ($dt[isocode]==$phpgw->db->f('nativecurr') and $dt[exrate]<>1)
					$err=lang("Exchange rate for ledger currency must = 1") ;
	$phpgw->db->query("SELECT * FROM ${pre}currency WHERE isocode='$dt[isocode]'");
	$phpgw->db->next_record() ;
	$nativeexrate = $phpgw->db->f('exrate') ;
	if ($nativeexrate>0) {
		$ratio = $dt[exrate]/$nativeexrate ;
		if (0.8>$ratio or $ratio>1.2)	$err=lang("Exchange rate deviates too much from default") ;
		}
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		if ($dt['itemid'.$i]=='')	$err=lang("Item Code Missing") ;
		$row = lang("Row") ; $rowi = "[$row $i]" ;
		if ($dt['qty'.$i] and !is_numeric($dt['qty'.$i]))
					$err=$rowi.lang("Invalid Qty, must be numeric");
		if ($dt['discount'.$i] and !is_numeric($dt['discount'.$i]) and $dt[taxstatus]<>"t")
					$err=$rowi.lang("Invalid Discount, must be numeric");
		if ($dt['cost'.$i] and !is_numeric($dt['cost'.$i]))
					$err=$rowi.lang("Invalid Unit Price, must be numeric");
		if ($dt['tax1'.$i] and !is_numeric($dt['tax1'.$i]))
					$err=$rowi.lang("Invalid Tax1, must be numeric");
		if ($dt['tax2'.$i] and !is_numeric($dt['tax2'.$i]))
					$err=$rowi.lang("Invalid Tax2, must be numeric");
		if (($dt[taxstatus]=="f" or $dt[taxstatus]=="t") and $dt['tax1_pref'.$i]=='')
					$err=$rowi.lang("Blank Choice on Primary Tax Rate");
		if (($dt[taxstatus]=="f" or $dt[taxstatus]=="t") and $dt['tax2_pref'.$i]=='')
					$err=$rowi.lang("Blank Choice on Secondary Tax Rate");
		}
	if ($dt[isocode]<>$dt[oldisocode]) {
		$msg1 = lang('Currency changed') ;
		$msg2 = lang('Default exchange rate loaded') ;
		$msg3 = lang('Ensure pre-existing (discount,price,cost,tax) are still valid') ;
		$msg4 = lang('Click [Post Invoice] to re-activate invoice posting') ;
		$err = "$msg1;  $msg2;  $msg3;  $msg4" ;
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Invoice Header

    function invoice_header_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$script = &$ckapi[params_post][script] ;
	$t = &$ckapi[objects][template] ;

	$phpgw->db->query("SELECT nativecurr FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$loc_for = ($phpgw->db->f('nativecurr')==$dt[isocode]) ? lang('Local') : lang('*** Foreign ***') ;
	$taxstatus = $dt[taxstatus] ;
	$t->set_var('lang_invnumber',lang('Invoice#'));
	$t->set_var('lang_id',lang('Audit Id:'));
	$t->set_var('lang_curr_invoice',lang('Currency Invoice'));
	$t->set_var('lang_loc_for',$loc_for);
	$t->set_var('lang_ordnumber',lang('PO#'));
	$t->set_var('lang_transdate',lang('Invoice Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_vendor',lang('Vendor'));
	$t->set_var('lang_taxstatus',lang('Unit Price Tax Status'));
	$t->set_var('lang_isocode',lang('Currency'));
	$t->set_var('lang_exrate',lang('Exchange Rate'));
	$t->set_var('invnumber',$dt[invnumber]) ;
	$t->set_var('ordnumber',$dt[ordnumber]) ;
	$transdate = $dt[transdate] ;
	$duedate = $dt[duedate] ;
	$vendor = $dt[vendor] ;
	if (!$duedate and $vendor and $transdate) {
		$phpgw->db->query("SELECT * FROM ${pre}vendor WHERE id='$vendor'");
		$phpgw->db->next_record() ;
		$terms=$phpgw->db->f('terms');
		$td = explode("-",$transdate);
		$duedate = $dt[duedate]=date("Y-m-d",mktime(0,0,0,$td[1],$td[2]+$terms,$td[0])) ;
		}
	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('vendor',$vendor) ;
	$t->set_var('vendor_selectlist',vendor_selectlist('',$vendor)) ;
	$optiont = lang('Tax Included') ;
	$optionf = lang('Tax Not Included') ;
	$optione = lang('Tax Exempted') ;
	if ($tran=="invoicent")	$tax_sl = "<OPTION value='e' selected>$optione</OPTION>" ;
	    else {
		$tax_sl = "<OPTION value='t'>$optiont</OPTION>" ;
		$tax_sl.= "<OPTION value='f'>$optionf</OPTION>" ;
		$tax_sl.= "<OPTION value='e'>$optione</OPTION>" ;
		$tax_sl = str_replace("'$taxstatus'","'$taxstatus' selected",$tax_sl) ;
		}
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('isocode_selectlist',isocode_selectlist('',$dt[isocode])) ;
	if ($dt[isocode]<>$dt[oldisocode]) {
		$phpgw->db->query("SELECT exrate FROM ${pre}currency WHERE isocode='$dt[isocode]'");
		$phpgw->db->next_record() ;
		$dt[exrate] = $phpgw->db->f('exrate') ;
		$msg1 = lang('Currency changed') ;
		$msg2 = lang('Default exchange rate loaded') ;
		$msg3 = lang('Ensure pre-existing (discount,price,cost,tax) are still valid') ;
		$t->set_var('message',"$msg1;  $msg2;  $msg3");
		}
	$t->set_var('exrate',$dt[exrate]) ;
	$t->set_var('oldisocode',$dt['isocode']);

	$msg1 = lang("UC - Unit Cost, BTUP - Before Tax Unit Price, my std rate - my standard rate as a customer.");
	$msg2 = lang("Remember to adjust 'Post to Account', if appropriate.");
	$msg3 = lang("To recalculate Due Date, clear the Due Date field and click [Refresh Page].");
	$msg4 = lang("Non-numeric Unit Price and Tax will be converted to zero.");
	$msg5 = lang("If assembly/package is not to be exploded, choose it from the normal Product/Parts or Services sections of the item list.") ;
	$msg6 = lang("If Unit Price includes tax, discount is ignored.") ;
	$msg7 = lang("Posted (Tax Exempted) invoice will appear in the Invoice [no Tax] list.");
	$msg8 = lang("Manual tax input is allowed.");
	$msg9 = lang("However, inaccurate tax may be construed as an attempt to evade tax.");
	$t->set_var('message',"$msg1  $msg2<br>$msg3  <b>$msg4</b><br>$msg5<br>$msg6  $msg7<br><b>$msg8  $msg9</b>");

	$t->parse('out','report',True);
	}

//---- Reformat Invoice Array

    function invoice_transform() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$temp[id] = $dt[id] ;
	$temp[control] = $dt[control] ;
	$temp[vendor] = $dt[vendor] ;
	$temp[transdate] = $dt[transdate] ;
	$temp[duedate] = $dt[duedate] ;
	$temp[invnumber] = $dt[invnumber] ;
	$temp[ordnumber] = $dt[ordnumber] ;
	$temp[taxstatus] = $dt[taxstatus] ;
	$temp[ap_accno_id] = $dt[ap_accno_id] ;
	$temp[isocode] = $dt[isocode] ;
	$temp[oldisocode] = $dt[oldisocode] ;
	$temp[exrate] = $dt[exrate] ;

	if (isset($delete)) {$delrowno = intval(str_replace($row_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$itemid = $dt['itemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($itemid<0)	{
			$itemid = -$itemid ;
			$qty = $dt['qty'.$i]==0 ? 1 : $dt['qty'.$i] ;
			$phpgw->db->query("SELECT * FROM ${pre}assembly WHERE assembly_id='$itemid'");
			while ($phpgw->db->next_record()) {
				$temp['itemid'.$j] = $phpgw->db->f('item_id') ;
				$temp['qty'.$j] = $phpgw->db->f('qty') * $qty ;
				$j++ ;
				}
			continue ;
			}
		$temp['itemid'.$j]		=	$dt['itemid'.$i] ;
		$temp['itemtype'.$j]		=	$dt['itemtype'.$i] ;
		$temp['description'.$j]		=	$dt['description'.$i] ;
		$temp['qty'.$j]			=	$dt['qty'.$i] ;
		$temp['unit'.$j]		=	$dt['unit'.$i] ;
		$temp['cost'.$j]		=	$dt['cost'.$i] ;
		$temp['discount'.$j]		=	$dt['discount'.$i] ;
		$temp['inventory_accno_id'.$j]	=	$dt['inventory_accno_id'.$i] ;
		$temp['expense_accno_id'.$j]	=	$dt['expense_accno_id'.$i] ;
		$temp['dr_accno_id'.$j]		=	$dt['dr_accno_id'.$i] ;
		$temp['tax1_pref'.$j]		=	$dt['tax1_pref'.$i] ;
		$temp['tax2_pref'.$j]		=	$dt['tax2_pref'.$i] ;
		$temp['tax1'.$j]		=	$dt['tax1'.$i] ;
		$temp['tax2'.$j]		=	$dt['tax2'.$i] ;
		$temp['tax1_accno_id'.$j]	=	$dt['tax1_accno_id'.$i] ;
		$temp['tax2_accno_id'.$j]	=	$dt['tax2_accno_id'.$i] ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow)				$temp['itemid'.$j] = "" ;
	$dt = $temp ;
	unset($temp) ;
	}

//---- Write Invoice Detail

    function invoice_detail_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$firstime = $ckapi[params_post][firstime] ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$taxstatus = $dt[taxstatus] ;
	$tax_warning = lang("***** Choice Pending") ;
	if ($op=="view" or $op=="delete")	$posted = True ;
	if ($taxstatus<>'e') {
		$tax_pref_slist = "<OPTION value=''></OPTION>" ;
		$tax_pref_slist.= "<OPTION value='i'>".lang('apply item tax rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='v'>".lang('apply vendor rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='s'>".lang('apply my std rate')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='z'>".lang('tax rate = zero')."</OPTION>" ;
		$tax_pref_slist.= "<OPTION value='m'>".lang('manual tax input')."</OPTION>" ;
		$vendor = ($dt[vendor]=="") ? 0 : $dt[vendor];
		$sql = "SELECT vendor_id,chart_id,rate from ${pre}vendortax a, ${pre}tax b " ;
		$sql.= "WHERE vendor_id='$vendor' and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$vtax1chartid = $phpgw->db->f(chart_id) ;
		$vtax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,chart_id,rate from ${pre}vendortax a, ${pre}tax b " ;
		$sql.= "WHERE vendor_id='$vendor' and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$vtax2chartid = $phpgw->db->f(chart_id) ;
		$vtax2rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,chart_id,rate from ${pre}vendortax a, ${pre}tax b, ${pre}vendor c " ;
		$sql.= "WHERE c.name='zzzzMyself' and vendor_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax1chartid = $phpgw->db->f(chart_id) ;
		$stax1rate = $phpgw->db->f(rate) ;
		$sql = "SELECT vendor_id,chart_id,rate from ${pre}vendortax a, ${pre}tax b, ${pre}vendor c " ;
		$sql.= "WHERE c.name='zzzzMyself' and vendor_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		$stax2chartid = $phpgw->db->f(chart_id) ;
		$stax2rate = $phpgw->db->f(rate) ;
		}
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_number',lang('Item Code -- Id<br>(Inventory/Service)'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_btup',lang('BTUP'));
	$t->set_var('lang_discount',lang('Discount')."<br>$");
	$t->set_var('lang_tax',lang('Tax'));
	$phpgw->db->query("SELECT aptax1cap,aptax2cap,aptax1pref,aptax2pref FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$t->set_var('lang_tax1',$phpgw->db->f(aptax1cap));
	$t->set_var('lang_tax2',$phpgw->db->f(aptax2cap));
	$tax1pref = $phpgw->db->f(aptax1pref) ;
	$tax2pref = $phpgw->db->f(aptax2pref) ;
	$t->set_var('lang_cost',lang('Unit Price'));
	$t->set_var('lang_itemtotal',lang('Item Total'));
	$t->set_var('lang_netamount',lang('Net of Tax'));
	$t->set_var('lang_accno',lang('Post to Account'));
	$t->set_var('lang_delete',lang('Delete<br>Button'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$item_sl = item_selectlist("",'') ;
	$inv_acc_list = account_selectlist("WHERE link like '%IC:%' or link like '%IC'",'') ;
	$exp_acc_list = account_selectlist("WHERE link like '%AP_amount%'",'') ;
	if ($firstime and $ckapi[params][doneexit]=="po2invfilter.php")	$frompo = True ;
	$tax_acc_list = ($frompo) ? "" : account_selectlist("WHERE link like '%AP_tax%'",'') ;
	$sum_tax1 = $sum_tax2 = $sum_itemtotal = $sum_netamount = 0 ;
	For ($i=1;isset($dt['itemid'.$i]);$i++) {
		$t->set_var('itemid_fld','itemid'.$i) ;
		$t->set_var('itemtype_fld','itemtype'.$i) ;
		$t->set_var('description_fld','description'.$i);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('unit_fld','unit'.$i);
		$t->set_var('discount_fld','discount'.$i);
		$t->set_var('cost_fld','cost'.$i);
		$t->set_var('dr_accno_fld','dr_accno_id'.$i);
		$t->set_var('tax1_pref_fld','tax1_pref'.$i);
		$t->set_var('tax2_pref_fld','tax2_pref'.$i);
		$t->set_var('tax1_fld','tax1'.$i);
		$t->set_var('tax2_fld','tax2'.$i);
		$t->set_var('tax1_accno_fld','tax1_accno_id'.$i);
		$t->set_var('tax2_accno_fld','tax2_accno_id'.$i);
		$itemid = $dt['itemid'.$i] ;
		$itemtype = $dt['itemtype'.$i] ;
		$description = $dt['description'.$i] ;
		$unit = $dt['unit'.$i] ;
		$qty = ($itemid<>'' and $dt['qty'.$i]=='') ? 1 : $dt['qty'.$i] ;
		$discount = ($taxstatus=="t") ? "" : $dt['discount'.$i] ;
		$cost = $dt['cost'.$i] ;
		$drid = $dt['dr_accno_id'.$i] ;
		switch ($itemtype) :
			case "s" :	$drid = ($drid) ? $drid : $dt['expense_accno_id'.$i] ; break ;
			case "i" :	$drid = ($drid) ? $drid : $dt['inventory_accno_id'.$i] ; break ;
			case "" :	$drid = ($drid) ? $drid : "" ; break ;
			endswitch ;
		$tax1_pref = ($dt['tax1_pref'.$i] or $posted) ? $dt['tax1_pref'.$i] : $tax1pref ;
		$tax2_pref = ($dt['tax2_pref'.$i] or $posted) ? $dt['tax2_pref'.$i] : $tax2pref ;
		$slist = str_replace("'$tax1_pref'","'$tax1_pref' selected",$tax_pref_slist);
		$t->set_var('tax1_pref_slist',$slist);
		$slist = str_replace("'$tax2_pref'","'$tax2_pref' selected",$tax_pref_slist);
		$t->set_var('tax2_pref_slist',$slist);
		if (($tax1_pref=="" or $tax1_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark1',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark1',"");
		if (($tax2_pref=="" or $tax2_pref==' ') and !$posted and $taxstatus<>'e')
				$t->set_var('lang_taxremark2',"<b>$tax_warning</b>");
			else	$t->set_var('lang_taxremark2',"");
		$tax1 = $dt['tax1'.$i] ;
		$tax2 = $dt['tax2'.$i] ;
		$t1aid = $dt['tax1_accno_id'.$i] ;
		$t2aid = $dt['tax2_accno_id'.$i] ;
		$itemid = ($itemid=="") ? 0 : $itemid ;
		if (!$itemtype or $frompo) {
			$phpgw->db->query("SELECT * FROM ${pre}service WHERE id='$itemid'");
			if ($phpgw->db->next_record()) {
				$drid = $drid<>'' ? $drid : $phpgw->db->f('expense_accno_id');
				$itemtype = "s" ;
				}
			   else {
				$phpgw->db->query("SELECT * FROM ${pre}parts WHERE id='$itemid'");
				if ($phpgw->db->next_record()) {
					$drid = $drid<>'' ? $drid : $phpgw->db->f('inventory_accno_id');
					$itemtype = "i" ;
					}
				}
			$description = $description<>'' ? $description : $phpgw->db->f('description');
			$unit = $unit<>'' ? $unit : $phpgw->db->f('unit');
			$cost = ($cost<>'' or $itemid==0) ? $cost : $phpgw->db->f('cost')/$dt[exrate];
			$cost = number_format($cost,2,".",'') ;
			}
		$t->set_var('itemid',$itemid) ;
		$t->set_var('item_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$item_sl));
		$t->set_var('itemtype',$itemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$unit);
		$t->set_var('qty',$qty);
		$t->set_var('discount',$discount);
		if ($taxstatus=="t" or $posted)	$t->set_var('disc_readonly','readonly');
			else			$t->set_var('disc_readonly','');
		$cost = number_format($cost,2,".",'') ;
		$cost = ($itemid==0) ? "" : $cost ;
		$t->set_var('cost',$cost);
		switch ($itemtype) :
			case "s" :$slist = str_replace("'$drid'","'$drid' selected",$exp_acc_list) ; break ;
			case "i" :$slist = str_replace("'$drid'","'$drid' selected",$inv_acc_list) ; break ;
			case "" :$slist = "." ; break ;
			endswitch ;
		$t->set_var('dr_acc_selectlist',$slist) ;
		switch ($tax1_pref) :
			case "v" :
				$tax1chartid = $vtax1chartid ;
				$tax1rate = $vtax1rate ;
				break ;
			case "s" :
				$tax1chartid = $stax1chartid ;
				$tax1rate = $stax1rate ;
				break ;
			case "i" :
				$sql = "SELECT chart_id,rate from ${pre}itemtax a, ${pre}tax b " ;
				$sql.= "WHERE item_id='$itemid' and tax_id=id and " ;
				$sql.= "taxtype='1' and taxgroup='ap'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax1chartid = $phpgw->db->f(chart_id) ;
				$tax1rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax1rate = 0 ;		break ;
			case "m" :	$tax1rate = 0 ;		break ;
			case " " :	$tax1rate = 0 ;		break ;
			case "" :	$tax1rate = 0 ;		break ;
			endswitch ;
		switch ($tax2_pref) :
			case "v" :
				$tax2chartid = $vtax2chartid ;
				$tax2rate = $vtax2rate ;
				break ;
			case "s" :
				$tax2chartid = $stax2chartid ;
				$tax2rate = $stax2rate ;
				break ;
			case "i" :
				$sql = "SELECT chart_id,rate from ${pre}itemtax a, ${pre}tax b " ;
				$sql.= "WHERE item_id='$itemid' and tax_id=id and " ;
				$sql.= "taxtype='2' and taxgroup='ap'";
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$tax2chartid = $phpgw->db->f(chart_id) ;
				$tax2rate = $phpgw->db->f(rate) ;
				break ;
			case "z" :	$tax2rate = 0 ;		break ;
			case "m" :	$tax2rate = 0 ;		break ;
			case " " :	$tax2rate = 0 ;		break ;
			case "" :	$tax2rate = 0 ;		break ;
			endswitch ;
		switch ($taxstatus) :
			case "f" :
				$t->set_var('btup',$cost);
				$netamount = number_format($qty*$cost-$discount,2,".",'') ;
				$keeptax1=($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ");
				$keeptax2=($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ");
				$tax1 = ($keeptax1) ? $tax1 : $netamount*$tax1rate ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $netamount*$tax2rate ;
				$tax2 = number_format($tax2,2,".",'') ;
				$itemtotal = $netamount + $tax1 + $tax2 ;
				break ;
			case "t" :
				$t->set_var('btup','.');
				$t->set_var('discount','');
				$itemtotal = $taxbase = number_format($qty*$cost,2,".",'') ;
				$keeptax1=($firstime or $tax1_pref=="m" or $tax1_pref=="" or $tax1_pref==" ");
				$keeptax2=($firstime or $tax2_pref=="m" or $tax2_pref=="" or $tax2_pref==" ");
				if ($keeptax1)		$taxbase -= $tax1 ;
				if ($keeptax2)		$taxbase -= $tax2 ;
				$tax1 = ($keeptax1) ? $tax1 : $taxbase*$tax1rate/(1+$tax1rate+$tax2rate) ;
				$tax1 = number_format($tax1,2,".",'') ;
				$tax2 = ($keeptax2) ? $tax2 : $taxbase*$tax2rate/(1+$tax1rate+$tax2rate) ;
				$tax2 = number_format($tax2,2,".",'') ;
				$netamount = $itemtotal - $tax1 - $tax2 ;
				break ;
			case "e" :
				$t->set_var('btup','.');
				$netamount = number_format($qty*$cost-$discount,2,".",'') ;
				$itemtotal = $netamount ;
				$tax1rate = $tax2rate = 0 ;
				$tax1 = $tax2 = 0 ;
				$t1aid = $tax1chartid = $t2aid = $tax2chartid = 0 ;
				break ;
			endswitch ;
		$t1aid = $t1aid=='' ? $tax1chartid : $t1aid ;
		$slist = $tax1==0 ? "" : str_replace("'$t1aid'","'$t1aid' selected",$tax_acc_list) ;
		$t->set_var('tax1_acc_selectlist',$slist);
		$t2aid = $t2aid=='' ? $tax2chartid : $t2aid ;
		$slist = $tax2==0 ? "" : str_replace("'$t2aid'","'$t2aid' selected",$tax_acc_list) ;
		$t->set_var('tax2_acc_selectlist',$slist);
		$sum_tax1 += $tax1 ;
		$sum_tax2 += $tax2 ;
		$sum_itemtotal += $itemtotal ;
		$sum_netamount += $netamount ;
		$t->set_var('tax1',$tax1);
		$t->set_var('tax2',$tax2);
		$t->set_var('itemtotal',$itemtotal);
		$t->set_var('netamount',$netamount);
		if ($posted)	$t->set_var('rowno',"done") ;	else	$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);

		$dt['itemid'.$i] = $itemid ;
		$dt['itemtype'.$i] = $itemtype ;
		$dt['description'.$i] = $description ;
		$dt['qty'.$i] = $qty ;
		$dt['cost'.$i] = $cost ;
		$dt['discount'.$i] = $discount ;
		$dt['unit'.$i] = $unit ;
		$dt['dr_accno_id'.$i] =  $drid ;
		$dt['tax1'.$i] = $tax1 ;
		$dt['tax2'.$i] = $tax2 ;
		$dt['tax1_accno_id'.$i] = $t1aid ;
		$dt['tax2_accno_id'.$i] = $t2aid ;
		$dt['netamount'.$i] = $netamount ;
		}

	$t->set_var('lang_totalnet',lang('Total Tax / Net Amount'));
	$t->set_var('lang_totalap',lang('Total Payable'));
	$t->set_var('sum_tax',number_format($sum_tax1+$sum_tax2,2,".",'')) ;
	$dt[sum_netamount] = number_format($sum_netamount,2,".",'') ;
	$t->set_var('sum_netamount',$dt[sum_netamount]) ;
	$dt[sum_itemtotal] = number_format($sum_itemtotal,2,".",'') ;
	$t->set_var('sum_itemtotal',$dt[sum_itemtotal]) ;
	$ap_acc_list = account_selectlist("WHERE link like '%AP:%' or link like '%AP'",$dt[ap_accno_id]);
	$t->set_var('ap_acc_selectlist',$ap_acc_list) ;
	$t->parse('out','report',True);
	}

//---- Invoice Post Initialisation

    function invoice_post_init() {
	global $ckapi ;

	$tran = $ckapi[params][tran] ;
	$dt = &$ckapi[params_post][dt] ;

	$dt[source] = ($tran=='invoicewt') ? "APWT" : "APNT" ;
	$dt[description] = "AP: Invoice# $dt[invnumber]" ;
	if ($dt[taxstatus]=="e")	$dt[taxstatus] = "f" ;
	$dt[taxincluded] = $dt[taxstatus] ;
	$dt[amount] = $dt[sum_itemtotal] ;
	$dt[netamount] = $dt[sum_netamount] ;
	}

//---- Invoice Post - PreCommit Routine

    function invoice_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$op = &$ckapi[params_post][op] ;
	$t = &$ckapi[objects][template] ;

	if (substr_count($ckapi[params_post][script],'acctran')>0)	{
		$phpgw->db->query("DELETE from ${pre}acc_trans where trans_id='$id'");
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$chart_id	=	$dt['accno'.$i];
			$attrib1	=	$dt['attrib1'.$i] ;
			$attrib2	=	$dt['attrib2'.$i] ;
			$attrib3	=	$dt['attrib3'.$i] ;
			$dr		=	$dt['dr'.$i] ;
			$cr		=	$dt['cr'.$i] ;
			if ($dr==0) $amount=$cr; else $amount=-$dr;
			$attrib1 = ($attrib1=="") ? 0 : $attrib1 ;
			$attrib2 = ($attrib2=="") ? 0 : $attrib2 ;
			$attrib3 = ($attrib3=="") ? 0 : $attrib3 ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id," ;
			$sql.= "attrib1,attrib2,attrib3,amount,transdate)" ;
			$sql.=	"VALUES ('$id','$chart_id'," ;
			$sql.= "'$attrib1','$attrib2','$attrib3','$amount','$dt[transdate]')" ;
			$phpgw->db->query($sql);
			}
		return ;
		}
	$exrate = $dt['exrate'] ;
	$transdate = $dt['transdate'] ;
	if ($op<>'new')	{
		$phpgw->db->query("DELETE from ${pre}invoice where trans_id=$id");
		$phpgw->db->query("DELETE from ${pre}acc_trans where trans_id=$id");
		}
	if ($op<>'delete') {
		$apamount = 0 ;
		For ($i=1;isset($dt['itemid'.$i]);$i++) {
			$itemid		= $dt['itemid'.$i];
			$itemtype	= $dt['itemtype'.$i];
			$desc		= $dt['description'.$i];
			$unit		= $dt['unit'.$i];
			$qty		= $dt['qty'.$i];
			$cost		= $dt['cost'.$i] ;
			$discount	= $dt['discount'.$i];
			$chart_id	= $dt['dr_accno_id'.$i] ;
			$tax1		= number_format($dt['tax1'.$i],2,".",'');
			$tax2		= number_format($dt['tax2'.$i],2,".",'');
			$t1aid		= $dt['tax1_accno_id'.$i] ;
			$t2aid		= $dt['tax2_accno_id'.$i] ;
			$eaid		= ($itemtype=="s") ? $chart_id : "" ;
			$iaid		= ($itemtype=="i") ? $chart_id : "" ;
			$led_netamount	= number_format($dt['netamount'.$i]*$exrate,2,".",'') ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$chart_id','-$led_netamount','$transdate')";
			$phpgw->db->query($sql);
			if ($tax1==0 or $tax1=='')	$led_tax1 = 0.00 ;
			  else	{
				$led_tax1 = number_format($tax1*$exrate,2,".",'') ;
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$t1aid','-$led_tax1','$transdate')" ;
				$phpgw->db->query($sql);
				}
			if ($tax2==0 or $tax2=='')	$led_tax2 = 0.00 ;
			  else	{
				$led_tax2 = number_format($tax2*$exrate,2,".",'') ;
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$t2aid','-$led_tax2','$transdate')" ;
				$phpgw->db->query($sql);
				}
/*			
			if ($tax1<>0 and $tax1<>'') {
				$led_tax1 = number_format($tax1*$exrate,2,".",'') ;
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$t1aid','-$led_tax1','$transdate')" ;
				$phpgw->db->query($sql);
				}
			if ($tax2<>0 and $tax2<>'') {
				$led_tax2 = number_format($tax2*$exrate,2,".",'') ;
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$t2aid','-$led_tax2','$transdate')" ;
				$phpgw->db->query($sql);
				} */
			$iaid = ($iaid=="") ? 0 : $iaid ;
			$eaid = ($eaid=="") ? 0 : $eaid ;
			$t1aid = ($t1aid=="") ? 0 : $t1aid ;
			$t2aid = ($t2aid=="") ? 0 : $t2aid ;
			$sql =	"INSERT INTO ${pre}invoice (trans_id,inventory_accno_id," ;
			$sql.=	"expense_accno_id,itemid,itemtype,description,qty,cost," ;
			$sql.=	"discount,unit,tax1,tax2,tax1_accno_id,tax2_accno_id) " ;
			$sql.=	"VALUES ('$id','$iaid','$eaid','$itemid','$itemtype'," ;
			$sql.=	"'$desc','-$qty','$cost','$discount','$unit'," ;
			$sql.=	"'$tax1','$tax2','$t1aid','$t2aid')" ;
			$phpgw->db->query($sql);
			$apamount += $led_netamount + $led_tax1 + $led_tax2 ;
			}
		$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
		$sql.= "VALUES ('$id','$dt[ap_accno_id]','$apamount','$transdate')";
		$phpgw->db->query($sql);
		}
	if ($op=='delete') {
		$phpgw->db->query("DELETE FROM ${pre}p_match where invoiceid=$id");
		$phpgw->db->query("DELETE from ${pre}ipmatch where invoiceid=$id");
		}
	}

//---- Invnt Accounting Entries Reload (from ap/invoice tables)

    function invoice_reload() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$sql = "SELECT ap_accno_id,taxincluded,amount,exrate FROM ${pre}ap WHERE id='$id'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$apacc = $phpgw->db->f('ap_accno_id') ;
	$taxstatus = $phpgw->db->f('taxincluded') ;
	$exrate = $phpgw->db->f('exrate') ;
	$phpgw->db->query("SELECT * FROM ${pre}invoice WHERE trans_id='$id'") ;
	$apamt = 0 ;
	$i = 1 ;
	while ($phpgw->db->next_record()) {
		$qty	= $phpgw->db->f('qty') ;
		$cost   = $phpgw->db->f('cost') ;
		$discount = $phpgw->db->f('discount') ;
		$tax1	= $phpgw->db->f('tax1') ;
		$tax2	= $phpgw->db->f('tax2') ;
		$inaid	= $phpgw->db->f('inventory_accno_id') ;
		$exaid	= $phpgw->db->f('expense_accno_id') ;
		$t1aid	= $phpgw->db->f('tax1_accno_id') ;
		$t2aid	= $phpgw->db->f('tax2_accno_id') ;
		switch ($taxstatus) :
			case "f" : $netamount = number_format(-$qty*$cost-$discount,2,".",'') ;	break ;
			case "t" : $netamount = number_format(-$qty*$cost,2,".",'') -$tax1 -$tax2; break ;
			case "e" : $netamount = number_format(-$qty*$cost-$discount,2,".",'') ;	break ;
			endswitch ;
		$dt['accno'.$i]=	($inaid<>"" and $inaid<>0) ? $inaid : $exaid ;
		$led_netamount	=	number_format($netamount*$exrate,2,".",'') ;
		$dt['dr'.$i]	=	$led_netamount ;
		$dt['cr'.$i]	= 	"" ;
		$i++ ;
		if ($tax1==0 or $tax1=='')	$led_tax1 = 0.00 ;
		  else	{
			$dt['accno'.$i]	=	$t1aid;
			$led_tax1	=	number_format($tax1*$exrate,2,".",'') ;
			$dt['dr'.$i]	= 	$led_tax1 ;
			$dt['cr'.$i]	= 	"" ;
			$i++ ;
			}
		if ($tax2==0 or $tax2=='')	$led_tax2 = 0.00 ;
		  else	{
			$dt['accno'.$i]	=	$t2aid;
			$led_tax2	=	number_format($tax2*$exrate,2,".",'') ;
			$dt['dr'.$i]	= 	$led_tax2 ;
			$dt['cr'.$i]	= 	"" ;
			$i++ ;
			}
		$apamt += $led_netamount + $led_tax1 + $led_tax2 ;
		}
	$dt['accno'.$i]	=	$apacc;
	$dt['dr'.$i]	= 	"" ;
	$dt['cr'.$i]	= 	sprintf("%01.2f",$apamt) ;
	return $dt ;
	}

//---- Invnt Accounting Entries Accmask Creation

    function invoice_accmask() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("Select ap_accno_id from ${pre}ap where id='$id'");
	$phpgw->db->next_record() ;
	$accmask = $phpgw->db->f('ap_accno_id') ;
	$phpgw->db->query("Select tax1_accno_id,tax2_accno_id from ${pre}invoice where trans_id='$id'");
	while ($phpgw->db->next_record()) {
		$accmask .= ":".$phpgw->db->f('tax1_accno_id').":".$phpgw->db->f('tax2_accno_id') ;
		}
	$ckapi[params_post][accmask] = $accmask ;
	}

    }

?>
