<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ap' ;
	$tran = 'report' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$title = lang("Choose Report to Generate and to set Report Parameters :") ;
	$msg1 = lang('Generation of A/P report requires lengthy processing time.') ;
	$msg2 = lang('You should initiate report generation only during off-peak hours.') ;
	$ckapi[phrases] = array('lang_title'	=> $title ,
				'lang_criteria'	=> lang("Reporting Parameters") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Report Generation") ,
				'lang_add'	=> lang("Return to Index Page") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$note1 = lang("If wrong report chosen, click [Report] to restart.") ;
	$note1a = lang("Press (Start Report Generattion) one more time to start.") ;
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$ckapi[filter][] = array(criteria	=>	lang('Which Report') ,
				type		=>	'select' ,
				selectlist	=>	'' ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	$note1				) ;

	$ckapi[filter][] = array(criteria	=>	lang('Which Vendor') ,
				type		=>	'select' ,
				selectlist	=>	vendor_selectlist('',$vendor) ,
				varname		=>	'vendor' ,
				defval		=>	'' ,
				note		=>	lang('Select the target vendor') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Report Status as of') ,
				type		=>	'input' ,
				varname		=>	'rdate' ,
				defval		=>	'' ,
				note		=>	$dateformat			) ;
				
	$ckapi[filter][] = array(criteria	=>	lang('Date From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	$dateformat			) ;

	$ckapi[filter][] = array(criteria	=>	lang('Date To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	$dateformat			) ;


	$lang_reserved = lang('Reserved') ;
	$report1 = lang('Accounts Payable Aging Report') ;
	$report2 = lang('Vendor Invoice Aging Report') ;
	$report3 = lang('Detail List of Tax Paid') ;
	$report5 = lang('Accounts Payable Audit Control Report') ;

	$ckapi[filter][actlist] = array (	1=>	"<OPTION value='1'>1 -- $report1</OPTION>",
						2=>	"<OPTION value='2'>2 -- $report2</OPTION>",
						3=>	"<OPTION value='3'>3 -- $report3</OPTION>",
						4=>	"<OPTION value='4'>4 -- $lang_reserved</OPTION>",
						5=>	"<OPTION value='5'>5 -- $report5</OPTION>"	) ;
	$ckapi[filter][actstring] = array(	"0",	/* initial entry	*/
						"02",	/* report 1	*/
						"012",	/* report 2	*/
						"034",	/* report 3	*/
						"0",	/* report 4	*/
						"02"	/* report 5	*/			) ;
	if ($_POST[actnum]<>"")	$ckapi[filter][0][note] = $note1a ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
