<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ckapi.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

	global $ckapi,$phpgw,$phpgw_info;
	
	$phpgw_info["flags"]["currentapp"] = $app ;
	$phpgw_info["flags"]["enable_nextmatchs_class"] = True ;
	if ($disable_nm)	$phpgw_info["flags"]["enable_nextmatchs_class"] = False ;
	if ($enable_vfs)	$phpgw_info["flags"]["enable_vfs_class"] = True ;
	if ($noheader)		$phpgw_info["flags"]["noheader"] = True ;
	if ($nonavbar)		$phpgw_info["flags"]["nonavbar"] = True ;
	$pre = $ckapi['params']['pre'] = 'ck_' ;	
	/* CK-ERP table prefix; do not change this unless you are absolutely sure you know what you are doing */

	include_once('../header.inc.php');

	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$informsa = lang("Please inform System Admin") ;
	if ($id<>"" and ereg('[^0-9]',$id)) {
		$sqlattack = lang("Possible SQL injection attack") ;
		echo "$informsa:  $sqlattack [id->$id]" ;
		exit() ;
		}

	foreach ($_GET as $key => $value)	$_GET[$key] = strip_tags($value) ;
	if ($app<>'ck-bank' and $tran<>'ledger')	
		foreach ($_POST as $key => $value)	$_POST[$key] = strip_tags($value) ;
	
	list($dummy,$scriptdotphp) = explode("/$app/",$_SERVER["PHP_SELF"]) ;
	list($script,$dummy) = explode(".",$scriptdotphp) ;
	list($dummy,$op) = explode($tran,$script) ;
	$ckapi[params_post] = array('script'=>$script, 'op'=>$op) ;

	list($ver1,$ver2,$ver3) = explode(".",phpversion()) ;
	if ($ver1>4 or ($ver1==4 and $ver2>=2)) {
		$skiplist = "adminfilter,adminfilter_validate,admindelete,adminsetup,adminmd5," ;
		$skiplist.= "admininstest,admininsprod," ;
		$skiplist.= "developfilter,developfilter_validate,restore" ;
		if (substr_count($skiplist,$script)<=0) {
			$checksum = md5_file($_SERVER["SCRIPT_FILENAME"]) ;
			$phpgw->db->query("SELECT checksum FROM ${pre}md5 WHERE script='/$app/$scriptdotphp'") ;
			$phpgw->db->next_record() ;
			if ($checksum<>$phpgw->db->f('checksum')) {
				$failure = lang("MD5 checksum failure") ;
				echo "$informsa:  /$app/$scriptdotphp $failure" ;
				exit() ;
				}
			}
		}
	$ckapi[hostsys][username] = trim($phpgw_info["user"]["userid"]);
	$ckapi[hostsys][dbtype] = $dbtype = $phpgw_info["server"]["db_type"] ;
	if (substr_count("mysql,pgsql",$dbtype)<=0)	{echo "Database engine not supported"; exit();}
	$ckapi[hostsys][dataarea] = $phpgw_info["server"]["files_dir"] ;
	$ckapi[hostsys][th_bg] = $phpgw_info['theme']['th_bg'] ;
	$ckapi[hostsys][tr_color1] = $phpgw_info['theme']['row_on'] ;
	$ckapi[hostsys][tr_color2] = $phpgw_info['theme']['row_off'] ;

?>
