<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter_validate.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ar' ;
	$tran = 'report' ;
	$noheader = $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$pass2 = ($_GET["pass2"]) ? $_GET["pass2"] : $_POST["pass2"] ;
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$actnum = ($_GET["actnum"]) ? $_GET["actnum"] : $_POST["actnum"] ;
	$customer = ($_GET["customer"]) ? $_GET["customer"] : $_POST["customer"] ;
	$rdate = ($_GET["rdate"]) ? $_GET["rdate"] : $_POST["rdate"] ;
	$datefrom = ($_GET["datefrom"]) ? $_GET["datefrom"] : $_POST["datefrom"] ;
	$dateto = ($_GET["dateto"]) ? $_GET["dateto"] : $_POST["dateto"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	$err="";  $error = lang("Error") ;
	$phpgw->db->query("SELECT sum(amount) as amount FROM ${pre}acc_trans");
	$phpgw->db->next_record() ;
	$net = sprintf("%01.2f",$phpgw->db->f('amount')) ;
	if ($net<>0)		$err=lang("Dr/Cr Imbalance detected.  Pls inform System Admin immediately.") ;

	if ($rdate) {
		$date=input2date($rdate) ;
		if ($date=="")	$err=lang("Invalid Report Status Date");	else	$rdate = $date ;
		}
	    else	$rdate=date("Y-m-d") ;
	if ($datefrom) {
		$date=input2date($datefrom) ;
		if ($date=="")	$err=lang("Invalid Date From");			else	$datefrom = $date ;
		}
	if ($dateto) {
		$date=input2date($dateto) ;
		if ($date=="")	$err=lang("Invalid Date To");			else	$dateto = $date ;
		}
	if ($actnum==4)			$err="Report# $actnum is reserved for future use" ;
	if ($actnum<1 or $actnum>5)	$err="Invalid Report Number" ;
	if ($actnum=='')		$err="You have choosen a blank line" ;
	
	if ($err)			$err="<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)	{
		switch ($actnum) {
			case 1:
				$param_list = "repdate=$rdate" ;
				Header('Location: '.$phpgw->link("/$app/araging.php","$param_list"));
				$phpgw->common->phpgw_exit();
			case 2:
				$param_list = "repdate=$rdate&customer=$customer" ;
				Header('Location: '.$phpgw->link("/$app/invoiceaging.php","$param_list"));
				$phpgw->common->phpgw_exit();
			case 3:
				$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
				if ($datefrom)		$filter.= "${markpri}2transdate${marksec}${datefrom}" ;
				if ($dateto)		$filter.= "${markpri}4transdate${marksec}${dateto}" ;
				$filter =urlencode($filter) ;
				Header('Location: '.$phpgw->link("/$app/taxcollectlist.php","filter=$filter"));
				$phpgw->common->phpgw_exit();
			case 5:
				$param_list = "repdate=$rdate" ;
				Header('Location: '.$phpgw->link("/$app/controlreport.php","$param_list"));
				$phpgw->common->phpgw_exit();
			default:
				echo "Should not be here.  Weird Report Number" ;
			}
		}
	else
		{
		$getstr = "actnum=$actnum&customer=$customer&rdate=$rdate&" ;
		$getstr.= "datefrom=$datefrom&dateto=$dateto&err=$err" ;
		Header('Location: '.$phpgw->link("/$app/${tran}filter.php",$getstr));
		$phpgw->common->phpgw_exit();
		}

?>
