<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ledgerbulk.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-bank' ;
	$tran = 'ledger' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$status = ($_GET["status"]) ? $_GET["status"] : $_POST["status"] ;
	foreach ($_POST as $key => $value)	$_POST[$key] = strip_tags($value) ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$delete = ($_GET["delete"]) ? $_GET["delete"] : $_POST["delete"] ;

	$filter = urldecode(stripslashes($filter)) ;
	$proc = CreateObject('ck-api.process') ;
	$where = $proc->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$ckapi[params][table] = "${pre}bkr_trans" ;
	$proc = CreateObject('ck-api.process') ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('question','confirm.tpl');
	$t->set_file(array('report'=>"${tran}bulk.tpl",  'ledgers'=>"${tran}bulk.tpl"));
	$t->set_block('ledgers','ledger_row','ledger_section');
	$db_type = $ckapi[hostsys][dbtype] ;
	$float = ($db_type=="mysql") ? "double" : "float" ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_bankac',lang('Bank Account'));
list($dummy,$chart_id) = explode("'",$where) ;
$phpgw->db->query("SELECT accno,description FROM ${pre}chart WHERE id='$chart_id'");
$phpgw->db->next_record() ;
$bankac = $phpgw->db->f('accno')."--".$phpgw->db->f('description') ;
$t->set_var('bankac',$bankac);
$t->set_var('message',"");

$t->set_var('lang_post',lang('Post Bulk Update'));
$t->set_var('lang_delete',lang('Delete (non-blank) items'));
$getstr = "filter=$filter&sort=$sort&order=$order" ;
$t->set_var('post_action',$phpgw->link("/$app/${tran}bulk.php",$getstr));

if (isset($post) or isset($delete)) {
	$user = $ckapi[hostsys][username];
	$lockwhere = "WHERE resource='bankledgerbulk'" ;
	$phpgw->db->query("SELECT * FROM ${pre}resourcelock $lockwhere");
	$phpgw->db->next_record() ;
	$used_by = $phpgw->db->Record['used_by'] ;
	if ($used_by=="")	$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' $lockwhere");
	  else	{
	  	$err = lang("Bank Rec. Ledger Item [Bulk] Update/Edit/Delete is being accessed by ").$used_by;
		$t->set_var('message',"<b>".lang("Error").":  $err") ;
		$t->set_var('lang_post',lang('Done - Error'));
		$t->set_var('lang_delete',lang('Done - Error'));
		$t->set_var('post_action',$phpgw->link("/$app/${tran}list.php",$getstr));
		}
	}
$phpgw->db->query("SELECT * FROM ${pre}resourcelock $lockwhere");
$phpgw->db->next_record() ;
$used_by = $phpgw->db->Record['used_by'] ;
if ((isset($post) or isset($delete)) and $err=="") {
	$ip = ($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
	$user = $ckapi[hostsys][username];
	$now = mktime() ;
	$op = (isset($post)) ? 'edit' : 'delete' ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	if (isset($post)) {
		foreach ($status as $key => $value) {
			$iptime = "$ip=$now=$script=$key" ;
			$sql = "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
			$sql.= "VALUES ('$key','$app','$script','$ip','$user','$op','$now','$iptime')" ;
			$phpgw->db->query($sql);
			$phpgw->db->query("SELECT id from ${pre}log WHERE iptime='$iptime'");
			$phpgw->db->next_record();
			$logid = $phpgw->db->f('id');
			$sql = "UPDATE ${pre}bkr_trans SET status='$value',control=control+1 " ;
			$sql.= "WHERE trans_id=$key";
			$phpgw->db->query($sql);
			$ckapi[params_post][id] = $key ;
			$ckapi[params_post][logid] = $logid ;
			$proc->update_log_header() ;
			}
		$t->set_var('lang_post',lang('Done - Bulk Update Posted'));
		$t->set_var('lang_delete',lang('Done'));
		}
	if (isset($delete)) {
		foreach ($status as $key => $value) {
			$iptime = "$ip=$now=$script=$key" ;
			$sql = "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
			$sql.= "VALUES ('$key','$app','$script','$ip','$user','$op','$now','$iptime')" ;
			$phpgw->db->query($sql);
			$phpgw->db->query("SELECT id from ${pre}log WHERE iptime='$iptime'");
			$phpgw->db->next_record();
			$logid = $phpgw->db->f('id');
			$ckapi[params_post][id] = $key ;
			$ckapi[params_post][logid] = $logid ;
			$proc->update_log_header() ;
			$phpgw->db->query("DELETE FROM ${pre}bkr_trans WHERE trans_id=$key");
			}
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('lang_delete',lang('Done - Items deleted'));
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t->set_var('post_action',$phpgw->link("/$app/${tran}list.php",$getstr));
	$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='bankledgerbulk'");
	}
$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
$tr_color2 = $ckapi[hostsys][tr_color2] ;
$t->set_var('lang_title',lang('List of Ledger Items'));
$t->set_var('lang_sorthead','');
$t->set_var('lang_status',lang('Cheque/Item Status'));
$t->set_var('lang_transdate',lang('ledger Date'));
$t->set_var('lang_source',lang('Source'));
$t->set_var('lang_description',lang('Description'));
$t->set_var('lang_refnumber',lang('Ref Number'));
$t->set_var('lang_cheque',lang('Cheque'));
$t->set_var('lang_amount',lang('Amount<br>(Dr being +ve)'));
$t->set_var('lang_cleared',lang('Cleared'));
$t->set_var('lang_stopped',lang('Stopped'));
$t->set_var('lang_neither',lang('Neither'));
$t->set_var('lang_id',lang('Audit Id'));

if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$sql =  "SELECT * FROM ${pre}bkr_trans " ;
$sql.=	"WHERE substring(source,1,2)<>'SI' and substring(source,1,2)<>'SU' $where ORDER BY ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array('transdate'	=> lang("No Matching Item Found"),
			'source'	=> "",
			'description'	=> "",
			'refnumber'	=> "",
			'cheque'	=> "",
			'amount'	=> "",
			'id'		=> ""			)) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('ledger_section','ledger_row',True);
	}
while ($phpgw->db->next_record()) {
	$id	= $phpgw->db->f('id') ;
	$cchecked = ($phpgw->db->f('status')=="c") ? 'checked' : '' ;
	$schecked = ($phpgw->db->f('status')=="s") ? 'checked' : '' ;
	$nchecked = ($phpgw->db->f('status')=="") ? 'checked' : '' ;
	$t->set_var(array(
		'transdate'	=> $phpgw->db->f('transdate'),
		'source'	=> $phpgw->db->f('source'),
		'description'=> $phpgw->db->f('description'),
		'refnumber'=> $phpgw->db->f('refnumber'),
		'cheque'	=> $phpgw->db->f('cheque'),
		'amount'	=> $phpgw->db->f('amount'),
		'cchecked'	=> $cchecked,
		'schecked'	=> $schecked,
		'nchecked'	=> $nchecked,
		'id'		=> $id					));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('ledger_section','ledger_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','ledgers','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
