<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: worksheetfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-bank' ;
	$tran = 'worksheet' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"			) ;
	$ckapi[phrases] = array('lang_title'	=> lang('Enter Reconciliation Worksheet Parameters :'),
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Worksheet Generation") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

$bankac_sl = account_selectlist("WHERE (link like '%AP_paid%' or link like '%AR_paid%') and category='A'",'');
	$ckapi[filter][] = array(criteria	=>	lang('Bank Account') ,
				type		=>	'select' ,
				selectlist	=>	$bankac_sl ,
				varname		=>	'chart_id' ,
				defval		=>	"" ,
				note		=>	lang('Select the appropriate bank account'));

	$ckapi[filter][] = array(criteria	=>	lang('Reconciliation Period from') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Reconciliation Period to') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Beginning Bank Statement Balance') ,
				type		=>	'input' ,
				varname		=>	'beginbal' ,
				defval		=>	"" ,
				note		=>	lang('Must be a number') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Ending Bank Statement Balance') ,
				type		=>	'input' ,
				varname		=>	'endbal' ,
				defval		=>	"" ,
				note		=>	lang('Must be a number'));

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
