<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.cttcode.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class cttcode {

//---- Contact Code Detail Validation Checks

    function cttcode_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	$maxname = 10 ;
	$maxdesc = 40 ;
	$desc = $dt[description] ;
	if ($dt[name]=="")			$err = lang("Contact Code name Missing") ;
	   else if (strlen($dt[name])>$maxname)	$err = lang("Contact Code name too long") ;
	if ($desc=="")				$err = lang("Contact Code description Missing") ;
	   else if (strlen($desc)>$maxdesc)	$err = lang("Contact Code description too long") ;
	if ($dt[type]<>$dt[oldtype] or $dt[name]<>$dt[oldname]) {
		$sql = "SELECT * from ${pre}cttcode where type='$dt[type]' and name='$dt[name]'";
		$phpgw->db->query($sql);
		if ($phpgw->db->num_rows()>0)	$err = lang("Type/Name Combo already exists") ;
		}
	if ($dt[type]<>$dt[lasttype]) {
		$warn1 = lang("Contact Code Type had just been updated.") ;
		$warn2 = lang("Ensure other data are appropriately adjusted and updated.") ;
		$warn3 = lang("Then re-click [Update ...] button")  ;
		$err = "$warn1<br>$warn2  $warn3" ;
		}
	if ($dt[catid]=="")	$dt[catid]=0 ;
	
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Contact Code Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$allow = $dt[allowdelete] ;
	if ($allow<>"y" and $allow<>"Y")	$err = lang("Contact Code flagged deletion not allowed");
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Contact Code Detail

    function cttcode_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$noyes_sl = "<OPTION value='n'>".lang('No')."</OPTION>" ;
	$noyes_sl.= "<OPTION value='y'>".lang('Yes')."</OPTION>" ;
	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_type',lang('Contact Code Type'));
	$t->set_var('lang_category',lang('Contact Category'));
	$t->set_var('lang_name',lang('Contact Code Name'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_adelete',lang('Allow Delete'));
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('app',$ckapi[params][app]);
	$t->set_var('type_selectlist',cttcodetype_selectlist('',$dt[type]));
	$t->set_var('catid_selectlist',categoryid_selectlist("WHERE type='$dt[type]'",$dt[catid]));
	$t->set_var('oldtype',$dt[oldtype]);
	$t->set_var('name',$dt[name]);
	$t->set_var('oldname',$dt[oldname]);
	$t->set_var('description',$dt[description]);
	$ad_sl = str_replace("'$dt[allowdelete]'","'$dt[allowdelete]' selected",$noyes_sl) ;
	$t->set_var('adelete_selectlist',$ad_sl);
	$t->set_var("lasttype",$dt[type]);
	$t->parse('out','report',True);
	}

    }

?>
