<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.personperson.inc.php,v 0.8.1 2004/06/30 C K Wu $ */

    class personperson {

//---- Personperson Read

    function personperson_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * FROM ${pre}person WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$dt[name] = $dt[prsnumber] ;
	$phpgw->db->query("SELECT * FROM ${pre}person_person where contactid='$id' order by personcode");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['preferred'.$i]	=	$phpgw->db->f('preferred') ;
		$dt['personid'.$i]	=	$phpgw->db->f('personid') ;
		$dt['personcode'.$i]	=	$phpgw->db->f('personcode') ;
		}
	return $dt;
	}

//---- Personperson Validation Checks

    function personperson_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error = lang("Error") ;
	$row = lang("Row") ;
	$pr = "" ;
	For ($i=1;isset($dt['personcode'.$i]);$i++) {
		if ($dt[id]==$dt['personid'.$i])	$err="[$row $i]".lang("Contact Person and related person cannot be the same") ; 
		if ($dt['preferred'.$i]=='y')
			if ($pr<>"")	$err="[$row $i]".lang("More than one [preferred] related person");	else $pr="1";
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Personperson Header

    function personperson_header_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$t->set_var('lang_name',lang('Person Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->parse('out','report',True);
	}

//---- Write Personperson Detail

    function personperson_detail_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = lang('Row')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_personid',lang('Related Person'));
	$t->set_var('lang_personcode',lang("Person Code -- Description") );
	$t->set_var('lang_preferred',lang('Preferred'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_reserved',lang('Reserved Space'));
	$blankopt = "<OPTION value=''></OPTION>" ;
	$lang_person = strtolower(lang('person')) ;
	$lang_no = lang("no") ;
	$lang_yes = lang("yes") ;
	$preferred_sl = "<OPTION value='n'>n -- $lang_no</OPTION><OPTION value='y'>y -- $lang_yes</OPTION>" ;
	$personid_sl = personname_selectlist("",'',"long") ;
	$personcode_sl = categoryname_selectlist("WHERE type='$lang_person'",'') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['personcode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('personid_fld','personid'.$i) ;
			$t->set_var('personcode_fld','personcode'.$i) ;
			$t->set_var('preferred_fld','preferred'.$i) ;
			$t->set_var('personid_selectlist',$personid_sl) ;
			$t->set_var('personcode_selectlist',$personcode_sl) ;
			$t->set_var('preferred_selectlist',$preferred_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$personid	= $dt['personid'.$i] ;
		$personcode	= $dt['personcode'.$i] ;
		$preferred	= $dt['preferred'.$i] ;
		$t->set_var('personid_fld','personid'.$j) ;
		$t->set_var('personcode_fld','personcode'.$j) ;
		$t->set_var('preferred_fld','preferred'.$j) ;
		
		$t->set_var('personid_selectlist',str_replace("'$personid'","'$personid' selected",$personid_sl)) ;
		$t->set_var('personcode_selectlist',str_replace("'$personcode'","'$personcode' selected",$personcode_sl)) ;
		$t->set_var('preferred_selectlist',str_replace("'$preferred'","'$preferred' selected",$preferred_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;  else  $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',"done") ;  else  $t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('personid_fld','personid'.$i) ;
		$t->set_var('personcode_fld','personcode'.$i) ;
		$t->set_var('preferred_fld','preferred'.$i) ;
		$t->set_var('personid_selectlist',$personid_sl) ;
		$t->set_var('personcode_selectlist',$personcode_sl) ;
		$t->set_var('preferred_selectlist',$preferred_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->parse('out','report',True);
	}

//---- Personperson Post - PreCommit Routine

    function personperson_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')	$phpgw->db->query("DELETE from ${pre}person_person where contactid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['personcode'.$i]);$i++) {
			$personid = $dt['personid'.$i] ;
			$personcode = $dt['personcode'.$i] ;
			$preferred = $dt['preferred'.$i] ;
			$sql = "INSERT INTO ${pre}person_person (contactid,personid,personcode,preferred) " ;
			$sql.= "VALUES ('$id','$personid','$personcode','$preferred')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>

