<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: balancesheet.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-css' ;
	$tran = 'balancesheet' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$this_period = ($_GET["this_period"]) ? $_GET["this_period"] : $_POST["this_period"] ;
	$last_period = ($_GET["last_period"]) ? $_GET["last_period"] : $_POST["last_period"] ;
	$attrib1 = ($_GET["attrib1"]) ? $_GET["attrib1"] : $_POST["attrib1"] ;
	$attrib2 = ($_GET["attrib2"]) ? $_GET["attrib2"] : $_POST["attrib2"] ;
	$attrib3 = ($_GET["attrib3"]) ? $_GET["attrib3"] : $_POST["attrib3"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report','balancesheet.tpl') ;
	$t->set_block('report','asset_row', 'asset_section') ;
	$t->set_block('report','liab_row','liab_section') ;
	$t->set_block('report','equity_row','equity_section') ;

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_balance_sheet', lang('BALANCE SHEET'));
	if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
		$phpgw->db->query("Select * from ${pre}defaults");
		$phpgw->db->next_record();
		$a1cap = $phpgw->db->f('attrib1cap');	$a1tbl = $phpgw->db->f('attrib1tbl');	$a1ldf = $phpgw->db->f('attrib1ldesc');
		$a2cap = $phpgw->db->f('attrib2cap');	$a2tbl = $phpgw->db->f('attrib2tbl');	$a2ldf = $phpgw->db->f('attrib2ldesc');
		$a3cap = $phpgw->db->f('attrib3cap');	$a3tbl = $phpgw->db->f('attrib3tbl');	$a3ldf = $phpgw->db->f('attrib3ldesc');
		if ($attrib1<>'') {
			$phpgw->db->query("Select * from $a1tbl where id=$attrib1"); $phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a1ldf") ;
			$t->set_var('attrib1line',"$a1cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib1line',"");
		if ($attrib2<>'') {
			$phpgw->db->query("Select * from $a2tbl where id=$attrib2"); $phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a2ldf") ;
			$t->set_var('attrib2line',"$a2cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib2line',"");
		if ($attrib3<>'') {
			$phpgw->db->query("Select * from $a3tbl where id=$attrib3"); $phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a3ldf") ;
			$t->set_var('attrib3line',"$a3cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib3line',"");
		}
	   else {
		$t->set_var('attrib1line',"");
		$t->set_var('attrib2line',"");
		$t->set_var('attrib3line',"");
		}
	$t->set_var('lang_assets', lang('ASSETS'));
	$t->set_var('lang_total_assets', lang('TOTAL ASSETS'));
	$t->set_var('lang_liab', lang('LIABILITIES'));
	$t->set_var('lang_total_liab', lang('Total Liabilities'));
	$t->set_var('lang_share_equity', lang("SHAREHOLDER'S EQUITY"));
	$t->set_var('lang_total_equity', lang('Total Equity'));
	$t->set_var('lang_total_liab_equity', lang('TOTAL LIABILITIES & EQUITY'));
	$t->set_var('this_period',$this_period);
	$t->set_var('last_period',$last_period);

/*-----------------Write Asset Section----------------------------------------------*/

$user = $ckapi[hostsys][username];
$temp1 = "${pre}gl1".$user.time() ;
$temp2 = "${pre}gl2".$user.time() ;
$temp3 = "${pre}gl3".$user.time() ;

$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT accno,description,sum(amount) as this_period, 0.00 as last_period " ;
$sql.=	"FROM ${pre}acc_trans a, ${pre}chart b " ;
$sql.=	"WHERE transdate<='$this_period' and category='A' and a.chart_id=b.id " ;
if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
$sql.=	"GROUP BY accno,description ORDER BY accno" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp3 AS " ;
$sql.=	"SELECT accno,description, 0.00 as this_period, sum(amount) as last_period " ;
$sql.=	"FROM ${pre}acc_trans a, ${pre}chart b " ;
$sql.=	"WHERE transdate<='$last_period' and category='A' and a.chart_id=b.id " ;
if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
$sql.=	"GROUP BY accno,description ORDER BY accno" ;
$phpgw->db->query($sql);
$phpgw->db->query("INSERT INTO $temp2 (accno,description,this_period,last_period) SELECT * FROM $temp3");
$sql =  "CREATE TABLE $temp1 AS " .
	"SELECT description, sum(this_period) as this_period, sum(last_period) as last_period " .
		"from $temp2 group by accno, description order by accno" ;
$phpgw->db->query($sql);
$phpgw->db->query("SELECT * from $temp1");
if ($phpgw->db->num_rows()==0) {
	$t->set_var('asset_account','') ;
	$t->set_var('asset_this_period','-') ;
	$t->set_var('asset_last_period','-') ;
	$t->parse('asset_section','asset_row',true);
	}
$thisperiod_total = 0;
$lastperiod_total = 0;
while ($phpgw->db->next_record()) {
	$account_name		= $phpgw->db->f('description');
	$this_period_amount	= sprintf("%01.2f",-$phpgw->db->f('this_period'));
	$last_period_amount	= sprintf("%01.2f",-$phpgw->db->f('last_period'));
	$thisperiod_total	+=$this_period_amount ;
	$lastperiod_total	+=$last_period_amount ;
	$t->set_var('asset_account',$account_name) ;
	if ($this_period_amount==0) {$this_period_amount='-'; }
	if ($last_period_amount==0) {$last_period_amount='-'; }
	$t->set_var('asset_this_period',$this_period_amount) ;
	$t->set_var('asset_last_period',$last_period_amount) ;
	$t->parse('asset_section','asset_row',true);
	}
$t->set_var('total_assets_this_period',sprintf("%01.2f",$thisperiod_total)) ;
$t->set_var('total_assets_last_period',sprintf("%01.2f",$lastperiod_total)) ;
$total_assets_this_period = $thisperiod_total ;
$total_assets_last_period = $lastperiod_total ;

$phpgw->db->query("DROP TABLE $temp1");
$phpgw->db->query("DROP TABLE $temp2");
$phpgw->db->query("DROP TABLE $temp3");

/*--------------------Write Liability Section------------------------------------------*/

$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT accno,description,sum(amount) as this_period, 0.00 as last_period " ;
$sql.=	"FROM ${pre}acc_trans a, ${pre}chart b " ;
$sql.=	"WHERE transdate<='$this_period' and category='L' and a.chart_id=b.id " ;
if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
$sql.=	"GROUP BY accno,description ORDER BY accno" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp3 AS " ;
$sql.=	"SELECT accno,description, 0.00 as this_period, sum(amount) as last_period " ;
$sql.=	"FROM ${pre}acc_trans a, ${pre}chart b " ;
$sql.=	"WHERE transdate<='$last_period' and category='L' and a.chart_id=b.id " ;
if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
$sql.=	"GROUP BY accno,description ORDER BY accno" ;
$phpgw->db->query($sql);
$phpgw->db->query("INSERT INTO $temp2 (accno,description,this_period,last_period) SELECT * FROM $temp3");
$sql =  "CREATE TABLE $temp1 AS " .
	"SELECT description, sum(this_period) as this_period, sum(last_period) as last_period " .
		"from $temp2 group by accno, description order by accno" ;
$phpgw->db->query($sql);
$phpgw->db->query("SELECT * from $temp1");
if ($phpgw->db->num_rows()==0) {
	$t->set_var('liab_account','') ;
	$t->set_var('liab_this_period','-') ;
	$t->set_var('liab_last_period','-') ;
	$t->parse('liab_section','liab_row',true);
	}
$thisperiod_total = 0;
$lastperiod_total = 0;
while ($phpgw->db->next_record()) {
	$account_name		= $phpgw->db->f('description');
	$this_period_amount	= sprintf("%01.2f",$phpgw->db->f('this_period'));
	$last_period_amount	= sprintf("%01.2f",$phpgw->db->f('last_period'));
	$thisperiod_total	+=$this_period_amount ;
	$lastperiod_total	+=$last_period_amount ;
	$t->set_var('liab_account',$account_name) ;
	if ($this_period_amount==0) {$this_period_amount='-'; }
	if ($last_period_amount==0) {$last_period_amount='-'; }
	$t->set_var('liab_this_period',$this_period_amount) ;
	$t->set_var('liab_last_period',$last_period_amount) ;
	$t->parse('liab_section','liab_row',true);
	}
$t->set_var('total_liab_this_period',sprintf("%01.2f",$thisperiod_total)) ;
$t->set_var('total_liab_last_period',sprintf("%01.2f",$lastperiod_total)) ;
$total_liab_this_period = $thisperiod_total ;
$total_liab_last_period = $lastperiod_total ;

$phpgw->db->query("DROP TABLE $temp1");
$phpgw->db->query("DROP TABLE $temp2");
$phpgw->db->query("DROP TABLE $temp3");

/*--------------------Write Equity Section------------------------------------------*/

$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT accno,description,sum(amount) as this_period, 0.00 as last_period " ;
$sql.=	"FROM ${pre}acc_trans a, ${pre}chart b " ;
$sql.=	"WHERE transdate<='$this_period' and category='Q' and a.chart_id=b.id " ;
if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
$sql.=	"GROUP BY accno,description ORDER BY accno" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp3 AS " ;
$sql.=	"SELECT accno,description, 0.00 as this_period, sum(amount) as last_period " ;
$sql.=	"FROM ${pre}acc_trans a, ${pre}chart b " ;
$sql.=	"WHERE transdate<='$last_period' and category='Q' and a.chart_id=b.id " ;
if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
$sql.=	"GROUP BY accno,description ORDER BY accno" ;
$phpgw->db->query($sql);
$phpgw->db->query("INSERT INTO $temp2 (accno,description,this_period,last_period) SELECT * FROM $temp3");
$sql =  "CREATE TABLE $temp1 AS " .
	"SELECT description, sum(this_period) as this_period, sum(last_period) as last_period " .
		"from $temp2 group by accno, description order by accno" ;
$phpgw->db->query($sql);
$phpgw->db->query("SELECT * from $temp1");
if ($phpgw->db->num_rows()==0) {
	$t->set_var('equity_account','') ;
	$t->set_var('equity_this_period','-') ;
	$t->set_var('equity_last_period','-') ;
	$t->parse('equity_section','equity_row',true);
	}
$thisperiod_total = 0;
$lastperiod_total = 0;
while ($phpgw->db->next_record()) {
	$account_name		= $phpgw->db->f('description');
	$this_period_amount	= sprintf("%01.2f",$phpgw->db->f('this_period'));
	$last_period_amount	= sprintf("%01.2f",$phpgw->db->f('last_period'));
	$thisperiod_total	+=$this_period_amount ;
	$lastperiod_total	+=$last_period_amount ;
	$t->set_var('equity_account',$account_name) ;
	if ($this_period_amount==0) {$this_period_amount='-'; }
	if ($last_period_amount==0) {$last_period_amount='-'; }
	$t->set_var('equity_this_period',$this_period_amount) ;
	$t->set_var('equity_last_period',$last_period_amount) ;
	$t->parse('equity_section','equity_row',true);
	}
$ie_thisperiod = sprintf("%01.2f",$total_assets_this_period - $total_liab_this_period - $thisperiod_total) ;
$ie_lastperiod = sprintf("%01.2f",$total_assets_last_period - $total_liab_last_period - $lastperiod_total) ;
if ($ie_thisperiod==0) {$ie_thisperiod = '-' ; }
if ($ie_lastperiod==0) {$ie_lastperiod = '-' ; }
$thisperiod_total += $ie_thisperiod ;
$lastperiod_total += $ie_lastperiod ;
$t->set_var('unbooked_earning', '"'.lang('Interim Accumulated Earning').'"');
$t->set_var('earning_this_period', $ie_thisperiod ) ;
$t->set_var('earning_last_period', $ie_lastperiod ) ;
$t->set_var('total_equity_this_period',sprintf("%01.2f",$thisperiod_total)) ;
$t->set_var('total_equity_last_period',sprintf("%01.2f",$lastperiod_total)) ;
$t->set_var('total_liab_equity_this_period',sprintf("%01.2f",$total_liab_this_period+$thisperiod_total));
$t->set_var('total_liab_equity_last_period',sprintf("%01.2f",$total_liab_last_period+$lastperiod_total));

$phpgw->db->query("DROP TABLE $temp1");
$phpgw->db->query("DROP TABLE $temp2");
$phpgw->db->query("DROP TABLE $temp3");

/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',$phpgw->link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',lang('Done'));
    $t->pparse('out','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
