<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.comm.inc.php,v 0.11.1 2004/12/31 C K Wu $ */

    class comm {

//---- Comm Data Read

    function comm_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	$id = $ckapi[params_post][id] ;
	$catid = ($_GET["catid"]) ? $_GET["catid"] : $_POST["catid"] ;

	$phpgw->db->query("SELECT * FROM $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	if ($table=="${pre}org")	$dt[name] = $dt[orgnumber] ;
	if ($table=="${pre}person")	$dt[name] = $dt[prsnumber] ;

	$phpgw->db->query("SELECT * FROM ${pre}category WHERE id='$catid'");
	$phpgw->db->next_record();
	$dt[description] = $phpgw->db->f('description') ;
	$dt[catid] = $catid ;
	
	$sql = "SELECT a.* FROM ${pre}comm a, ${pre}cttcode b, ${pre}category c " ;
	$sql.= "WHERE contactid='$id' and commcode=b.name and b.catid=c.id and c.id=$catid order by commcode" ;
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['preferred'.$i]	=	$phpgw->db->f('preferred') ;
		$dt['commdata'.$i]	=	$phpgw->db->f('commdata') ;
		$dt['commcode'.$i]	=	$phpgw->db->f('commcode') ;
		}
	return $dt ;
	}

//---- Write Emergency Contact Header

    function comm_header_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_name',lang('Person Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('catid',$dt[catid]) ;
	$t->set_var('table',$ckapi[params][table]) ;
	$t->parse('out','report',True);
	}

//---- Write Emergency Contact Detail

    function comm_detail_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = lang('Row')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_preferred',lang("Preferred"));
	$t->set_var('lang_commdata',lang("Contact Communication Data")." - $dt[description]");
	$t->set_var('lang_commcode',lang("CommData Code -- Description") );
	$t->set_var('lang_delete',lang('Delete'));

	$lang_no = lang("no") ;
	$lang_yes = lang("yes") ;
	$preferred_sl = "<OPTION value='n'>n -- $lang_no</OPTION><OPTION value='y'>y -- $lang_yes</OPTION>" ;
	$commcode_sl = cttcodename_selectlist("WHERE catid='$dt[catid]'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['commcode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('preferred_fld','preferred'.$i) ;
			$t->set_var('commdata_fld','commdata'.$i) ;
			$t->set_var('commcode_fld','commcode'.$i) ;
			$t->set_var('preferred_selectlist',$preferred_sl) ;
			$t->set_var('commdata','') ;
			$t->set_var('commcode_selectlist',$commcode_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$preferred	=	$dt['preferred'.$i] ;
		$commcode	=	$dt['commcode'.$i] ;

		$t->set_var('preferred_fld','preferred'.$j) ;
		$t->set_var('commdata_fld','commdata'.$j) ;
		$t->set_var('commcode_fld','commcode'.$j) ;

		$t->set_var('preferred_selectlist',str_replace("'$preferred'","'$preferred' selected",$preferred_sl)) ;
		$t->set_var('commdata',$dt['commdata'.$i]) ;
		$t->set_var('commcode_selectlist',str_replace("'$commcode'","'$commcode' selected",$commcode_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;	else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;	else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('preferred_fld','preferred'.$i) ;
		$t->set_var('commdata_fld','commdata'.$i) ;
		$t->set_var('commcode_fld','commcode'.$i) ;
		$t->set_var('preferred_selectlist',$preferred_sl) ;
		$t->set_var('commdata','') ;
		$t->set_var('commcode_selectlist',$commcode_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

    }

?>

