<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.org.inc.php,v 0.11.1 2004/12/31 C K Wu $ */

	class org {

//---- Contact Org Data Read

    function org_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	$phpgw->db->query("SELECT * FROM $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	if (is_array($uniqueflds) and $op=='edit')
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	if ($op=='copy')	$id=0 ;
	$lang_person = strtolower(lang('person')) ;
	$sql = "SELECT a.*,c.description as nature,b.prsnumber,b.family,b.given " ;
	$sql.= "FROM ${pre}org_person a, ${pre}person b, ${pre}category c " ;
	$sql.= "WHERE contactid='$id' and preferred='y' and c.type='$lang_person' and personid=b.id and a.personcode=c.name";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[person] = $phpgw->db->Record ;
	$lang_org = strtolower(lang('org')) ;
	$sql = "SELECT a.*,c.description as nature,b.orgname " ;
	$sql.= "FROM ${pre}org_org a, ${pre}org b, ${pre}category c " ;
	$sql.= "WHERE contactid='$id' and preferred='y' and c.type='$lang_org' and orgid=b.id and a.orgcode=c.name";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[org] = $phpgw->db->Record ;
	$lang_comm = lang('comm') ;
	$sql = "SELECT a.*,c.description as category,b.description as nature,catid " ;
	$sql.= "FROM ${pre}comm a, ${pre}cttcode b, ${pre}category c " ;
	$sql.= "WHERE contactid='$id' and preferred='y' and b.type='$lang_comm' and commcode=b.name and catid=c.id";
	$phpgw->db->query($sql);
	while ($phpgw->db->next_record()) {
		$catid = $phpgw->db->Record[catid] ;
		$dt[comm][$catid] = $phpgw->db->Record ;
		}
	$lang_addr = strtolower(lang('address')) ;
	$sql = "SELECT a.*,b.description as nature FROM ${pre}address a, ${pre}cttcode b " ;
	$sql.= "WHERE contactid='$id' and preferred='y' and type='$lang_addr' and addresscode=b.name";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[addr] = $phpgw->db->Record ;
	$lang_org = strtolower(lang('org')) ;
	$sql = "SELECT contactid,name as nature,description as data,preferred " ;
	$sql.= "FROM ${pre}ctt_category a, ${pre}category b ";
	$sql.= "WHERE contactid='$id' and preferred='y' and a.cttcode=b.name and b.type='$lang_org'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[cat] = $phpgw->db->Record ;
	$lang_othr = lang('others') ;
	$sql = "SELECT contactid,description as nature,value as data,preferred FROM ${pre}others " ;
	$sql.= "WHERE contactid='$id' and preferred='y'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[othr] = $phpgw->db->Record ;

	return $dt ;
	}

//---- Write Org Header

    function org_header_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$script = &$ckapi[params_post][script] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('lang_orgnumber',lang("Name/#"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_note',lang("Note"));
	$t->set_var('lang_orgname',lang("Organization Name"));
	$t->set_var('lang_nationalorgid',lang("Organization National ID"));
	$t->set_var('lang_username',lang("Host System User Name"));

	$blankopt = "<OPTION value=''></OPTION>" ;
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('orgnumber',$dt[orgnumber]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('note',$dt[note]);
	$t->set_var('orgname',$dt[orgname]);
	$t->set_var('nationalorgid',$dt[nationalorgid]);
	$t->set_var('username',$dt[username]);
	$t->set_var('message','');

//	$t->parse('out','report',True);
	}

//---- Write org Detail

    function org_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$t->set_var('lang_channel',lang("Contact Details"));
	$t->set_var('lang_prefer',lang("Preferred"));
	$t->set_var('lang_type',lang("Type"));
	$t->set_var('lang_category',lang("Category"));
	$t->set_var('lang_nature',lang("Nature"));
	$t->set_var('lang_data',lang("Data"));
	$t->set_var('lang_full',lang("Full Info"));
	$t->set_var('lang_action',lang('view')) ;
/*	switch ($op) :
		case "view" :	$t->set_var('lang_action',lang('view')) ;	break;
		case "copy" :	$t->set_var('lang_action',"") ;			break;
		case "edit" :	$t->set_var('lang_action',lang('edit')) ;	break;
		case "delete" :	$t->set_var('lang_action','') ;			break;
		case "add" :	$t->set_var('lang_action',"") ;			break;
		endswitch ; */

	$t->set_var('type',lang("Related Person"));
	$t->set_var('nature',$dt[person][nature]);
	$title = $dt[person][title] ;
	$prsnumber = $dt[person][prsnumber] ;
	$family = $dt[person][family] ;
	$given = $dt[person][given] ;
	if ($family=="" and $given=="")		$data = $prsnumber ;
	  else					$data = "$prsnumber ($family, $given)" ;
	if ($title<>"")	{
		$lang_title = lang("Title") ;
		$data.= " [$lang_title - $title]" ;
		}
	$t->set_var('data',$data);
	$script = "orgperson$op.php" ;
	$getstr = "id=$dt[id]&return=$script" ;
	switch ($op) :
		case "view" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
		case "edit" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
		endswitch ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$t->set_var('type',lang("Associated Organization"));
	$t->set_var('nature',$dt[org][nature]);
	$t->set_var('data',$dt[org][orgname]);
	$script = "orgorg$op.php" ;
	$getstr = "id=$dt[id]&return=$script" ;
	switch ($op) :
		case "view" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
		case "edit" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
		endswitch ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);
	
	$lang_comm = lang('comm') ;
	$msg = lang("MSG") ;
	$phpgw->db->query("SELECT * FROM ${pre}category WHERE type='$lang_comm'");
	while ($phpgw->db->next_record()) {
		$catid = $phpgw->db->Record[id] ;
		$comm = ($dt[comm][$catid]<>"") ? $dt[comm][$catid] : "" ;
		$desc = $phpgw->db->Record[description] ;
		$t->set_var('type',"$msg - $desc");
		$t->set_var('nature',$comm[nature]);
		$t->set_var('data',$comm[commdata]);
		$script = "comm$op.php" ;
		$getstr = "id=$dt[id]&table=$table&catid=$catid&return=$script" ;
		switch ($op) :
			case "view" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
			case "edit" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
			endswitch ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	
	$t->set_var('type',lang("Address"));
	$t->set_var('nature',$dt[addr][nature]);
	$l1 = trim($dt[addr][line1]) ;
	$l2 = trim($dt[addr][line2]) ;
	$l3 = trim($dt[addr][line3]) ;
	$l4 = trim($dt[addr][line4]) ;
	$reg = trim($dt[addr][region]) ;
	$ctry = trim($dt[addr][country]) ;
	$zip = trim($dt[addr][zip]) ;
	$t->set_var('data',"$l1 $l2<br>$l3 $l4<br>$reg $ctry $zip");
	$script = "address$op.php" ;
	$getstr = "id=$dt[id]&table=$table&return=$script" ;
	switch ($op) :
		case "view" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
		case "edit" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
		endswitch ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$t->set_var('type',lang("Category"));
	$t->set_var('nature',$dt[cat][nature]);
	$t->set_var('data',$dt[cat][data]);
	$script = "ctt_category$op.php" ;
	$getstr = "id=$dt[id]&table=$table&return=$script" ;
	switch ($op) :
		case "view" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
		case "edit" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
		endswitch ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$t->set_var('type',lang("Others"));
	$t->set_var('nature',$dt[othr][nature]);
	$t->set_var('data',$dt[othr][data]);
	$script = "others$op.php" ;
	$getstr = "id=$dt[id]&table=$table&return=$script" ;
	switch ($op) :
		case "view" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
		case "edit" :	$t->set_var('action',$phpgw->link("/$app/$script",$getstr));	break;
		endswitch ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	if ($op=="edit") {
		$t->set_var('lang_image_action',lang("Edit Image"));
		$getstr = "id=$dt[id]&table=$table&return=imageedit.php" ;
		$t->set_var('image_action',$phpgw->link("/$app/imageedit.php",$getstr));
		}
	  else	$t->set_var('lang_image_action',"");
	$imageid = $dt[id] ;
	$img = $ckapi[hostsys][dataarea]."/images/$imageid.png" ;
	$t->set_var('image',$phpgw->link("/$app/contactview_image.php","imgfile=$img"));
	$t->set_var('tr_color_a',$tr_color2) ;
	$t->set_var('tr_color_b',$tr_color1) ;

	}
		
    }

?>



