<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-css' ;
	$tran = 'report' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$msg1 = lang('Generation of ledger report requires lengthy processing time.') ;
	$msg2.= lang('You should initiate report generation only during off-peak hours.') ;
	$ckapi[phrases] =array('lang_title'=>lang('Choose Report to Generate and to set Report Parameters :'),
				'lang_criteria'	=> lang("Report Parameters") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Report Generation") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$phpgw->db->query("Select * from ${pre}defaults");
	$phpgw->db->next_record();
	$a1cap = $phpgw->db->f('attrib1cap');	$a1tbl = $phpgw->db->f('attrib1tbl');
	$a2cap = $phpgw->db->f('attrib2cap');	$a2tbl = $phpgw->db->f('attrib2tbl');
	$a3cap = $phpgw->db->f('attrib3cap');	$a3tbl = $phpgw->db->f('attrib3tbl');
	$a1sdf = $phpgw->db->f('attrib1sdesc');	$a1cnv = $phpgw->db->f('attrib1cnval');
	$a2sdf = $phpgw->db->f('attrib2sdesc');	$a2cnv = $phpgw->db->f('attrib2cnval');
	$a3sdf = $phpgw->db->f('attrib3sdesc');	$a3cnv = $phpgw->db->f('attrib3cnval');
	$ac_sl = "<OPTION value='0'>all -- All Accounts (will fail under heavy load)</OPTION>" ;
	$ac_sl .= account_selectlist(" WHERE charttype='A' ") ;
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$note1 = lang("If wrong action chosen, click [Report] to restart.") ;
	$note1a = lang("If all parameters chosen, press [Start Report Generation] one more time to start.") ;

	$ckapi[filter][] = array(criteria	=>	lang('Which Report') ,
				type		=>	'select' ,
				selectlist	=>	'' ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	"$note1<br>$note1a"			);

	$ckapi[filter][] = array(criteria	=>	$a1cap ,
				type		=>	'select' ,
				selectlist	=>	attrib_selectlist($a1tbl,$a1sdf,'','') ,
				varname		=>	'attrib1' ,
				defval		=>	'' ,
				note		=>lang("Choose to produce the report of which")." $a1cap") ;

	$ckapi[filter][] = array(criteria	=>	$a2cap ,
				type		=>	'select' ,
				selectlist	=>	attrib_selectlist($a2tbl,$a2sdf,'','') ,
				varname		=>	'attrib2' ,
				defval		=>	'' ,
				note		=>lang("Choose to produce the report of which")." $a2cap") ;

	$ckapi[filter][] = array(criteria	=>	$a3cap ,
				type		=>	'select' ,
				selectlist	=>	attrib_selectlist($a3tbl,$a3sdf,'','') ,
				varname		=>	'attrib3' ,
				defval		=>	'' ,
				note		=>lang("Choose to produce the report of which")." $a3cap") ;

	$ckapi[filter][] = array(criteria	=>	lang('Which Account') ,
				type		=>	'select' ,
				selectlist	=>	$ac_sl ,
				varname		=>	'account' ,
				defval		=>	'' ,
				note		=>	lang('Select the target account')	);

	$ckapi[filter][] = array(criteria	=>	lang('Report Status as of (Current Period)') ,
				type		=>	'input' ,
				varname		=>	'rdate_curr' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Date from (Current Period)') ,
				type		=>	'input' ,
				varname		=>	'datefrom_curr' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Date to (Current Period)') ,
				type		=>	'input' ,
				varname		=>	'dateto_curr' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Report Status as of (Comparison Period)') ,
				type		=>	'input' ,
				varname		=>	'rdate_comp' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Date from (Comparison Period)') ,
				type		=>	'input' ,
				varname		=>	'datefrom_comp' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Date to (Comparison Period)') ,
				type		=>	'input' ,
				varname		=>	'dateto_comp' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$trialbalance = lang('Trial Balance') ;
	$incomestatement = lang('Income Statement') ;
	$balancesheet = lang('Balance Sheet') ;
	$ledgerlisting = lang('Ledger Listing') ;
	$controlreport = lang('Ledger Audit Control Report') ;
	$anomalies = lang('List of Journals with Anomalies') ;
	$ckapi[filter][actlist] = array (	1=>"<OPTION value='1'>1 -- $trialbalance</OPTION>",
						2=>"<OPTION value='2'>2 -- $incomestatement</OPTION>",
						3=>"<OPTION value='3'>3 -- $balancesheet</OPTION>",
						4=>"<OPTION value='4'>4 -- $ledgerlisting</OPTION>"	) ;
//						5=>"<OPTION value='5'>5 -- $controlreport</OPTION>",
//						6=>"<OPTION value='6'>6 -- $anomalies</OPTION>" ) ;
	$ckapi[filter][actstring] = array("0",			/* first entry	*/
					"05",			/* report 1	*/
					"067910",		/* report 2	*/
					"058",			/* report 3	*/
					"067",			/* report 4	*/		) ;
//					"05",			/* report 5	*/
//					"0"			/* report 6	*/		) ;
	$actnum = ($_GET["actnum"]) ? $_GET["actnum"] : $_POST["actnum"] ;
	if ($actnum==1 or $actnum==3) {
		For ($i=1;$i<=3;$i++)	{
			$constantvar = "a${i}cnv" ;
			if ($$constantvar == "yes")	$ckapi[filter][actstring][$actnum] .= "$i" ;
			}
		}
	if ($actnum==2 or $actnum==4)
		For ($i=1;$i<=3;$i++)			$ckapi[filter][actstring][$actnum] .= "$i" ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>

