<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.dept.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class dept {

//---- Department Detail Validation Checks

    function dept_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	if ($dt[name]=="")		$err=lang('Department name Missing');
	if ($dt[description]=="")	$err=lang('Department description Missing');
	if ($dt[email] and strpos($dt[email],'@')=='')  $err = lang("Invalid email address") ;
	if ($dt[name]<>$dt[oldname]) {
		$phpgw->db->query("SELECT * from ${pre}department where name='$dt[name]'");
		if ($phpgw->db->num_rows()>0)	$err = lang("Department Name already exists") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Department Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$errmsg1 = lang("This department is in use within an existing") ;
	$emprec = lang("employee record") ;
	$journal = lang("journal") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}employee where dept='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $emprec id#".$phpgw->db->f('id') ;
		}
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Department Detail

    function dept_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_name',lang('Department Name'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_head',lang('Head of Department'));
	$t->set_var('lang_email',lang('Contact Email'));
	$t->set_var('lang_headcount',lang('Head Count'));
	$id = ($dt[id]=="") ? 0 : $dt[id] ;
	$t->set_var('id',$id);
	$t->set_var('control',$dt[control]);
	$t->set_var('name',$dt[name]);
	$t->set_var('oldname',$dt[oldname]);
	$t->set_var('description',$dt[description]);
	$t->set_var('head_sl',employee_selectlist('',$dt[head]));
	$t->set_var('email',$dt[email]);
	$phpgw->db->query("SELECT count(name) as headcount from ${pre}employee where dept = '$id'");
	$phpgw->db->next_record();
	$t->set_var('headcount',$phpgw->db->f('headcount'));
	$t->set_var('message','');
	$t->parse('out','report',True);
	}


    }

?>
