<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.alternate.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class alternate {

//---- Alternate List SQL Formation

    function alternate_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$sql =  "SELECT distinct a.* from ${pre}parts a,${pre}alternate b " ;
	$sql.=  "WHERE a.id=b.alternate_id $where order by ".$order." ".$sort ;
	return $sql ;
	}

//---- Alternate Read

    function alternate_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT control FROM ${pre}parts WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$phpgw->db->query("SELECT * from ${pre}alternate WHERE alternate_id='$id' order by id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['item_id'.$i] = $phpgw->db->f('item_id') ;
		$dt['qty'.$i] = $phpgw->db->f('qty') ;
		}
	$dt[target] = $dt[id] = $id ;
	return $dt ;
	}

//---- Alternate Add Initialisation

    function alternate_add_init() {
	global $ckapi ;

	$ckapi[params_post][dt]['item_id1'] = "" ;
	}


//---- Alternate Validation Checks

    function alternate_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;

	$err=""; $error=lang("Error") ;
	if ($op<>'edit')	{
		$phpgw->db->query("SELECT distinct * from ${pre}alternate where alternate_id=$dt[target]");
		if ($phpgw->db->num_rows()>0)		$err=lang("Alternate already exists");
		}
	For ($i=1;isset($dt['item_id'.$i]);$i++) {
		$row = lang("Row") ; $rowi = "[$row $i]" ;
		if ($dt['item_id'.$i]==$dt[target])	$err=$rowi.lang("Alternate cannot be itself");
		For ($j=1;isset($dt['item_id'.$j]);$j++) {
			$rowij = "[$row $i/$j]" ;
			if ($dt['item_id'.$i]==$dt['item_id'.$j] and $i<>$j)
							$err=$rowij.lang("Duplicative Alternate");
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Alternate Header

    function alternate_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_ginfo',lang("General Information"));
	$t->set_var('lang_target',lang("Target Part"));
	$t->set_var('lang_id',lang("Audit Id :"));

	$where = (!$uniwhere) ? " WHERE id='$dt[target]' " : $uniwhere;
	$t->set_var('part_sl',part_selectlist($where,$dt[target])) ;
	if ($dt[target]<>$dt[lasttarget]) {
		$phpgw->db->query("SELECT control FROM ${pre}parts WHERE id='$dt[target]'");
		$phpgw->db->next_record();
		$dt[control] = $phpgw->db->f('control');
		}
	$t->set_var('lasttarget',$dt[target]) ;
	$t->set_var('id',$dt[target]) ;
	$dt[id] = $dt[target] ;
	$t->set_var('control',$dt[control]);
	$t->parse('out','report',True);
	}

//---- Write Alternate Detail

    function alternate_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_alt',lang('Alternate Part/Service'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$t->set_var('control',$dt[control]);
	$item_list = item_selectlist("",'') ;

	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($dt['item_id'.$i]);$i++) {
		if ($i<>$rowno) {
			$item_id = $dt['item_id'.$i] ;
			if (isset($delete) and $i>$rowno) {$j=$i-1;} else {$j=$i;}
			$t->set_var('item_fld','item_id'.$j) ;
			$t->set_var('item_sl',str_replace("'$item_id'","'$item_id' selected",$item_list));
			if ($posted)	$t->set_var('rowno',"done") ;	else $t->set_var('rowno',$row_.$j) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)		$i=1 ;
	if ($i==1)				$newrow=True ;
	if ($newrow) {
		$t->set_var('item_fld','item_id'.$i) ;
		$t->set_var('item_sl',$item_list);
		$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->parse('out','report',True);
	}

//---- Alternate Post Initialisation

    function alternate_post_init() {
	global $ckapi ;

	if ($ckapi[params_post][op]=='new')	$ckapi[params_post][op] = 'edit' ;
	}

//---- Alternate Post - PreCommit Routine

    function alternate_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	$id = $dt[target] ;
	if ($op<>'new')	$phpgw->db->query("DELETE FROM ${pre}alternate WHERE alternate_id=$id");
	if ($op<>'delete') {
		$sql1 = "INSERT INTO ${pre}alternate (alternate_id,item_id) " ;
		For ($i=1;isset($dt['item_id'.$i]);$i++) {
			$item_id	= $dt['item_id'.$i];
			$sql = "$sql1 VALUES ('$id','$item_id')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>