<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: bulkpayrollfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'bulkpayroll' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}bulkpayroll" ,
				'doneexit'	=> "index.php"				) ;
	$msg1 = lang("Payroll Generation normally requires lengthy processing time.") ;
	$msg2 = lang("You should initiate Payroll Generation only during off-peak hours.");
	$msg3 = lang("Salary advice for previous period may be regenerated.") ;
	$ckapi[phrases] = array('lang_title'=>lang("Choose Action to perform and to set Action Parameters :"),
				'lang_criteria'	=> lang("Action Parameters") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Action") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "$msg1<br>$msg2<br>$msg3" ,
				'message'	=> ""					);

	$warning1 = lang("Since Payroll Generation is irreversible, please perform database backup first then follow the strict sequence of Step 1-2-3.");
	$warning1a = lang("All payroll related data modification should also be stopped.") ;
	$warning2 = lang("Inaccurate Date will affect subsequent period's payroll.") ;
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$note1 = lang("If wrong action chosen, click (Generate Bulk Payroll) to restart.") ;
	$note2 = lang('Operate on all staff or staff with the choosen pay period') ;
	$note4 = lang("For cheque generation, this step needs to be repeated for all staff that require a payroll check.");
	$note4a = lang("Cheques for past payroll period may be regenerated.") ;
	$note5 = lang("For any one employee's cheque, payment journal should only be generated once.") ;
	$note7 = lang("Choose which ledger (bank) account to put through Cr (cheque amount).") ;
	$note7a = lang("Please ignore if payment journal is not to be generated.") ;
	$nullopt = "<OPTION value=''></OPTION>" ;

	$note3 = lang('Immediate past payroll period') ;
	$phpgw->db->query("SELECT max(trans_id) as id FROM ${pre}pyrohist");
	$phpgw->db->next_record() ;
	$id = $phpgw->db->Record['id'] ;
	$phpgw->db->query("SELECT description FROM ${pre}gl WHERE id='$id'");
	$phpgw->db->next_record() ;
	$pastdesc = $phpgw->db->Record['description'] ;
	$frommarker = strtolower(lang('from')).'::' ;
	$tomarker = strtolower(lang('to')).'::' ;
	list($dummy,$fromto) = explode($frommarker,$pastdesc) ;
	list($from,$to) = explode($tomarker,$fromto) ;
	$perifrom = trim($from);
	$perito = trim($to);

	$ckapi[filter][] = array(criteria	=>	lang('Which Action') ,
				type		=>	'select' ,
				selectlist	=>	'' ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	"<b>$warning1  $warning1a</b>  $note1"	);

	$ckapi[filter][] = array(criteria	=>	lang('Pay Period') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.pperiod_selectlist('','') ,
				varname		=>	'period' ,
				defval		=>	'' ,
				note		=>	$note2					);

	$ckapi[filter][] = array(criteria	=>	lang('Useful Information') ,
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No input required]') ,
				note		=>	"$note3:  $perifrom => $perito"		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"<b>$warning2</b>  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"<b>$warning2</b>  $dateformat"		) ;

	$step1 = lang('Step 1 - Test Run on Current Period Payroll Generation') ;
	$step2 = lang('Step 2 - Generate Current Period Payroll, Journal and History Data') ;
	$step3 = lang('Step 3 - Email Salary Advice to Staff') ;
	$ckapi[filter][actlist] = array (	1=>	"<OPTION value='1'>$step1</OPTION>",
						2=>	"<OPTION value='2'>$step2</OPTION>",
						3=>	"<OPTION value='3'>$step3</OPTION>"	);
	$ckapi[filter][actstring] = array("0",		/* first entry	*/
					"01234",	/* Step 1	*/
					"01234",	/* Step 2	*/
					"02"		/* Step 3	*/			) ;

	if ($_POST[actnum]>2)	$ckapi[filter][3][note] = $ckapi[filter][4][note] = $dateformat ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>


