<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: payjournallist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'payjournal' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}gl" ,
				'sortkey'	=> "bpyroid,name" ,
				'doneexit'	=> "${tran}filter.php"			);
$msg=lang("Payment Journal should be generated after salary is paid via cheque, autopay or other mechanisms");
	$ckapi[phrases] = array('lang_title'	=> lang("List of Settled/Outstanding Salary Payment") ,
				'lang_employee'	=> lang("Employee") ,
				'lang_bank'	=> lang("Bank Account") ,
				'lang_period'	=> lang("Payroll Period") ,
				'lang_payment'	=> lang("Payment") ,
				'lang_print'	=> lang("Print") ,
				'lang_bulkpayroll'	=> lang("Bulk Payroll") ,
				'lang_payjournal'	=> lang("Payment Journal") ,
				'lang_add'	=> lang("Done") ,
				'lang_total'	=> lang("Total") ,
				'message'	=> $msg					);
	$ckapi[columns] = array('id'		=> lang('ID') ,
				'name'		=> lang('Name') ,
				'bank'		=> lang('Bank Account') ,
				'bankacname'	=> lang('Name') ,
				'bankac'	=> lang('Number') ,
				'datefrom'	=> lang('Period From') ,
				'dateto'	=> lang('Period To') ,
				'amount'	=> lang('Amount') ,
				'bpyroid'	=> lang('Audit ID') ,
				'id'		=> lang('Audit ID') 			);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'cheque'	=> "/$app/${tran}cheque.php" ,
				'genpj'		=> "/$app/${tran}gen.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_cheque'	=> lang("Cheque") ,
				'lang_genpj'	=> lang("Generate") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;
	ExecMethod('ck-api.process.process_footer') ;

?>

