<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: pobillhist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-po' ;
	$tran = 'po' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	$po = CreateObject("$app.$tran") ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$ckapi[objects][template] = &$t ;
	$t->set_file('report',"${tran}billhist.tpl") ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('View PO Billing History'));
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

/*------------- Write PO Billing History to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM ${pre}po WHERE id='$id'");
	$phpgw->db->next_record();

	$ckapi[params_post][dt] = $phpgw->db->Record ;
	$duedate = $phpgw->db->f('duedate') ;
	$poamount = $phpgw->db->f('amount') ;
	$netamount = $phpgw->db->f('netamount') ;
	$ckapi[params_post][dt][taxstatus] = ($poamount==$netamount) ? "e" : $phpgw->db->f('taxincluded') ;
	$po->po_header_write() ;

	$t->set_var('lang_date',lang('Date'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_invoiceid',lang('Invoice ID'));
	$t->set_var('lang_invamount',lang('Invoice Amount'));
	$t->set_var('lang_bamount',lang('Amount billed<br>against this PO'));
	$t->set_var('lang_osamount',lang('Outstanding PO<br>Unbilled Amount'));
	$t->set_var('lang_title_detail',lang('Detail'));
	$t->set_var('note1',lang('Note 1 - Days Elapsed since PO due and not fully billed'));
	$t->set_var('note2',lang('Note 2 - Press [done] button at Detail screen to work on detail transaction maintenance'));

	$t->set_var('date',$duedate);
	$t->set_var('description','<- '.lang('Due Date').' / '.lang('PO Amount').' ->');
	$t->set_var('invoiceid','');
	$t->set_var('invamount','');
	$t->set_var('bamount','');
	$t->set_var('osamount',$poamount);
	$t->set_var('lang_item',lang('PO'));
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	$pofilter = urlencode("${markpri}1a.id${marksec}${id}") ;
	$tran1 = ($poamount==$netamount) ? "pont" : "powt" ;
	$item = $phpgw->link("/$app/${tran1}view.php","id=$id&filter=$pofilter");
	$t->set_var('item',$item) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$sql = "SELECT transdate,id,invnumber,amount,netamount,b_amount FROM ${pre}ap, ${pre}ipmatch " ;
	$sql.= "WHERE poid='$id' and id=invoiceid ORDER BY transdate" ;
	$phpgw->db->query($sql);
	$osamount = $poamount ;
	while ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$invamount = $phpgw->db->f('amount') ;
		$netaount = $phpgw->db->f('netamount') ;
		$bamount = $phpgw->db->f('b_amount') ;
		$t->set_var('date',$phpgw->db->f('transdate'));
		$lang_invno = lang('Invoice#') ;
		$t->set_var('description',"$lang_invno:    ".$phpgw->db->f('invnumber'));
		$t->set_var('invoiceid',$id);
		$t->set_var('invamount',$invamount);
		$bamount = $phpgw->db->f('b_amount') ;
		$t->set_var('bamount',$bamount);
		$osamount -= $bamount ;
		$t->set_var('osamount',$osamount);
		$t->set_var('lang_item',lang('Invoice'));
		$pofilter = urlencode("${markpri}1a.id${marksec}${id}") ;
		$tran2 = ($invamount==$netamount) ? "invoicent" : "invoicewt" ;
		$item = $phpgw->link("/ck-ap/${tran2}view.php","id=$id&filter=$pofilter");
		$t->set_var('item',$item) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('date',date("Y-m-d"));
	$t->set_var('description','<- '.lang('System Date').' / '.lang('Days Overdue [Note 1]').' ->');
	$t->set_var('invoiceid','');
	$t->set_var('invamount','');
	$t->set_var('bamount','');
	$t->set_var('osamount','');
	$t->set_var('lang_item','');
	$overdue = (time()-strtotime($duedate))/86400 ;

	$overdue = ($overdue<0 or $osamount<=0) ? lang("N/A") : floor($overdue) ;
	$t->set_var('invoiceid',$overdue);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('action',$phpgw->link("/$app/${tran1}list.php","filter=$filter")) ;
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_newrow',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran1}list.php","filter=$filter")) ;
	$t->set_var('lang_done',lang('Done'));
	$t->set_var('message','') ;
	$t->pparse('out','report',True);
	ExecMethod('ck-api.process.process_footer') ;

?>
