<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: shiftballist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-m' ;
	$tran = 'shiftbal' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "shiftbalfilter.php"			) ;
	$note1 = lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight') ;
	$note2 = lang('Cash Balance')." - ".lang('Cash Balance that should be available inside CashBox or Cash ShortFall(+ve)/Surplus(-ve) post End-of-Shift operation') ;
	$ckapi[phrases] = array('lang_title'	=> lang("List of Shift End Cash Balances") ,
				'lang_add'	=> lang("Done") ,
				'lang_note1'	=> $note1,				
				'lang_note2'	=> $note2				) ;
	$ckapi[columns] = array('transdate'	=> lang('Date') ,
				'shift'		=> lang('Shift') ,
				'name'		=> lang('CashBox') ,
				'cashier'	=> lang('Cashier') ,
				'cashamt'	=> lang('Cash Tendered<br>by Customer') ,
				'changeamt'	=> lang('Cash Returned<br>to Customer') ,
				'cbtamt'	=> lang('Bulk Cash<br>Transferred in/out') ,
				'balance'	=> lang('Cash Balance')		) ;
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View Detail")			) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
