<?php
 /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-quote' ;
	$tran = 'controlreport' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report',"$tran.tpl");
	$t->set_block('report','block1','block1_section');
	$t->set_block('report','block2','block2_section');

/*---------------------------------------------------------------------------------*/

	$note1 = lang('Note 1') ;
	$t->set_var('lang_control_report', lang('Quotation Audit Control Report'));
	$t->set_var('lang_detail', lang('Detail'));
	$t->set_var('lang_note', lang('Note'));
	$t->set_var('lang_date', lang('Date'));
	$t->set_var('lang_customer', lang('Customer'));
	$t->set_var('lang_tax', lang('Tax Type'));
	$t->set_var('lang_quote', lang('Quotation'));
	$t->set_var('lang_oitem', lang('Order Item'));
	$t->set_var('lang_requested_status', lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_print_date', lang('Date Report Printed'));
	$t->set_var('lang_status_note'," ".lang('(note the effect of postdated Quotations)'));
	$t->set_var('lang_note1',$note1);
	$t->set_var('lang_total_amount', lang('Total Amount'));
	$t->set_var('lang_total_netamount', lang('Total Amount (Net of Tax)'));
	$t->set_var('lang_total_tax', lang('Total Tax'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));
	$note1a = lang('These lines are for control reconciliation purpose only') ;
	$note1b = lang('The figures represent an amalgamation of different currency amounts') ;
	$t->set_var('note1',"$note1 - $note1a. $note1b.");

/*-----------------Gather and Write Status Date Info---------------------------------*/

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}quote " ;
$sql.=	"WHERE transdate <= '$repdate' GROUP BY isocode ORDER BY isocode" ;
$phpgw->db->query($sql);
if ($phpgw->db->num_rows()==0)	$t->set_var('block1_section',"");

while ($phpgw->db->next_record()) {
	$t->set_var(array('isocode'	=> $phpgw->db->f('isocode'),
		'curr_amount'	=> $phpgw->db->f('curr_amount')  ));
	$t->parse('block1_section','block1',true);
	}

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from ${pre}quote WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_amount = $phpgw->db->f('amount') ;
$quote_netamount = $phpgw->db->f('netamount') ;

$sql =	"SELECT sum(qty*price-discount-tax1-tax2) as oitem_amount from ${pre}oitem a,${pre}quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='t'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_netamount = $phpgw->db->f('oitem_amount') ;
$sql =	"SELECT sum(qty*price-discount) as oitem_amount from ${pre}oitem a,${pre}quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='f'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_netamount += $phpgw->db->f('oitem_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}oitem a,${pre}quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_tax = $phpgw->db->f('tax1')+$phpgw->db->f('tax2') ;

$sql =	"SELECT count(id) as count from ${pre}quote WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(a.id) as count from ${pre}oitem a,${pre}quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id from ${pre}quote WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(a.id) as id from ${pre}oitem a,${pre}quote b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_id = $phpgw->db->f('id') ;

$t->set_var('status_date',$repdate) ;
$t->set_var('quote_amount',sprintf("%01.2f",$quote_amount)) ;
$t->set_var('quote_netamount',sprintf("%01.2f",$quote_netamount)) ;
$t->set_var('oitem_netamount',sprintf("%01.2f",$oitem_netamount)) ;
$t->set_var('oitem_tax',sprintf("%01.2f",$oitem_tax)) ;
$t->set_var('payment_amount',sprintf("%01.2f",$payment_amount)) ;
$t->set_var('quote_count',$quote_count) ;
$t->set_var('oitem_count',$oitem_count) ;
$t->set_var('payment_count',$payment_count) ;
$t->set_var('quote_id',$quote_id) ;
$t->set_var('oitem_id',$oitem_id) ;

/*-----------------Gather and Write Total System Info-----------------------------*/

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}quote " ;
$sql.=	"GROUP BY isocode ORDER BY isocode" ;
$phpgw->db->query($sql);
if ($phpgw->db->num_rows()==0)	$t->set_var('block2_section',"");

while ($phpgw->db->next_record()) {
	$t->set_var(array('isocode'	=> $phpgw->db->f('isocode'),
		'curr_amount'	=> $phpgw->db->f('curr_amount')  ));
	$t->parse('block2_section','block2',true);
	}

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from ${pre}quote " ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_amount = $phpgw->db->f('amount') ;
$quote_netamount = $phpgw->db->f('netamount') ;

$sql =	"SELECT sum(qty*price-discount-tax1-tax2) as oitem_amount from ${pre}oitem a,${pre}quote b " .
	"WHERE a.trans_id=b.id and b.taxincluded='t'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_netamount = $phpgw->db->f('oitem_amount') ;
$sql =	"SELECT sum(qty*price-discount) as oitem_amount from ${pre}oitem a,${pre}quote b " .
	"WHERE a.trans_id=b.id and b.taxincluded='f'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_netamount += $phpgw->db->f('oitem_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}oitem a,${pre}quote b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_tax = $phpgw->db->f('tax1')+$phpgw->db->f('tax2') ;

$sql =	"SELECT count(id) as count FROM ${pre}customer" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$customer_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM ${pre}tax WHERE taxgroup='ar'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$tax_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM ${pre}quote" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(a.id) as count FROM ${pre}oitem a,${pre}quote b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id FROM ${pre}customer" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$customer_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM ${pre}tax WHERE taxgroup='ar'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$tax_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM ${pre}quote" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$quote_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(a.id) as id FROM ${pre}oitem a,${pre}quote b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$oitem_id = $phpgw->db->f('id') ;

$t->set_var('print_date',date("Y-m-d")) ;
$t->set_var('sys_quote_amount',sprintf("%01.2f",$quote_amount)) ;
$t->set_var('sys_quote_netamount',sprintf("%01.2f",$quote_netamount)) ;
$t->set_var('sys_oitem_netamount',sprintf("%01.2f",$oitem_netamount)) ;
$t->set_var('sys_oitem_tax',sprintf("%01.2f",$oitem_tax)) ;
$t->set_var('sys_customer_count',$customer_count) ;
$t->set_var('sys_tax_count',$tax_count) ;
$t->set_var('sys_quote_count',$quote_count) ;
$t->set_var('sys_oitem_count',$oitem_count) ;
$t->set_var('sys_payment_count',$payment_count) ;
$t->set_var('sys_customer_id',$customer_id) ;
$t->set_var('sys_tax_id',$tax_id) ;
$t->set_var('sys_quote_id',$quote_id) ;
$t->set_var('sys_oitem_id',$oitem_id) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
