<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: leaveapplist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-sss' ;
	$tran = 'leaveapp' ;
	$enable_nm = True ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'leaveapp',
				'tran'		=> $tran ,
				'table'		=> 'leaveapp' ,
				'sortkey'	=> 'leavefrom,leaveto'			);
	$msg1 = lang('Approved Leave Applications cannot be edited nor deleted.') ;
	$msg2 = lang('To allow auto email requesting various approvals, email/dns environment must be correctly setup.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Leave Application List") ,
				'lang_add'	=> lang("Add New Leave Application") ,
				'message'	=> "$msg1  $msg2"			);
	$ckapi[columns] = array('staff'		=> lang('Employee Name/#') ,
				'leavefrom'	=> lang('Leave From') ,
				'leaveto'	=> lang('Leave To') ,
				'description'	=> lang('Leave Description') ,
				'duration'	=> lang('Duration in Work Days') ,
				'approved_by'	=> lang('Approved By') ,
				'id'		=> lang('Audit ID') 			);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")		) ;
	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
