<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: payrollfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-sss' ;
	$tran = 'payroll' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "${tran}filter_validate.php"		) ;

	$title = lang("Choose Payroll Info to generate and to set Parameters :") ;
	$msg1 = lang('Please note that your payroll info will next be displayed on screen') ;
	$ckapi[phrases] = array('lang_title'	=> $title ,
				'lang_criteria'	=> lang("Info Generation Parameters") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Generate Past Period Payroll Info") ,
				'lang_add'	=> lang("Generate Current Period Payroll Info") ,
			'lang_search_message'	=> "<b>$msg1</b>"		);

	$dateformat = lang('Format: YYYY-MM-DD') ;
	$msg = lang('Payroll info falling within (from/to) date will be listed.') ;
	$ckapi[filter][] = array(criteria	=>	lang('Payroll Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"$msg  $dateformat"		);

	$ckapi[filter][] = array(criteria	=>	lang('Payroll Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"$msg  $dateformat"		);

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>

