<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: contractfilter.php,v 0.10.1 2004/10/31 C K Wu $ */

	$app = 'ck-vrm' ;
	$tran = 'contract' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Contracts :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Contract") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$contractmsg = lang('Contracts falling within (from/to) period will be listed.') ;
	$opennote = lang("Click box if only current and unexpired contracts are to be retrieved") ;
	$ckapi[filter][] = array(criteria	=>	lang('Vendor') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.vendor_selectlist("","") ,
				varname		=>	'vendor' ,
				defval		=>	"" ,
				note		=>	lang('Search for contracts of the target vendor') );
				
	$ckapi[filter][] = array(criteria	=>	lang('Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"$contractmsg  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"$contractmsg  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Contract Name/#') ,
				type		=>	'input' ,
				varname		=>	'cntnumber' ,
				defval		=>	"" ,
				note		=>	lang('Search for target key word in the contract name/# field') );

	$ckapi[filter][] = array(criteria	=>	lang('Open Contracts Only') ,
				type		=>	'checkbox' ,
				varname		=>	'opentran' ,
				defval		=>	"" ,
				note		=>	$opennote				 );

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
