<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: vendcasefilter.php,v 0.10.1 2004/10/31 C K Wu $ */

	$app = 'ck-vrm' ;
	$tran = 'vendcase' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Contact Cases :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Contact Case") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$non_vendor = "<OPTION value='0'>".lang("Non-Vendor")."</OPTION>" ;
	$startmsg = lang('Case Log Starting Date falling within (from/to) date range will be listed.') ; 
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$opennote = lang("Click box if only outstanding (non-closed) contact cases are to be retrieved") ;
	$ckapi[filter][] = array(criteria	=>	lang('Vendor') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.$non_vendor.vendor_selectlist("","") ,
				varname		=>	'vendor' ,
				defval		=>	"" ,
				note		=>	lang('Search for contact cases of the target vendor') );

	$ckapi[filter][] = array(criteria	=>	lang('From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"$startmsg  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	lang('To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"$startmsg  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Contact Case Number') ,
				type		=>	'input' ,
				varname		=>	'casenumber' ,
				defval		=>	"" ,
				note		=>lang('Search for target key word in the contact case number field') );

	$ckapi[filter][] = array(criteria	=>	lang('Open Contact Cases Only') ,
				type		=>	'checkbox' ,
				varname		=>	'opentran' ,
				defval		=>	"" ,
				note		=>	$opennote				 );

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
