<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: vendcaselist.php,v 0.10.1 2004/10/31 C K Wu $ */

	$app = 'ck-vrm' ;
	$tran = 'vendcase' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}vendcase"		);
	$ckapi[phrases] = array('lang_title'	=> lang("List of Contact Cases") ,
				'lang_add'	=> lang("Add New Contact Case") ,
				'bulk_action'	=> $phpgw->link("/$app/${tran}filter.php" ) ,
				'message'	=> $msg				);
	$ckapi[columns] = array('casenumber'	=> lang('Contact Case Name/#') ,
				'name'		=> lang('Vendor Name') ,
				'description'	=> lang('Contact Case Description') ,
				'start'		=> lang('Started on') ,
				'id'		=> lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

	$temp = $ckapi[params_sql][temp];
	if ($temp<>"")	$phpgw->db->query("DROP TABLE $temp");
	ExecMethod('ck-api.process.process_footer') ;

?>
