<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: developfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-admin' ;
	$tran = 'develop' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$ckapi[phrases] = array('lang_title'	=> lang("Choose Admin Action to Perform :") ,
				'lang_criteria'	=> lang("Action to Perform") ,
				'lang_value'	=> lang("Parameter Value") ,
				'lang_note'	=> lang("Start Related Action") ,
				'lang_search'	=> lang("Done") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$lang_delete = lang('Delete') ;  $link_delete = $phpgw->link("/$app/admindelete.php") ;
	$lang_setup = lang('Setup') ;  $link_setup = $phpgw->link("/$app/adminsetup.php") ;
	$lang_build = lang('Build') ;  $link_build = $phpgw->link("/$app/adminbuild1.php","chart=1") ;
	$lang_create = lang('Create') ;  $link_create = $phpgw->link("/$app/admincreate.php") ;
	$lang_convert = lang('Convert') ;  $link_convert = $phpgw->link("/$app/adminconvert.php") ;
	$lang_statlist = lang('Statistics') ;  $link_statlist = $phpgw->link("/$app/statlist.php") ;
	$lang_md5 = lang('MD5') ;  $link_md5 = $phpgw->link("/$app/adminmd5.php") ;
	$lang_copy = lang('Copy') ;  $link_copy = $phpgw->link("/$app/admincopy.php") ;
	$lang_actlang = lang ('Make it available at phpgw setup screen') ;
	$activate = lang('Activate') ;
	$link_setlang = $phpgw->link("/$app/adminlang.php") ;
	$phpgw->db->query("SELECT * FROM phpgw_languages ORDER BY lang_id");
	$lang_sl="";
	$gen = lang('Generate') ;
//	$gen1 = lang("Create dummy records for volume test") ;
//	$gen2 = lang("Do not activate this step, if you are not a developer") ;
	$lang_gen = lang("If you are not a developer, do not activate this step") ;
	While ($phpgw->db->next_record()) {
		$lang_id = $phpgw->db->f('lang_id') ;
		$lang_name = $phpgw->db->f('lang_name');
		$available = $phpgw->db->f('available');
		$lang_sl .= "<OPTION value='$lang_id'>$lang_id -- $lang_name -- $available</OPTION>" ;
		}
	$translate = lang('Translate') ;
	$lang_translate = lang('Be sure to lodge existing zt phrases with db 1st') ;

	$ckapi[filter][] = array(criteria	=>	lang('Delete all Data and Data Tables') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_delete' target='_blank'>$lang_delete</a>");

	$ckapi[filter][] = array(criteria	=>	lang('Setup Data Tables') ,
				type		=>	'input' ,
				varname		=>	'description' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_setup' target='_blank'>$lang_setup</a>",);

	$ckapi[filter][] = array(criteria	=>	lang('Generate MD5 Script checksum'),
				type		=>	'input' ,
				varname		=>	'' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_md5' target='_blank'>$lang_md5</a>");

	$ckapi[filter][] = array(criteria	=>	lang('Build Chart of Accounts and other Master Data'),
				type		=>	'input' ,
				varname		=>	'chart' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_build' target='_blank'>$lang_build</a>");

	$ckapi[filter][] = array(criteria	=>	lang('Create Test Data'),
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_create' target='_blank'>$lang_create</a>");

	$ckapi[filter][] = array(criteria	=>	lang('Convert big5/gb18030 to utf-8'),
				type		=>	'input' ,
				varname		=>	'conv' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_convert' target='_blank'>$lang_convert</a>");

	$ckapi[filter][] = array(criteria	=>	lang('Check Access Statistics'),
				type		=>	'input' ,
				varname		=>	'stat' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<a href='$link_statlist' target='_blank'>$lang_statlist</a>");

	$ckapi[filter][] = array(criteria	=>	lang ('Activate Language') ,
				type		=>	'select' ,
				selectlist	=>	$lang_sl ,
				varname		=>	'lang_id' ,
				defval		=>	"" ,
				note		=>	"<input type='submit' name='actlang' value='$activate'>  $lang_actlang");

	$ckapi[filter][] = array(criteria	=>	lang("Generate Traditional Chinese translation") ,
				type		=>	'input' ,
				varname		=>	'appl' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<input type='submit' name='translate' value='$translate'>  $lang_translate");

	$ckapi[filter][] = array(criteria	=>	lang("Number of dummy records to generate") ,
				type		=>	'input' ,
				varname		=>	'num_rec' ,
				defval		=>	"" ,
				note		=>	"<input type='submit' name='gen' value='$gen'>  $lang_gen");

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
