<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: controlreport.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ap' ;
	$tran = 'controlreport' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$repdate = ($_GET["repdate"]) ? $_GET["repdate"] : $_POST["repdate"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report','controlreport.tpl');
	$t->set_block('report','block1','block1_section');
	$t->set_block('report','block1a','block1a_section');
	$t->set_block('report','block2','block2_section');
	$t->set_block('report','block2a','block2a_section');

/*---------------------------------------------------------------------------------*/

	$note1 = lang('Note 1') ;
	$t->set_var('lang_control_report', lang('Accounts Payable Audit Control Report'));
	$t->set_var('lang_detail', lang('Detail'));
	$t->set_var('lang_note', lang('Note'));
	$t->set_var('lang_date', lang('Date'));
	$t->set_var('lang_vendor', lang('Vendor'));
	$t->set_var('lang_tax', lang('Tax Type'));
	$t->set_var('lang_invoice', lang('Payable'));
	$t->set_var('lang_invoiceitem', lang('Invoice Item'));
	$t->set_var('lang_payment', lang('Payment'));
	$t->set_var('lang_requested_status', lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', lang('Status as of'));
	$t->set_var('lang_print_date', lang('Date Report Printed'));
	$t->set_var('lang_status_note', lang('(note the effect of postdated Invoices)'));
	$t->set_var('lang_note1',$note1);
	$t->set_var('lang_total_amount', lang('Total Amount'));
	$t->set_var('lang_total_netamount', lang('Total Amount (Net of Tax)'));
	$t->set_var('lang_total_tax', lang('Total Tax'));
	$t->set_var('lang_total_count', lang('Total Record Count'));
	$t->set_var('lang_latest_id', lang('Latest Audit Trail ID'));
	$note1a = lang('These lines are for control reconciliation purpose only') ;
	$note1b = lang('The figures represent an amalgamation of different currency amounts') ;
	$t->set_var('note1',"$note1 - $note1a. $note1b.");

/*-----------------Gather and Write Status Date Info---------------------------------*/

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}ap " ;
$sql.=	"WHERE transdate <= '$repdate' GROUP BY isocode ORDER BY isocode" ;
$phpgw->db->query($sql);
if ($phpgw->db->num_rows()==0)	$t->set_var('block1_section',"");

while ($phpgw->db->next_record()) {
	$t->set_var(array('isocode'	=> $phpgw->db->f('isocode'),
		'curr_amount'	=> $phpgw->db->f('curr_amount')  ));
	$t->parse('block1_section','block1',true);
	}

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}payment " ;
$sql.=	"WHERE transdate <= '$repdate' GROUP BY isocode ORDER BY isocode" ;
$phpgw->db->query($sql);
if ($phpgw->db->num_rows()==0)	$t->set_var('block1a_section',"");

while ($phpgw->db->next_record()) {
	$t->set_var(array('isocode'	=> $phpgw->db->f('isocode'),
		'curr_amount'	=> $phpgw->db->f('curr_amount')  ));
	$t->parse('block1a_section','block1a',true);
	}

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from ${pre}ap WHERE transdate<='$repdate'";
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_amount = $phpgw->db->f('amount') ;
$invoice_netamount = $phpgw->db->f('netamount') ;

$sql =	"SELECT sum((-qty)*cost-discount-tax1-tax2) as invoice_item_amount from ${pre}invoice a,${pre}ap b ";
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='t'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_netamount = $phpgw->db->f('invoice_item_amount') ;
$sql =	"SELECT sum((-qty)*cost-discount) as invoice_item_amount from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='f'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_netamount += $phpgw->db->f('invoice_item_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_tax = $phpgw->db->f('tax1')+$phpgw->db->f('tax2') ;

$sql =	"SELECT sum(amount) as amount from ${pre}payment WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$payment_amount = $phpgw->db->f('amount') ;

$sql =	"SELECT count(id) as count from ${pre}ap WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(a.id) as count from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count from ${pre}payment WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$payment_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id from ${pre}ap WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(a.id) as id from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id from ${pre}payment WHERE transdate <= '$repdate'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$payment_id = $phpgw->db->f('id') ;

$t->set_var('status_date',$repdate) ;
$t->set_var('invoice_amount',sprintf("%01.2f",$invoice_amount)) ;
$t->set_var('invoice_netamount',sprintf("%01.2f",$invoice_netamount)) ;
$t->set_var('invoice_item_netamount',sprintf("%01.2f",$invoice_item_netamount)) ;
$t->set_var('invoice_item_tax',sprintf("%01.2f",$invoice_item_tax)) ;
$t->set_var('payment_amount',sprintf("%01.2f",$payment_amount)) ;
$t->set_var('invoice_count',$invoice_count) ;
$t->set_var('invoice_item_count',$invoice_item_count) ;
$t->set_var('payment_count',$payment_count) ;
$t->set_var('invoice_id',$invoice_id) ;
$t->set_var('invoice_item_id',$invoice_item_id) ;
$t->set_var('payment_id',$payment_id) ;

/*-----------------Gather and Write Total System Info-----------------------------*/

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}ap " ;
$sql.=	"GROUP BY isocode ORDER BY isocode" ;
$phpgw->db->query($sql);
if ($phpgw->db->num_rows()==0)	$t->set_var('block2_section',"");

while ($phpgw->db->next_record()) {
	$t->set_var(array('isocode'	=> $phpgw->db->f('isocode'),
		'curr_amount'	=> $phpgw->db->f('curr_amount')  ));
	$t->parse('block2_section','block2',true);
	}

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}payment " ;
$sql.=	"GROUP BY isocode ORDER BY isocode" ;
$phpgw->db->query($sql);
if ($phpgw->db->num_rows()==0)	$t->set_var('block2a_section',"");

while ($phpgw->db->next_record()) {
	$t->set_var(array('isocode'	=> $phpgw->db->f('isocode'),
		'curr_amount'	=> $phpgw->db->f('curr_amount')  ));
	$t->parse('block2a_section','block2a',true);
	}

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from ${pre}ap " ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_amount = $phpgw->db->f('amount') ;
$invoice_netamount = $phpgw->db->f('netamount') ;

$sql =	"SELECT sum((-qty)*cost-discount-tax1-tax2) as invoice_item_amount from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE a.trans_id=b.id and b.taxincluded='t'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_netamount = $phpgw->db->f('invoice_item_amount') ;
$sql =	"SELECT sum((-qty)*cost-discount) as invoice_item_amount from ${pre}invoice a,${pre}ap b " ;
$sql.=	"WHERE a.trans_id=b.id and b.taxincluded='f'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_netamount += $phpgw->db->f('invoice_item_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}invoice a,${pre}ap b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_tax = $phpgw->db->f('tax1')+$phpgw->db->f('tax2') ;

$sql =	"SELECT sum(amount) as amount FROM ${pre}payment" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$payment_amount = $phpgw->db->f('amount') ;

$sql =	"SELECT count(id) as count FROM ${pre}vendor" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$vendor_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM ${pre}tax WHERE taxgroup='ap'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$tax_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM ${pre}ap" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(a.id) as count FROM ${pre}invoice a,${pre}ap b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_count = $phpgw->db->f('count') ;

$sql =	"SELECT count(id) as count FROM ${pre}payment" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$payment_count = $phpgw->db->f('count') ;

$sql =	"SELECT max(id) as id FROM ${pre}vendor" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$vendor_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM ${pre}tax WHERE taxgroup='ap'" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$tax_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM ${pre}ap" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(a.id) as id FROM ${pre}invoice a,${pre}ap b WHERE a.trans_id=b.id" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$invoice_item_id = $phpgw->db->f('id') ;

$sql =	"SELECT max(id) as id FROM ${pre}payment" ;
$phpgw->db->query($sql);
$phpgw->db->next_record();
$payment_id = $phpgw->db->f('id') ;

$t->set_var('print_date',date("Y-m-d")) ;
$t->set_var('sys_invoice_amount',sprintf("%01.2f",$invoice_amount)) ;
$t->set_var('sys_invoice_netamount',sprintf("%01.2f",$invoice_netamount)) ;
$t->set_var('sys_invoice_item_netamount',sprintf("%01.2f",$invoice_item_netamount)) ;
$t->set_var('sys_invoice_item_tax',sprintf("%01.2f",$invoice_item_tax)) ;
$t->set_var('sys_payment_amount',sprintf("%01.2f",$payment_amount)) ;
$t->set_var('sys_vendor_count',$vendor_count) ;
$t->set_var('sys_tax_count',$tax_count) ;
$t->set_var('sys_invoice_count',$invoice_count) ;
$t->set_var('sys_invoice_item_count',$invoice_item_count) ;
$t->set_var('sys_payment_count',$payment_count) ;
$t->set_var('sys_vendor_id',$vendor_id) ;
$t->set_var('sys_tax_id',$tax_id) ;
$t->set_var('sys_invoice_id',$invoice_id) ;
$t->set_var('sys_invoice_item_id',$invoice_item_id) ;
$t->set_var('sys_payment_id',$payment_id) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',$phpgw->link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report');
	ExecMethod('ck-api.process.process_footer') ;

?>
