<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.receipt.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class receipt {

//---- Receipt List SQL Formation

    function receipt_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$last10 = substr($where,strlen($where)-10,10) ;
	$fields = "transdate,name,rptnumber,remark,isocode,amount,a.id" ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$sql1 =	"SELECT $fields FROM ${pre}receipt a, ${pre}customer b WHERE 1=1 $where AND customer=b.id " ;
		$sql2 =	"SELECT $fields FROM ${pre}receipt a, ${pre}customer b,${pre}r_match c " ;
		$sql2.=	"WHERE 1=1 $where AND customer=b.id AND a.id=c.receiptid " ;
		$sql2.=	"GROUP BY $fields HAVING sum(s_amount)>=amount " ;
		if ($ckapi[hostsys][dbtype]=="mysql")	{
			$user = $ckapi[hostsys][username] ;
			$ckapi[params_sql][temp1] = $temp1 = "${pre}rpl1".$user.time() ;
			$ckapi[params_sql][temp2] = $temp2 = "${pre}rpl2".$user.time() ;
			$phpgw->db->query("CREATE TABLE $temp1 AS $sql1");
			$phpgw->db->query("CREATE TABLE $temp2 AS $sql2");
			$sql = "SELECT $temp1.* from $temp1 LEFT JOIN $temp2 " ;
			$sql.= "ON $temp1.id=$temp2.id WHERE $temp2.id IS NULL ORDER BY $order $sort" ;
			}
			else	$sql="$sql1 EXCEPT $sql2 ORDER BY $order $sort" ;
		}
	else	$sql = "SELECT $fields FROM ${pre}receipt a,${pre}customer b WHERE 1=1 $where AND customer=b.id ORDER BY $order $sort";
	return $sql ;
	}

//---- Receipt List Link Adjustement

    function receipt_list_adjust() {
	global $ckapi,$phpgw ;

	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	$getstr = "order=$order&sort=$sort&id=$dt[id]&filter=$filter" ;
	$t->set_var('bulk_action',$phpgw->link("/$app/${tran}bulk.php",$getstr)) ;
	$disabled = ($dt[id]=="") ? "disabled" : "" ;
	$t->set_var('disabled',$disabled) ;
	}

//---- Receipt Data Read

    function receipt_read() {
	global $ckapi ;

	$op = $ckapi[params_post][op] ;
	$this->receipt_header_read() ;
	if ($op<>'copy')			$this->receipt_allotted_read() ;
	$this->receipt_pending_read() ;
	$ckapi[params_post][dt][oldcustomer] = $ckapi[params_post][dt][customer] ;
	$ckapi[params_post][dt][oldisocode] = $ckapi[params_post][dt][isocode] ;
	$ckapi[params_post][dt][oldamount] = $ckapi[params_post][dt][amount] ;
	return $ckapi[params_post][dt] ;
	}

//---- Receipt Data Header Read

    function receipt_header_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$dt = &$ckapi[params_post][dt] ;

	$phpgw->db->query("SELECT * FROM ${pre}receipt WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	}

//---- Receipt Data (Allotment) Read

    function receipt_allotted_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$dt = &$ckapi[params_post][dt] ;

	$id = ($id=="") ? 0 : $id ;
	$sql = "SELECT invnumber,id,duedate,amount,s_amount FROM ${pre}ar, ${pre}r_match " ;
	$sql .= "WHERE receiptid='$id' and id=invoiceid and customer='$dt[customer]' and isocode='$dt[isocode]'";
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['pinvnumber'.$i]	=	$phpgw->db->f('invnumber') ;
		$dt['pinvoiceid'.$i]	=	$phpgw->db->f('id') ;
		$dt['pduedate'.$i]	=	$phpgw->db->f('duedate') ;
		$dt['pinvoiceamt'.$i]	=	$phpgw->db->f('amount') ;
		$dt['ps_amount'.$i]	=	$phpgw->db->f('s_amount') ;
		$dt['pnewsamount'.$i]	=	"" ;
		}
	}

//---- Receipt Data (Pending) Read

    function receipt_pending_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = &$ckapi[params_post][dt] ;
	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}rp1".$user.time() ;
	$temp2 = "${pre}rp2".$user.time() ;
	if ($dt[customer]=='')			$dt[customer]=0 ;
	$fields = "invnumber,id,duedate" ;
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.= "SELECT $fields,amount,0.0 as s_amount,0.0 as paidamount " ;
	$sql.= "FROM ${pre}ar WHERE customer='$dt[customer]' and isocode='$dt[isocode]'";
	$phpgw->db->query($sql);
	$id = ($id=="") ? 0 : $id ;
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT $fields,0.0 as amount,s_amount,0.0 as paidamount " ;
	$sql.= "FROM ${pre}ar, ${pre}r_match WHERE id=invoiceid and receiptid='$id'";
	$phpgw->db->query($sql);
	$sql = "INSERT INTO $temp1 " ;
	$sql.= "SELECT $fields,0.0 as amount,0.0 as s_amount,sum(s_amount) as paidamount " ;
	$sql.= "FROM ${pre}ar a, ${pre}r_match b ";
	$sql.= "WHERE customer='$dt[customer]' and a.id=b.invoiceid GROUP BY $fields";
	$phpgw->db->query($sql);
	$sql = "CREATE TABLE $temp2 AS " ;
	$sql.= "SELECT $fields,sum(amount) as amount,sum(s_amount) as s_amount,sum(paidamount) as paidamt " ;
	$sql.= "FROM $temp1 GROUP BY $fields ";
	$phpgw->db->query($sql);
	$sql = "SELECT * FROM $temp2 WHERE amount > paidamt ORDER BY invnumber" ;
	$phpgw->db->query($sql) ;
	For ($i=1;$phpgw->db->next_record();$i++) {
		$upinvoiceamt		=	$phpgw->db->f('amount') ;
		$uppaidamount		=	$phpgw->db->f('paidamt') ;
		$dt['upinvnumber'.$i]	=	$phpgw->db->f('invnumber') ;
		$dt['upinvoiceid'.$i]	=	$phpgw->db->f('id') ;
		$dt['upduedate'.$i]	=	$phpgw->db->f('duedate') ;
		$dt['upinvoiceamt'.$i]	=	$upinvoiceamt ;
		$s_amount = ($op=='add' or $op=='copy') ? 0 : $phpgw->db->f('s_amount') ;
		$dt['ups_amount'.$i]	=	$s_amount ;
		$dt['ups_othamt'.$i]	=	$uppaidamount - $s_amount ;
		$dt['uppaidamount'.$i]	=	$uppaidamount ;
		$dt['uposamount'.$i]	=	$upinvoiceamt - $uppaidamount ;
		}
	$phpgw->db->query("DROP TABLE $temp1, $temp2");
	}

//---- Receipt Data Transformation

    function receipt_transform() {
	global $ckapi ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$customer = $dt[customer] ;
	$oldcustomer = $dt[oldcustomer] ;
	$isocode = $dt[isocode] ;
	$oldisocode = $dt[oldisocode] ;
	$amount = $dt[amount] ;
	$oldamount = $dt[oldamount] ;

	if ($customer<>$oldcustomer or $isocode<>$oldisocode) {
		$dt = "" ;
		$dt[isocode] = $isocode ;
		$dt[customer] = $customer ;
		if ($op=='edit')	$this->receipt_allotted_read() ;
		$this->receipt_pending_read() ;
		if ($customer<>$oldcustomer and $oldcustomer<>"") {
			$msg1 = lang("Customer has been changed or newly picked") ;
			$msg2 = lang("All matchings start afresh");
			$t->set_var('message1',"<b>$msg1.  $msg2.</b>") ;
			}
		if ($isocode<>$oldisocode) {
			$msg1 = lang('Currency changed') ;
			$msg2 = lang('Default exchange rate loaded') ;
			$msg3 = lang('%1 invoices loaded',$isocode) ;
			$msg4 = lang('All matchings start afresh') ;
			$t->set_var('message1',"<b>$msg1.  $msg2.  $msg3.  $msg4.</b>");
			}
		unset($move, $match_equal, $match_fifo, $clear, $post) ;
		foreach ($ckapi[buttons] as $key => $value)	$ckapi[buttons][$key] = "" ;
		}
	if ($amount<>$oldamount) {
		$this->match_clear() ;
		$msg1 = lang("Receipt amount has been changed") ;
		$msg2 = lang("All matchings start afresh") ;
		$t->set_var('message1',"<b>$msg1.  $msg2.</b>") ;
		unset($move, $match_equal, $match_fifo, $clear, $post) ;
		foreach ($ckapi[buttons] as $key => $value)	$ckapi[buttons][$key] = "" ;
		$dt[move] = "" ;
		}
	if (isset($clear))		{$msg = $this->match_clear() ; $t->set_var('message1',$msg) ;}
	if (isset($match_equal))	{$msg = $this->match_equal() ; $t->set_var('message1',$msg) ;}
	if (isset($match_fifo))		{$msg = $this->match_fifo() ; $t->set_var('message1',$msg) ;}
	}

//---- Receipt Add Initialisation

    function receipt_add_init() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$dt[transdate] = date("Y-m-d") ;
	$phpgw->db->query("SELECT nativecurr FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$dt[isocode] = $dt[oldisocode] = $phpgw->db->f('nativecurr') ;
	$dt[exrate] = 1 ;
	$this->receipt_pending_read() ;
	}

//---- Receipt Detail Validation Checks

    function receipt_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	$row = lang("Row") ;
	if ($dt[rptnumber]=="")			$err=lang("Receipt Number Missing");
	if (input2date($dt[transdate])=="")	$err=lang("Invalid Receipt Date");
	if (!is_numeric($dt[amount]))		$err=lang("Receipt amount must be numeric");
	if ($dt[exrate]<=0)			$err=lang("Invalid Exchange Rate") ;
	$phpgw->db->query("SELECT nativecurr FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	if ($dt[isocode]==$phpgw->db->f('nativecurr') and $dt[exrate]<>1)
					$err=lang("Exchange rate for ledger currency must = 1") ;
	$phpgw->db->query("SELECT * FROM ${pre}currency WHERE isocode='$dt[isocode]'");
	$phpgw->db->next_record() ;
	$nativeexrate = $phpgw->db->f('exrate') ;
	if ($nativeexrate>0) {
		$ratio = $dt[exrate]/$nativeexrate ;
		if (0.8>$ratio or $ratio>1.2)	$err=lang("Exchange rate deviates too much from default");
		}
	$sum_pnewsamt = 0 ;
	For ($i=1;isset($dt['pinvoiceid'.$i]);$i++) {
		$pnewsamt = $dt['pnewsamount'.$i] ;
		$rowi = "[$row $i]" ;
		if ($pnewsamt<0)		$err=$rowi.lang("New Amount Settled must be +ve");
		if ($pnewsamt>$dt[amount])	$err=$rowi.lang("New Amount Settled > Receipt Amount");
		if ($pnewsamt>$dt['pinvoiceamt'.$i]) $err=$rowi.lang("New Amount Settled > Invoice Amount");
		if (!is_numeric($pnewsamt) and strlen($pnewsamt)>0)
						$err=$rowi.lang("New Amount Settled must be numeric");
		$sum_pnewsamt += ($pnewsamt=="") ? $dt['ps_amount'.$i] : $pnewsamt ;
		}
	if ($sum_pnewsamt>$dt[amount])		$err=lang("Total Amount Settled > Receipt Amount");
	For ($i=1;isset($dt['upinvoiceid'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		if ($dt['uposamount'.$i]<0)	$err=$rowi.lang("UNPAID invoice overpaid");
		}
	if ($dt[isocode]<>$dt[oldisocode]) {
		$warn1 = lang('Currency changed') ;
		$warn2 = lang('Default exchange rate loaded') ;
		$warn3 = lang('%1 invoices loaded',$dt[isocode]) ;
		$warn4 = lang('All matchings start afresh') ;
		$err = "$warn1;  $warn2;  $warn3;  $warn4" ;
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Receipt Header

    function receipt_header_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$phpgw->db->query("SELECT nativecurr FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$loc_for = ($phpgw->db->f('nativecurr')==$dt[isocode]) ? lang('Local') : lang('*** Foreign ***') ;
	if ($dt[isocode]<>$dt[oldisocode]) {
		$phpgw->db->query("SELECT exrate FROM ${pre}currency WHERE isocode='$dt[isocode]'");
		$phpgw->db->next_record() ;
		$dt[exrate] = $phpgw->db->f('exrate') ;
		}
	$t->set_var('lang_customer',lang('Customer'));
	$t->set_var('lang_rptnumber',lang('Receipt#'));
	$t->set_var('lang_cheque',lang('Cheque#'));
	$t->set_var('lang_id',lang('Audit Id:')." ");
	$t->set_var('lang_curr_receipt',lang('Currency Receipt'));
	$t->set_var('lang_loc_for',$loc_for);
	$t->set_var('lang_transdate',lang('Receipt Date'));
	$t->set_var('lang_remark',lang('Remark'));
	$t->set_var('lang_amount',lang('Receipt Amount'));
	$t->set_var('lang_drpostto',lang('Receipt Amount Dr to Account'));
	$t->set_var('lang_crpostto',lang('Receipt Amount Cr to Account'));
	$t->set_var('lang_isocode',lang('Currency'));
	$t->set_var('lang_exrate',lang('Exchange Rate'));
	$customer = $dt[customer] ;
	$t->set_var('customer',$customer) ;
	$t->set_var('oldcustomer',$customer) ;
	$t->set_var('customer_selectlist',customer_selectlist('',$customer)) ;
	$t->set_var('rptnumber',$dt[rptnumber]) ;
	$t->set_var('cheque',$dt[cheque]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('remark',$dt[remark]) ;
	$t->set_var('amount',$dt[amount]) ;
	$t->set_var('oldamount',$dt[amount]) ;
	$dr_acc_list = account_selectlist("WHERE link like '%AR_paid%'",$dt[dr_accno_id]);
	$t->set_var('dr_acc_selectlist',$dr_acc_list) ;
	$cr_acc_list = account_selectlist("WHERE link like '%AR:%' or link like '%AR'",$dt[cr_accno_id]);
	$t->set_var('cr_acc_selectlist',$cr_acc_list) ;
	$t->set_var('isocode_selectlist',isocode_selectlist('',$dt[isocode])) ;
	$t->set_var('oldisocode',$dt[isocode]) ;
	$t->set_var('exrate',$dt[exrate]) ;
	$t->parse('out','report',True);
	}

//---- Write Receipt Detail

    function receipt_detail_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$dt = &$ckapi[params_post][dt] ;
	$posted = &$ckapi[params_post][posted] ;
	$t = &$ckapi[objects][template] ;

	if ($op=="view" or $op=="delete")       $posted = True ;
	$t->set_block('report','paidlist','paidlist_section');
	$t->set_block('report','unpaidlist','unpaidlist_section');
	$moverow_ = lang('Move Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_pltitle',lang('List of Fully/Partially PAID %1 Invoices settled by this Receipt',$dt[isocode]));
	$t->set_var('lang_pinvnumber',lang('Invoice#'));
	$t->set_var('lang_pinvoiceid',lang('Invoice ID'));
	$t->set_var('lang_pduedate',lang('Due Date'));
	$t->set_var('lang_pfullamount',lang('Full Invoice Amount'));
	$t->set_var('lang_psettled',lang('Amount Settled<br>via this Receipt'));
	$t->set_var('lang_pnewsamount',lang('Amount Settled via this<br>Receipt to be Updated to'));
	$sum_pinvoiceamt = $sum_ps_amount = $sum_pnewsamt = 0 ;
	For ($i=1;isset($dt['pinvoiceid'.$i]);$i++) {
		$t->set_var('pinvnumber_fld','pinvnumber'.$i);
		$t->set_var('pinvoiceid_fld','pinvoiceid'.$i);
		$t->set_var('pduedate_fld','pduedate'.$i);
		$t->set_var('pinvoiceamt_fld','pinvoiceamt'.$i);
		$t->set_var('ps_amount_fld','ps_amount'.$i) ;
		$t->set_var('pnewsamount_fld','pnewsamount'.$i);
		$t->set_var('pinvnumber',$dt['pinvnumber'.$i]) ;
		$pinvoiceid = $dt['pinvoiceid'.$i] ;
		$t->set_var('pinvoiceid',$pinvoiceid) ;
		$t->set_var('pduedate',$dt['pduedate'.$i]) ;
		$t->set_var('pinvoiceamt',$dt['pinvoiceamt'.$i]) ;
		$t->set_var('ps_amount',$dt['ps_amount'.$i]) ;
		$pnewsamount = $dt['pnewsamount'.$i] ;
		if (is_numeric($pnewsamount))		$t->set_var('pnewsamount',"") ;
			else				$t->set_var('pnewsamount',$pnewsamount) ;
		if (strlen($pnewsamount)>0 and is_numeric($pnewsamount)) {
			For ($j=1;isset($dt['upinvoiceid'.$j]);$j++) {
				if ($pinvoiceid==$dt['upinvoiceid'.$j]) {
					$dt['ups_amount'.$j] = $pnewsamount ;
					$dt['uppaidamount'.$j]= $dt['ups_amount'.$j] + $dt['ups_othamt'.$j];
					$dt['uposamount'.$j]=$dt['upinvoiceamt'.$j] - $dt['uppaidamount'.$j] ;
					break ;
					}
				}
			if (!isset($dt['upinvoiceid'.$j])) {
				$user = $ckapi[hostsys][username];
				$tmp = "${pre}rpt".$user.time() ;
				$fields = "invnumber,id,duedate,amount" ;
				$sql = "CREATE TABLE $tmp AS SELECT $fields," ;
				$sql.=		"0.0 as s_amount,sum(s_amount) as paidamt " ;
				$sql.=	"FROM ${pre}ar,${pre}r_match " ;
				$sql.=	"WHERE id='$pinvoiceid' and invoiceid='$pinvoiceid' GROUP BY $fields";
				$phpgw->db->query($sql);
				$sql = "INSERT INTO $tmp " ;
				$sql.= "SELECT $fields,s_amount,0.0 as paidamt FROM ${pre}ar,${pre}r_match ";
				$sql.=	"WHERE id='$pinvoiceid' and " ;
				$sql.=		"invoiceid='$pinvoiceid' and receiptid='$dt[id]' " ;
				$phpgw->db->query($sql);
				$sql = "SELECT $fields,sum(s_amount) as s_amount,sum(paidamt) as paidamt " ;
				$sql.=	"FROM $tmp GROUP BY $fields " ;
				$phpgw->db->query($sql) ;

				$phpgw->db->next_record() ;
				$dt['upinvnumber'.$j]	= $phpgw->db->f('invnumber') ;
				$dt['upinvoiceid'.$j]	= $phpgw->db->f('id') ;
				$dt['upduedate'.$j]	= $phpgw->db->f('duedate') ;
				$dt['upinvoiceamt'.$j]	= $phpgw->db->f('amount') ;
				$dt['ups_amount'.$j]	= $pnewsamount ;
				$dt['ups_othamt'.$j]	= $phpgw->db->f('paidamt')-$phpgw->db->f('s_amount');
				$dt['uppaidamount'.$j]	= $dt['ups_amount'.$j] + $dt['ups_othamt'.$j] ;
				$dt['uposamount'.$j]	= $dt['upinvoiceamt'.$j] - $dt['uppaidamount'.$j] ;

				$sql = "DROP TABLE $tmp" ;
				$phpgw->db->query($sql);
				}
			$t->set_var('ps_amount',$pnewsamount) ;
			$dt['ps_amount'.$i] = $pnewsamount ;
			}
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('paidlist_section','paidlist', True);
		$sum_pinvoiceamt	+= $dt['pinvoiceamt'.$i] ;
		$sum_ps_amount		+= $dt['ps_amount'.$i] ;
		}
	if ($i==1)	$t->set_var('paidlist_section',"");
	$movrowno = intval(str_replace($moverow_,"",$dt[move])) ;
	if ($movrowno<>0) {
		$t->set_var('pinvnumber_fld','pinvnumber'.$i);
		$t->set_var('pinvoiceid_fld','pinvoiceid'.$i);
		$t->set_var('pduedate_fld','pduedate'.$i);
		$t->set_var('pinvoiceamt_fld','pinvoiceamt'.$i);
		$t->set_var('ps_amount_fld','ps_amount'.$i) ;
		$t->set_var('pnewsamount_fld','pnewsamount'.$i);
		$t->set_var('pinvnumber',$dt['upinvnumber'.$movrowno]) ;
		$t->set_var('pinvoiceid',$dt['upinvoiceid'.$movrowno]) ;
		$t->set_var('pduedate',$dt['upduedate'.$movrowno]) ;
		$t->set_var('pinvoiceamt',$dt['upinvoiceamt'.$movrowno]) ;
		$t->set_var('ps_amount',0) ;
		$t->set_var('pnewsamount',"") ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('paidlist_section','paidlist', True);
		$sum_pinvoiceamt	+= $dt['upinvoiceamt'.$movrowno] ;
		}
	$msg = ($dt[amount]>$sum_ps_amount) ? lang("[Receipt underallocated to Invoice]") : "" ;
	$t->set_var('lang_total',lang('Total Amount')." ".$msg);
	$t->set_var('sum_pinvoiceamt',$sum_pinvoiceamt);
	$t->set_var('sum_ps_amount',$sum_ps_amount);
	$t->set_var('sum_pnewsamt',$sum_pnewsamt);
	$t->set_var('lang_upltitle',lang('List of Fully/Partially UNPAID %1 Invoices accrued on this customer',$dt[isocode]));
	$t->set_var('lang_upinvnumber',lang('Invoice#'));
	$t->set_var('lang_upinvoiceid',lang('Invoice ID'));
	$t->set_var('lang_upduedate',lang('Due Date'));
	$t->set_var('lang_upfullamount',lang('Full Invoice Amount'));
	$t->set_var('lang_ups_amount',lang('Amount Settled via this Payment'));
	$t->set_var('lang_ups_othamt',lang('Amount Settled via other Payments'));
	$t->set_var('lang_uppaidamount',lang('Total Amount Settled'));
	$t->set_var('lang_uposamount',lang('Outstanding Unpaid Amount'));
	$t->set_var('lang_upmove2paid',lang('Move to Paid List'));
	For ($i=1;isset($dt['upinvoiceid'.$i]);$i++) {
		$t->set_var('upinvnumber_fld','upinvnumber'.$i);
		$t->set_var('upinvoiceid_fld','upinvoiceid'.$i);
		$t->set_var('upduedate_fld','upduedate'.$i);
		$t->set_var('upinvoiceamt_fld','upinvoiceamt'.$i);
		$t->set_var('ups_amount_fld','ups_amount'.$i);
		$t->set_var('ups_othamt_fld','ups_othamt'.$i);
		$t->set_var('uppaidamount_fld','uppaidamount'.$i) ;
		$t->set_var('uposamount_fld','uposamount'.$i);
		$t->set_var('upinvnumber',$dt['upinvnumber'.$i]) ;
		$t->set_var('upinvoiceid',$dt['upinvoiceid'.$i]) ;
		$t->set_var('upduedate',$dt['upduedate'.$i]) ;
		$t->set_var('upinvoiceamt',$dt['upinvoiceamt'.$i]) ;
		$t->set_var('ups_amount',$dt['ups_amount'.$i]) ;
		$t->set_var('ups_othamt',$dt['ups_othamt'.$i]) ;
		$t->set_var('uppaidamount',$dt['uppaidamount'.$i]) ;
		$t->set_var('uposamount',$dt['uposamount'.$i]) ;
		$t->set_var('rowno',$moverow_.$i) ;
		For ($j=1;isset($dt['pinvoiceid'.$j]);$j++) {
			if ($dt['upinvoiceid'.$i]==$dt['pinvoiceid'.$j]) $t->set_var('rowno',lang("already in the list"));
			}
		if ($movrowno==$i)	$t->set_var('rowno',lang("already in the list")) ;
		if ($posted)		$t->set_var('rowno',"done") ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('unpaidlist_section','unpaidlist', True);
		}
	if ($i==1)	$t->set_var('unpaidlist_section',"");
	}

//---- Perform Receipt/Invoice Matching on Balance Amount by Matching Equal Amount

    function match_equal() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;

	if (!isset($dt[upinvoiceid1]))	$message1 = lang("All Invoices already settled") ;
	   else {
		$temp = $dt ;
		For ($j=1;isset($dt['upinvoiceid'.$j]);$j++)	$duedate[$j] = $temp['upduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$dt['upinvnumber'.$j]	=	$temp['upinvnumber'.$key] ;
			$dt['upinvoiceid'.$j]	=	$temp['upinvoiceid'.$key] ;
			$dt['upduedate'.$j]	=	$val ;
			$dt['upinvoiceamt'.$j]	=	$temp['upinvoiceamt'.$key] ;
			$dt['ups_amount'.$j]	=	$temp['ups_amount'.$key] ;
			$dt['ups_othamt'.$j]	=	$temp['ups_othamt'.$key] ;
			$dt['uppaidamount'.$j]	=	$temp['uppaidamount'.$key] ;
			$dt['uposamount'.$j]	=	$temp['uposamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $dt[amount] ;
	For ($i=1;isset($dt['pinvoiceid'.$i]);$i++)	{
		$bal -= $dt['ps_amount'.$i] ;
		$dt['pnewsamount'.$i] = "" ;
		}
	if ($bal==0)	$message2 = lang("Receipt is alreadly fully allocated") ;
	   else {
		For ($j=1;isset($dt['upinvoiceid'.$j]);$j++) {
			if ($dt['uposamount'.$j]==$bal) {
				$dt['ups_amount'.$j] += $bal ;
				$dt['uppaidamount'.$j] += $bal ;
				$dt['uposamount'.$j]  = 0 ;
				$invoiceid = $dt['upinvoiceid'.$j] ;
				For ($i=1;isset($dt['pinvoiceid'.$i]);$i++) {
					if ($dt['pinvoiceid'.$i]==$invoiceid) {
						$dt['ps_amount'.$i] += $bal ;
						$dt['pnewsamount'.$i] = "" ;
						break ;
						}
					}
				if (!isset($dt['pinvoiceid'.$i])) {
					$dt['pinvnumber'.$i]	= $dt['upinvnumber'.$j] ;
					$dt['pinvoiceid'.$i]	= $dt['upinvoiceid'.$j] ;
					$dt['pduedate'.$i]	= $dt['upduedate'.$j] ;
					$dt['pinvoiceamt'.$i]	= $dt['upinvoiceamt'.$j];
					$dt['ps_amount'.$i]	= $bal ;
					$dt['pnewsamount'.$i]	= "" ;
					}
				break ;
				}
			}
		}
	if (isset($dt["upinvoiceid$j"]))
		$message3 = lang("Matching completed.  If result OK, click POST button to update.") ;
	$message = lang("No (equal) matching item found") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	if (isset($message3))		$message = $message3 ;
	return "<b>$message</b>" ;
	}

//---- Perform Receipt/Invoice Matching on Balance Amount by FIFO Scheme

    function match_fifo() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;

	if (!isset($dt[upinvoiceid1]))	$message1 = lang("All Invoices already settled") ;
	   else {
		$temp = $dt ;
		For ($j=1;isset($dt['upinvoiceid'.$j]);$j++)	$duedate[$j] = $temp['upduedate'.$j] ;
		asort($duedate) ;
		reset($duedate) ;
		$j = 1 ;
		while (list($key,$val)=each($duedate)) {
			$dt['upinvnumber'.$j]	=	$temp['upinvnumber'.$key] ;
			$dt['upinvoiceid'.$j]	=	$temp['upinvoiceid'.$key] ;
			$dt['upduedate'.$j]	=	$val ;
			$dt['upinvoiceamt'.$j]	=	$temp['upinvoiceamt'.$key] ;
			$dt['ups_amount'.$j]	=	$temp['ups_amount'.$key] ;
			$dt['ups_othamt'.$j]	=	$temp['ups_othamt'.$key] ;
			$dt['uppaidamount'.$j]	=	$temp['uppaidamount'.$key] ;
			$dt['uposamount'.$j]	=	$temp['uposamount'.$key] ;
			$j++ ;
			}
		}
	$bal = $dt[amount] ;
	For ($i=1;isset($dt['pinvoiceid'.$i]);$i++)	{
		$bal -= $dt['ps_amount'.$i] ;
		$dt['pnewsamount'.$i] = "" ;
		}

	if ($bal==0)	$message2 = lang("Receipt is alreadly fully allocated") ;
	   else	{
		For ($j=1;isset($dt['upinvoiceid'.$j]);$j++) {
			$uposamt = $dt['uposamount'.$j] ;
			if ($uposamt>0) {
				if ($bal>=$uposamt) {
					$dt['ups_amount'.$j] += $uposamt ;
					$dt['uppaidamount'.$j] += $uposamt ;
					$dt['uposamount'.$j]  = 0 ;
					$invoiceid = $dt['upinvoiceid'.$j] ;
					For ($i=1;isset($dt['pinvoiceid'.$i]);$i++) {
						if ($dt['pinvoiceid'.$i]==$invoiceid) {
							$dt['ps_amount'.$i] += $uposamt ;
							$dt['pnewsamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($dt['pinvoiceid'.$i])) {
						$dt['pinvnumber'.$i]	= $dt['upinvnumber'.$j] ;
						$dt['pinvoiceid'.$i]	= $invoiceid ;
						$dt['pduedate'.$i]	= $dt['upduedate'.$j] ;
						$dt['pinvoiceamt'.$i]	= $dt['upinvoiceamt'.$j];
						$dt['ps_amount'.$i]	+= $uposamt ;
						$dt['pnewsamount'.$i]	= "" ;
						}
					$bal -= $uposamt ;
					}
				   else {
					$dt['ups_amount'.$j] += $bal ;
					$dt['uppaidamount'.$j] += $bal ;
					$dt['uposamount'.$j]  -= $bal ;
					$invoiceid = $dt['upinvoiceid'.$j] ;
					For ($i=1;(isset($dt['pinvoiceid'.$i]) and $bal>0);$i++) {
						if ($dt['pinvoiceid'.$i]==$invoiceid) {
							$dt['ps_amount'.$i] += $bal ;
							$dt['pnewsamount'.$i] = "" ;
							break ;
							}
						}
					if (!isset($dt['pinvoiceid'.$i])) {
						$dt['pinvnumber'.$i]	= $dt['upinvnumber'.$j] ;
						$dt['pinvoiceid'.$i]	= $invoiceid ;
						$dt['pduedate'.$i]	= $dt['upduedate'.$j] ;
						$dt['pinvoiceamt'.$i]	= $dt['upinvoiceamt'.$j];
						$dt['ps_amount'.$i]	= $bal ;
						$dt['pnewsamount'.$i]	= "" ;
						}
					$bal = 0 ;
					}
				}
			}
		}
	$message = lang("Matching completed.  If result OK, click POST button to update.") ;
	if (isset($message1))		$message = $message1 ;
	if (isset($message2))		$message = $message2 ;
	return "<b>$message</b>" ;
	}

//---- Clear current on-screen Receipt/Invoice Matching

    function match_clear() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;

	For ($i=1;isset($dt['pinvoiceid'.$i]);$i++)	{
		$invoiceid = $dt['pinvoiceid'.$i] ;
		$psamt = $dt['ps_amount'.$i] ;
		For ($j=1;isset($dt['upinvoiceid'.$j]);$j++) {
			if ($dt['upinvoiceid'.$j]==$invoiceid) {
				$dt['ups_amount'.$j] = 0 ;
				$dt['uppaidamount'.$j] -= $psamt ;
				$dt['uposamount'.$j]  += $psamt ;
				break ;
				}
			}
		if (!isset($dt['upinvoiceid'.$j])) {
			$dt['upinvnumber'.$j]	=	$dt['pinvnumber'.$i] ;
			$dt['upinvoiceid'.$j]	=	$invoiceid ;
			$dt['upduedate'.$j]	=	$dt['pduedate'.$i] ;
			$dt['upinvoiceamt'.$j]	=	$dt['pinvoiceamt'.$i] ;
			$dt['ups_amount'.$j]	=	0 ;
			$dt['ups_othamt'.$j]	=	$dt['pinvoiceamt'.$i] - $psamt ;
			$dt['uppaidamount'.$j]	=	$dt['ups_othamt'.$j] ;
			$dt['uposamount'.$j]	=	$psamt ;
			}
		unset($dt['pinvoiceid'.$i]) ;
		}
	$message = lang("All (on-screen) matchings for current Receipt cleared") ;
	return "<b>$message</b>" ;
	}

//---- Receipt Post Initialisation

    function receipt_post_init() {
	global $ckapi ;

	$tran = $ckapi[params][tran] ;
	$dt = &$ckapi[params_post][dt] ;

	$dt[source] = "ARRT" ;
	$dt[description] = "AR: Receipt# $dt[rptnumber]" ;
	}

//---- Receipt Post - PreCommit Routine

    function receipt_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$op = &$ckapi[params_post][op] ;

	if (substr_count($ckapi[params_post][script],'acctran')>0)	{
		$phpgw->db->query("DELETE from ${pre}acc_trans where trans_id='$id'");
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$chart_id	=	$dt['accno'.$i];
			$attrib1	=	$dt['attrib1'.$i] ;
			$attrib2	=	$dt['attrib2'.$i] ;
			$attrib3	=	$dt['attrib3'.$i] ;
			$dr		=	$dt['dr'.$i] ;
			$cr		=	$dt['cr'.$i] ;
			if ($dr==0) $amount=$cr; else $amount=-$dr;
			$attrib1 = ($attrib1=="") ? 0 : $attrib1 ;
			$attrib2 = ($attrib2=="") ? 0 : $attrib2 ;
			$attrib3 = ($attrib3=="") ? 0 : $attrib3 ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id," ;
			$sql.= "attrib1,attrib2,attrib3,amount,transdate)" ;
			$sql.=	"VALUES ('$id','$chart_id'," ;
			$sql.= "'$attrib1','$attrib2','$attrib3','$amount','$dt[transdate]')" ;
			$phpgw->db->query($sql);
			}
		return ;
		}
	if ($op<>'new')	{
		$phpgw->db->query("DELETE from ${pre}acc_trans where trans_id='$id'");
		$phpgw->db->query("DELETE from ${pre}r_match where receiptid=$id");
		}
	if ($op<>'delete') {
		$led_amount = number_format($dt[amount]*$dt[exrate],2,".","") ;
		$sql1 = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) " ;
		$sql = "$sql1 VALUES('$id','$dt[dr_accno_id]','-$led_amount','$dt[transdate]')";
		$phpgw->db->query($sql);
		$sql = "$sql1 VALUES('$id','$dt[cr_accno_id]','$led_amount','$dt[transdate]')";
		$phpgw->db->query($sql);
		For ($i=1;isset($dt['pinvoiceid'.$i]);$i++) {
			$s_amt = $dt['pnewsamount'.$i]=="" ? $dt['ps_amount'.$i] : $dt['pnewsamount'.$i] ;
			if ($s_amt<>0) {
				$invid	= $dt['pinvoiceid'.$i] ;
				$sql = "INSERT INTO ${pre}r_match (receiptid,invoiceid,s_amount) " ;
				$sql.= "VALUES ('$id','$invid','$s_amt')";
				$phpgw->db->query($sql);
				}
			}
		}
	}

//---- Receipt Accounting Entries Reload (from receipt table)

    function receipt_reload() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * FROM ${pre}receipt WHERE id='$id'") ;
	$phpgw->db->next_record();
	$rptamt = number_format($phpgw->db->f('amount')*$phpgw->db->f('exrate'),2,".","") ;
	$dt['accno1']	=	$phpgw->db->f('dr_accno_id') ;
	$dt['dr1']	= 	sprintf("%01.2f",$rptamt) ;
	$dt['cr1']	= 	"" ;
	$dt['accno2']	=	$phpgw->db->f('cr_accno_id') ;
	$dt['dr2']	= 	"" ;
	$dt['cr2']	= 	sprintf("%01.2f",$rptamt) ;
	return $dt;
	}

    }

?>
