<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: so2invfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ar' ;
	$tran = 'so2inv' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$title = lang("Choose Customer and then the relevant Sales Order to convert :") ;
	$ckapi[phrases] = array('lang_title'	=> $title ,
				'lang_criteria'	=> lang("Action Parameters") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Action") ,
				'lang_add'	=> lang("Return to Index Page") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$target_customer = lang('Select the target customer') ;
	$target_so = lang('Select the target Sales Order') ;
	$note1 = lang("If wrong parameters chosen, click [Convert SO to Invoice] to restart.") ;
	$note1a = lang("Press [Start Action] one more time to start SO conversion.") ;
	$note2	= lang("Blank SO list means no SO relevant to the choosen customer is found") ;
	if ($_POST[customer]=="")	$_POST[customer] = 0 ;

	$ckapi[filter][] = array(criteria	=>	lang('Which Customer') ,
				type		=>	'select' ,
				selectlist	=>	"" ,
				varname		=>	'customer' ,
				defval		=>	'' ,
				note		=>	"$target_customer<br>$note1" 	) ;

	$ckapi[filter][] = array(criteria	=>	lang('Which Sales Order') ,
				type		=>	'select' ,
				selectlist	=>	so_selectlist("WHERE customer='$_POST[customer]'",''),
				varname		=>	'id' ,
				defval		=>	'' ,
				note		=>	"$target_so<br>$note2"		) ;

	$ckapi[filter][actlist] = array (	1=>	customer_selectlist('','')	) ;
	$ckapi[filter][actstring] = array(	"0",	/* initial entry	*/
						"01"					) ;
	if ($_POST[customer]<>"") {
		$_POST[actnum] = 1 ;
		$ckapi[filter][actlist] = array(1=>customer_selectlist("WHERE id='$_POST[customer]'",'')) ;
		$ckapi[filter][0][note] = "$note1a<br>$note1" ;
		}

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
