<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.ledger.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class ledger {

//---- Ledger Item List SQL Formation

    function ledger_list_sql() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_bankac',lang('Bank Account'));
	list($dummy,$chart_id) = explode("'",$where) ;
	$phpgw->db->query("SELECT accno,description FROM ${pre}chart WHERE id='$chart_id'");
	$phpgw->db->next_record() ;
	$bankac = $phpgw->db->f('accno')."--".$phpgw->db->f('description') ;
	$t->set_var('bankac',$bankac);

	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter = urlencode(urldecode(stripslashes($filter))) ;

	$t->set_var('filter',$filter);
	$t->set_var('sort',$sort);
	$t->set_var('order',$order);
	$t->set_var('lang_done',lang('Done'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran}filter.php"));

	$sql =  "SELECT * FROM ${pre}bkr_trans " ;
	$sql.=	"WHERE substring(source,1,2)<>'SI' and substring(source,1,2)<>'SU' $where ORDER BY ".$order." ".$sort ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0)		$t->set_var('disabled','disabled');

	return $sql ;
	}

//---- Ledger Item List Link Adjustement

    function ledger_list_adjust() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params_list][dt] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('status',"");
	if ($status=="c")		$t->set_var('status',lang('Cleared'));
	if ($status=="s")		$t->set_var('status',lang('Stopped'));
	}

//---- Ledger Item Read

    function ledger_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$phpgw->db->query("select * from ${pre}bkr_trans where trans_id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	return $dt ;
	}

//---- Ledger Item Detail Validation Checks

    function ledger_validate() {
	global $ckapi,$pre,$phpgw ;

	$err=""; $error=lang('Error') ;
	$user = $ckapi[hostsys][username];
	$lockwhere = "WHERE resource='bankledgerbulk'" ;
	$phpgw->db->query("SELECT * FROM ${pre}resourcelock $lockwhere");
	$phpgw->db->next_record() ;
	$used_by = $phpgw->db->Record['used_by'] ;
	if ($used_by=="")	$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' $lockwhere");
	  else	$err = lang("Bank Rec. Ledger Item [Bulk] Update/Edit/Delete is being accessed by ").$used_by;
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Ledger Item Delete Validation Checks

    function delete_validate() {
	global $ckapi,$pre,$phpgw ;

	$err=""; $error=lang('Error') ;
	$user = $ckapi[hostsys][username];
	$lockwhere = "WHERE resource='bankledgerbulk'" ;
	$phpgw->db->query("SELECT * FROM ${pre}resourcelock $lockwhere");
	$phpgw->db->next_record() ;
	$used_by = $phpgw->db->Record['used_by'] ;
	if ($used_by=="")	$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' $lockwhere");
	  else	$err = lang("Bank Rec. Ledger Item [Bulk] Update/Edit/Delete is being accessed by ").$used_by;
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Ledger Item Detail

    function ledger_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_transdate',lang('Ledger Date'));
	$t->set_var('lang_refnumber',lang('Ref Number'));
	$t->set_var('lang_cheque',lang('Cheque Number'));
	$t->set_var('lang_amount',lang('Amount'));
	$t->set_var('lang_status',lang('Status'));
	$t->set_var('lang_source',lang('Source'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_id',lang('ID#'));

	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('transdate',$dt[transdate]);
	$t->set_var('refnumber',$dt[refnumber]);
	$t->set_var('cheque',$dt[cheque]);
	$t->set_var('amount',$dt[amount]);
	$t->set_var('status',$dt[status]);
	$t->set_var('source',$dt[source]);
	$t->set_var('description',$dt[description]);
	$status_sl = str_replace("'$dt[status]'","'$dt[status]'"." selected",status_selectlist() ) ;
	$t->set_var('status_selectlist',$status_sl);

	$t->parse('out','report',True);
	}

    function ledger_post_postcommit() {
	global $pre,$phpgw ;

	$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='bankledgerbulk'");
	}

    }

?>
