<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.rights.inc.php,v 0.11.1 2004/12/31 C K Wu $ */

    class rights {

//---- Rights List SQL Formation

    function rights_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$phpgw->db->query("SELECT * from ${pre}defaults");
	$phpgw->db->next_record();
	$attrib1cap = $phpgw->db->f('attrib1cap') ;
	$attrib2cap = $phpgw->db->f('attrib2cap') ;
	$attrib3cap = $phpgw->db->f('attrib3cap') ;
	$attrib1tbl = $phpgw->db->f('attrib1tbl') ;
	$attrib2tbl = $phpgw->db->f('attrib2tbl') ;
	$attrib3tbl = $phpgw->db->f('attrib3tbl') ;
	$user = $ckapi[hostsys][username];
	$temp = "${pre}rl".$user.time() ;
	$phpgw->db->query("CREATE TABLE $temp (caption text,rtable text)");
	$phpgw->db->query("INSERT INTO $temp (caption,rtable) VALUES ('$attrib1cap', '$attrib1tbl')");
	$phpgw->db->query("INSERT INTO $temp (caption,rtable) VALUES ('$attrib2cap', '$attrib2tbl')");
	$phpgw->db->query("INSERT INTO $temp (caption,rtable) VALUES ('$attrib3cap', '$attrib3tbl')");
	$sql =  "SELECT a.*,caption as attribute FROM ${pre}rights a,$temp b " ;
	$sql.=	"WHERE $where AND module='ck-css' AND a.rtable=b.rtable ORDER BY $order $sort";
	$ckapi[params_sql][temp] = $temp ;
	return $sql ;
	}

//---- Rights Read

    function rights_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$uniqueflds = $ckapi[params][uniqueflds] ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("SELECT * from ${pre}rights WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$phpgw->db->query("SELECT * from ${pre}defaults");
	$phpgw->db->next_record();
	$attribarr = array (	$phpgw->db->f('attrib1tbl') => $phpgw->db->f('attrib1cap'),
				$phpgw->db->f('attrib2tbl') => $phpgw->db->f('attrib2cap'),
				$phpgw->db->f('attrib3tbl') => $phpgw->db->f('attrib3cap')	) ;
	$attribtbl = $dt[rtable] ;
	$dt[attribute] = $attribarr[$attribtbl] ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Rights Detail Validation Checks

    function rights_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;

	$phpgw->db->query("SELECT * from ${pre}defaults");
	$phpgw->db->next_record();
	$attrib1cap = $phpgw->db->f('attrib1cap') ;
	$attrib2cap = $phpgw->db->f('attrib2cap') ;
	$attrib3cap = $phpgw->db->f('attrib3cap') ;
	$attrib1tbl = $phpgw->db->f('attrib1tbl') ;
	$attrib2tbl = $phpgw->db->f('attrib2tbl') ;
	$attrib3tbl = $phpgw->db->f('attrib3tbl') ;
	$attrib1sdesc = $phpgw->db->f('attrib1sdesc') ;
	$attrib2sdesc = $phpgw->db->f('attrib2sdesc') ;
	$attrib3sdesc = $phpgw->db->f('attrib3sdesc') ;

	$attribarr = array (	"$attrib1cap" => "$attrib1tbl",
				"$attrib2cap" => "$attrib2tbl",
				"$attrib3cap" => "$attrib3tbl"	) ;
	$attribsdesc = array (	"$attrib1cap" => "$attrib1sdesc",
				"$attrib2cap" => "$attrib2sdesc",
				"$attrib3cap" => "$attrib3sdesc"	) ;

	$err="";  $error=lang("Error") ;
	if ($dt[rgroup]=="")				$err=lang("User Group Missing") ;
	if ($dt[attribute]=="")				$err=lang("Attribute Missing");
	if ($dt[rvalue]=="")				$err=lang("Attribute Value Missing");
	$phpgw->db->query("SELECT * from phpgw_accounts where account_type='g' and account_firstname='$dt[rgroup]'");
	if ($phpgw->db->num_rows()<=0)			$err=lang("No such Host System Group exists") ;
	$caplist = "$attrib1cap,$attrib2cap,$attrib3cap" ;
	if (substr_count($caplist,$dt[attribute])<=0)	$err=lang("No such Attribute exists") ;
	  else	{
		$attribtbl = $attribarr[$dt[attribute]] ;
		$sdesc = $attribsdesc[$dt[attribute]] ;
		$phpgw->db->query("SELECT * from $attribtbl where $sdesc='$dt[rvalue]'");
		if ($phpgw->db->num_rows()<=0)		$err=lang("No such Attribute Value exists") ;
		if ($dt[rgroup]<>$dt[oldrgroup] or $dt[attribute]<>$dt[oldattribute] or $dt[rvalue]<>$dt[oldrvalue]) {
			$sql = "SELECT * from $table " ;
			$sql.= "WHERE rgroup='$dt[rgroup]' and module='ck-css' and " ;
			$sql.=		"rtable='$attribtbl' and rfield='$sdesc' and rvalue='$dt[rvalue]'" ;
			$phpgw->db->query($sql);
			if ($phpgw->db->num_rows()>0)	$err=lang("Group/Attribute/Value combination already exists");
			}
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;
	}

//---- Write Rights Detail

    function rights_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_rgroup',lang('User Group'));
	$t->set_var('lang_attribute',lang('Attribute'));
	$t->set_var('lang_rvalue',lang('Attribute Value'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val","old$val");
	$t->set_var('rgroup',$dt[rgroup]);
	$t->set_var('attribute',$dt[attribute]);
	$t->set_var('rvalue',$dt[rvalue]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->parse('out','report',True);
	}

//---- Rights Post Initialisation

    function rights_post_init() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$dt[module] = "ck-css" ;
	$phpgw->db->query("SELECT * from ${pre}defaults");
	$phpgw->db->next_record();
	$attribarr = array (	$phpgw->db->f('attrib1cap') => $phpgw->db->f('attrib1tbl'),
				$phpgw->db->f('attrib2cap') => $phpgw->db->f('attrib2tbl'),
				$phpgw->db->f('attrib3cap') => $phpgw->db->f('attrib3tbl')	) ;
	$attribsdesc = array (	$phpgw->db->f('attrib1cap') => $phpgw->db->f('attrib1sdesc'),
				$phpgw->db->f('attrib2cap') => $phpgw->db->f('attrib2sdesc'),
				$phpgw->db->f('attrib3cap') => $phpgw->db->f('attrib3sdesc')	) ;
	$dt[rtable] = $attribarr[$dt[attribute]] ;
	$dt[rfield] = $attribsdesc[$dt[attribute]] ;
	}

    }

?>
