<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: incomestatement.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-css' ;
	$tran = 'incomestatement' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$start_this_period = ($_GET["start_this_period"]) ? $_GET["start_this_period"] : $_POST["start_this_period"] ;
	$end_this_period = ($_GET["end_this_period"]) ? $_GET["end_this_period"] : $_POST["end_this_period"] ;
	$start_last_period = ($_GET["start_last_period"]) ? $_GET["start_last_period"] : $_POST["start_last_period"] ;
	$end_last_period = ($_GET["end_last_period"]) ? $_GET["end_last_period"] : $_POST["end_last_period"] ;
	$attrib1 = ($_GET["attrib1"]) ? $_GET["attrib1"] : $_POST["attrib1"] ;
	$attrib2 = ($_GET["attrib2"]) ? $_GET["attrib2"] : $_POST["attrib2"] ;
	$attrib3 = ($_GET["attrib3"]) ? $_GET["attrib3"] : $_POST["attrib3"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report', 'incomestatement.tpl') ;
	$t->set_block('report','income_row','income_section') ;
	$t->set_block('report','expense_row','expense_section') ;

/*---------------------------------------------------------------------------------*/

	$title = lang('Income Statement') ;
	if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
		$phpgw->db->query("Select * from ${pre}defaults");
		$phpgw->db->next_record();
		$a1cap = $phpgw->db->f('attrib1cap');	$a1tbl = $phpgw->db->f('attrib1tbl');	$a1ldf = $phpgw->db->f('attrib1ldesc');
		$a2cap = $phpgw->db->f('attrib2cap');	$a2tbl = $phpgw->db->f('attrib2tbl');	$a2ldf = $phpgw->db->f('attrib2ldesc');
		$a3cap = $phpgw->db->f('attrib3cap');	$a3tbl = $phpgw->db->f('attrib3tbl');	$a3ldf = $phpgw->db->f('attrib3ldesc');
		if ($attrib1<>'') {
			$phpgw->db->query("Select * from $a1tbl where id=$attrib1"); $phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a1ldf") ;
			$t->set_var('attrib1line',"$a1cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib1line',"");
		if ($attrib2<>'') {
			$phpgw->db->query("Select * from $a2tbl where id=$attrib2"); $phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a2ldf") ;
			$t->set_var('attrib2line',"$a2cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib2line',"");
		if ($attrib3<>'') {
			$phpgw->db->query("Select * from $a3tbl where id=$attrib3"); $phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a3ldf") ;
			$t->set_var('attrib3line',"$a3cap:  $ldesc<br>");
			}
		   else $t->set_var('attrib3line',"");
		}
	   else {
		$t->set_var('attrib1line',"");
		$t->set_var('attrib2line',"");
		$t->set_var('attrib3line',"");
		}
	$t->set_var('lang_income_statement', lang('Income Statement'));
	$t->set_var('lang_from',lang('From :').' ');
	$t->set_var('lang_to',lang('To :').' ');
	$t->set_var('lang_income', lang('INCOME'));
	$t->set_var('lang_total_income', lang('Total Income'));
	$t->set_var('lang_expense', lang('EXPENSES'));
	$t->set_var('lang_total_expense', lang('Total Expenses'));
	$t->set_var('lang_profit_loss', lang('TOTAL PROFIT/(LOSS) FOR THE PERIOD'));
	$t->set_var('start_this_period',$start_this_period);
	$t->set_var('start_last_period',$start_last_period);
	$t->set_var('end_this_period',$end_this_period);
	$t->set_var('end_last_period',$end_last_period);

	$user = $ckapi[hostsys][username];
	$temp1 = "${pre}gl1".$user.time() ;
	$temp2 = "${pre}gl2".$user.time() ;
	$temp3 = "${pre}gl3".$user.time() ;

/*-----------------Write Income Section----------------------------------------------*/

$select = "SELECT accno,b.description,sum(amount) as this_period, 0.00 as last_period " ;
$select.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
$where = "WHERE category='I' and a.transdate>='$start_this_period' and " ;
$where.= "a.transdate<='$end_this_period' and a.chart_id=b.id ";
if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
	$select .= ",${pre}gl c " ;
	$where  .= "and a.trans_id=c.id " ;
	}
if ($attrib1<>'')	$where .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$where .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$where .= " and attrib3=$attrib3 " ;
$sql =	"CREATE TABLE $temp2 AS " .$select.$where. "GROUP BY accno,b.description ORDER BY accno" ;
$phpgw->db->query($sql);

$select = "SELECT accno,b.description,0.00 as this_period, sum(amount) as last_period " ;
$select.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
$where = "WHERE category='I' and a.transdate>='$start_last_period' and " ;
$where.= "a.transdate<='$end_last_period' and a.chart_id=b.id ";
if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
	$select .= ",${pre}gl c " ;
	$where  .= "and a.trans_id=c.id " ;
	}
if ($attrib1<>'')	$where .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$where .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$where .= " and attrib3=$attrib3 " ;
$sql =	"CREATE TABLE $temp3 AS " .$select.$where. "GROUP BY accno,b.description ORDER BY accno" ;
$phpgw->db->query($sql);

$phpgw->db->query("INSERT INTO $temp2 (accno,description,this_period,last_period) SELECT * FROM $temp3");
$sql =  "CREATE TABLE $temp1 AS " .
	"SELECT description, sum(this_period) as this_period, sum(last_period) as last_period " .
		"from $temp2 group by accno, description order by accno" ;
$phpgw->db->query($sql);
$phpgw->db->query("SELECT * from $temp1");

if ($phpgw->db->num_rows()==0) {
	$t->set_var('income_account','') ;
	$t->set_var('income_this_period','-') ;
	$t->set_var('income_last_period','-') ;
	$t->parse('income_section','income_row',true);
	}
$thisperiod_total = 0;
$lastperiod_total = 0;
while ($phpgw->db->next_record()) {
	$account_name		= $phpgw->db->f('description');
	$this_period_amount	= sprintf("%01.2f",$phpgw->db->f('this_period'));
	$last_period_amount	= sprintf("%01.2f",$phpgw->db->f('last_period'));
	$thisperiod_total	+=$this_period_amount ;
	$lastperiod_total	+=$last_period_amount ;
	$t->set_var('income_account',$account_name) ;
	if ($this_period_amount==0) {$this_period_amount='-'; }
	if ($last_period_amount==0) {$last_period_amount='-'; }
	$t->set_var('income_this_period',$this_period_amount) ;
	$t->set_var('income_last_period',$last_period_amount) ;
	$t->parse('income_section','income_row',true);
	}

$t->set_var('total_income_this_period',sprintf("%01.2f",$thisperiod_total)) ;
$t->set_var('total_income_last_period',sprintf("%01.2f",$lastperiod_total)) ;
$total_income_this_period = $thisperiod_total ;
$total_income_last_period = $lastperiod_total ;

$phpgw->db->query("DROP TABLE $temp1");
$phpgw->db->query("DROP TABLE $temp2");
$phpgw->db->query("DROP TABLE $temp3");

/*--------------------Write Expense Section------------------------------------------*/

$select = "SELECT accno,b.description,sum(amount) as this_period, 0.00 as last_period " ;
$select.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
$where = "WHERE category='E' and a.transdate>='$start_this_period' and " ;
$where.= "a.transdate<='$end_this_period' and a.chart_id=b.id ";
if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
	$select .= ",${pre}gl c " ;
	$where  .= "and a.trans_id=c.id " ;
	}
if ($attrib1<>'')	$where .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$where .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$where .= " and attrib3=$attrib3 " ;
$sql =	"CREATE TABLE $temp2 AS " .$select.$where. "GROUP BY accno,b.description ORDER BY accno" ;
$phpgw->db->query($sql);

$select = "SELECT accno,b.description,0.00 as this_period, sum(amount) as last_period " ;
$select.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
$where = "WHERE category='E' and a.transdate>='$start_last_period' and " ;
$where.= "a.transdate<='$end_last_period' and a.chart_id=b.id ";
if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
	$select .= ",${pre}gl c " ;
	$where  .= "and a.trans_id=c.id " ;
	}
if ($attrib1<>'')	$where .= " and attrib1=$attrib1 " ;
if ($attrib2<>'')	$where .= " and attrib2=$attrib2 " ;
if ($attrib3<>'')	$where .= " and attrib3='$attrib3' " ;
$sql =	"CREATE TABLE $temp3 AS " .$select.$where. "GROUP BY accno,b.description ORDER BY accno" ;
$phpgw->db->query($sql);

$phpgw->db->query("INSERT INTO $temp2 (accno,description,this_period,last_period) SELECT * FROM $temp3");
$sql =  "CREATE TABLE $temp1 AS " .
	"SELECT description, sum(this_period) as this_period, sum(last_period) as last_period " .
		"from $temp2 group by accno, description order by accno" ;
$phpgw->db->query($sql);
$phpgw->db->query("SELECT * from $temp1");

if ($phpgw->db->num_rows()==0) {
	$t->set_var('expense_account','') ;
	$t->set_var('expense_this_period','-') ;
	$t->set_var('expense_last_period','-') ;
	$t->parse('expense_section','expense_row',true);
	}
$thisperiod_total = 0;
$lastperiod_total = 0;
while ($phpgw->db->next_record()) {
	$account_name		= $phpgw->db->f('description');
	$this_period_amount	= sprintf("%01.2f",-$phpgw->db->f('this_period'));
	$last_period_amount	= sprintf("%01.2f",-$phpgw->db->f('last_period'));
	if ($this_period_amount==0) {$this_period_amount='-'; }
	if ($last_period_amount==0) {$last_period_amount='-'; }
	$t->set_var('expense_account',$account_name) ;
	$thisperiod_total	+=$this_period_amount ;
	$lastperiod_total	+=$last_period_amount ;
	$t->set_var('expense_this_period',$this_period_amount) ;
	$t->set_var('expense_last_period',$last_period_amount) ;
	$t->set_var(array(	'expense_account'	=> $account_name,
				'expense_this_period'	=> $this_period_amount,
            	    		'expense_last_period'	=> $last_period_amount ));
	$t->parse('expense_section','expense_row',True);
	}
$t->set_var('total_expense_this_period',sprintf("%01.2f",$thisperiod_total)) ;
$t->set_var('total_expense_last_period',sprintf("%01.2f",$lastperiod_total)) ;

/*--------------------Write Profit/Loss Section------------------------------------------*/

$t->set_var('total_profit_loss_this_period',sprintf("%01.2f",$total_income_this_period-$thisperiod_total));
$t->set_var('total_profit_loss_last_period',sprintf("%01.2f",$total_income_last_period-$lastperiod_total));

$phpgw->db->query("DROP TABLE $temp1");
$phpgw->db->query("DROP TABLE $temp2");
$phpgw->db->query("DROP TABLE $temp3");

/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',$phpgw->link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',lang('Done'));
    $t->pparse('out','report',true);
	ExecMethod('ck-api.process.process_footer') ;

?>
