<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: header.inc.php,v 0.8.1 2004/03/31 C K Wu $ */
  
    $t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-hr'));
    $t->set_file(array('hr_header' => 'header.tpl'));
    $info1 = lang('Human Resources') ;
    $info2 = lang("You must read each module's index page in detail.") ;
    $info3 = lang("It contains the Terms & Conditions of usage and re-distribution.") ;
    $t->set_var('info',"$info1  [$info2  $info3]");
    $t->set_var('bg_color',$phpgw_info["theme"]["th_bg"]);
    $t->set_var('link_employee',$phpgw->link('/ck-hr/employeefilter.php'));
    $t->set_var('lang_employee',lang('Employee'));
    $t->set_var('link_attend',$phpgw->link('/ck-hr/attendfilter.php'));
    $t->set_var('lang_attend',lang('Attendance'));
    $t->set_var('link_timesheet',$phpgw->link('/ck-hr/timesheetfilter.php'));
    $t->set_var('lang_timesheet',lang('Timesheet'));
    $t->set_var('link_leaveapp',$phpgw->link('/ck-hr/leaveappfilter.php'));
    $t->set_var('lang_leaveapp',lang('Leave Application'));
    $t->set_var('link_dept',$phpgw->link('/ck-hr/deptfilter.php'));
    $t->set_var('lang_dept',lang('Department'));
    $t->set_var('link_activity',$phpgw->link('/ck-hr/activityfilter.php'));
    $t->set_var('lang_activity',lang('Activity (Code)'));
    $t->set_var('link_achievement',$phpgw->link('/ck-hr/achievefilter.php'));
    $t->set_var('lang_achievement',lang('Achievement (Code)'));
    $t->set_var('link_hrcode',$phpgw->link('/ck-hr/hrcodefilter.php'));
    $t->set_var('lang_hrcode',lang('HR Code/Abbreviation'));
    $t->set_var('link_report',$phpgw->link('/ck-hr/reportfilter.php'));
    $t->set_var('lang_report',lang('Report'));

	$readonly = False ;
	$phpgw->db->query("SELECT readonlygrp FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$readonlygrp = $phpgw->db->f('readonlygrp') ;
	$groups = ExecMethod('phpgwapi.accounts.membership') ;
	while (list($key,$value)=each($groups))
		if ($groups["$key"]['account_name']==$readonlygrp)	$readonly = True ;
	if ($readonly) {
		$t->set_var(array('link_employee'=>"", 'lang_employee'=>""));
		$t->set_var(array('link_attend'=>"", 'lang_attend'=>""));
		$t->set_var(array('link_timesheet'=>"", 'lang_timesheet'=>""));
		$t->set_var(array('link_leaveapp'=>"", 'lang_leaveapp'=>""));
		$t->set_var(array('link_dept'=>"", 'lang_dept'=>""));
		$t->set_var(array('link_activity'=>"", 'lang_activity'=>""));
		$t->set_var(array('link_achievement'=>"", 'lang_achievement'=>""));
		$t->set_var(array('link_hrcode'=>"", 'lang_hrcode'=>""));
		}

    $t->pparse('out','hr_header');
?>
