<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: gddn.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-inv' ;
	$tran = 'gd' ;
	$noheader = $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-inv'));
	$t->set_file(array('report'		=> 'gddn.tpl',
	                   'items'		=> 'gddn.tpl'));
	$t->set_block('items','item_row','item_section');

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=lang('Delivery Note (DN) Image (Use browser print function to output the DN shown above)');
	$t->set_var('lang_title',$title);
	$remark=lang('Please sign and return the duplicate of this Delivery Note to acknowledge receipt of the items listed above.<br><br><br><br><br><br><br>____________________________________________<br>Authorised Signature') ;
	$notes=lang('(This is a sample subject to tailoring per individual printer and DN format)');
	$t->set_var('charset',lang('charset'));
	$t->set_var('lang_notes',$notes);
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$logofile = $ckapi[hostsys][dataarea]."/images/logo.png" ;
	$t->set_var('logo',$phpgw->link("/ck-admin/logoview_image.php","imgfile=$logofile"));

/*------------- Write Payment to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;
	$currency = $phpgw->db->f('nativecurr') ;

	$phpgw->db->query("SELECT * FROM ${pre}il WHERE id='$id'");
	$phpgw->db->next_record();
	$customer = $phpgw->db->f('to_from') ;
	$transdate = $phpgw->db->f('transdate') ;
	$dnnumber = $phpgw->db->f('id') ;
	$transdate = date("d-m-Y",strtotime($transdate)) ;
	$duedate = date("d-m-Y",strtotime($duedate)) ;

	$phpgw->db->query("SELECT b.* FROM ${pre}customer a, ${pre}org b WHERE a.id='$customer' and contactid=b.id");
	if ($phpgw->db->next_record())	$name = $shiptoname = $phpgw->db->f('orgname') ;
	  else	{
		$phpgw->db->query("SELECT * FROM ${pre}customer a, ${pre}person b WHERE a.id='$customer' and contactid=b.id");
		$phpgw->db->next_record();
		$name = $shiptoname = strtoupper($phpgw->db->f('family'))." ".$phpgw->db->f('given') ;
		}
	$sql = "SELECT name,b.* FROM ${pre}customer a, ${pre}address b " ;
	$sql.= "WHERE a.id='$customer' and a.contactid=b.contactid and addresscode='billaddr'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$addr1 = $phpgw->db->f('line1') ;
	$addr2 = $phpgw->db->f('line2') ;
	$addr3 = $phpgw->db->f('line3') ;
	$addr4 = $phpgw->db->f('line4') ;
	$terms = $phpgw->db->f('terms') ;
	$sql = "SELECT name,b.* FROM ${pre}customer a, ${pre}address b " ;
	$sql.= "WHERE a.id='$customer' and a.contactid=b.contactid and addresscode='shipaddr'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$shiptoaddr1 = $phpgw->db->f('line1') ;
	$shiptoaddr2 = $phpgw->db->f('line2') ;
	$shiptoaddr3 = $phpgw->db->f('line3') ;
	$shiptoaddr4 = $phpgw->db->f('line4') ;

	$t->set_var('lang_dn',strtoupper(lang('DELIVERY NOTE')));
	$t->set_var('lang_transdate',lang('Delivery Note Date'));
	$t->set_var('lang_dnnumber',lang('DN Number'));
	$t->set_var('pattern','==========');
	$t->set_var('lang_billto',lang('Bill To:'));
	$t->set_var('lang_shipto',lang('Ship To:'));
	$t->set_var('lang_itemid',lang('Item ID'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_price',lang('Price'));
	$t->set_var('lang_discount',lang('Discount'));
	$t->set_var('lang_amount',lang('Amount'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('dnnumber',$dnnumber) ;
	$t->set_var('name',$name) ;
	$t->set_var('addr1',$addr1) ;
	$t->set_var('addr2',$addr2) ;
	$t->set_var('addr3',$addr3) ;
	$t->set_var('addr4',$addr4) ;
	$t->set_var('shiptoname',$shiptoname) ;
	$t->set_var('shiptoaddr1',$shiptoaddr1) ;
	$t->set_var('shiptoaddr2',$shiptoaddr2) ;
	$t->set_var('shiptoaddr3',$shiptoaddr3) ;
	$t->set_var('shiptoaddr4',$shiptoaddr4) ;

// ---------------------------- Begin list items -----------------------------------------

	$sql = "SELECT c.itemid,c.description,a.qty " ;
	$sql.= "FROM ${pre}inv_trans a,${pre}so b,${pre}oitem c " ;
	$sql.= "WHERE a.trans_id='$id' and a.order_id=b.id and b.id=c.trans_id and a.parts_id=c.itemid";
	$phpgw->db->query($sql);
	$total = 0 ;
	while ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$description = $phpgw->db->f('description') ;
		$qty = -$phpgw->db->f('qty') ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'description'	=> $description,
					'qty'		=> $qty )) ;
		$t->parse('item_section','item_row',true);
		}
	$t->set_var('lang_thank',lang("Thank you for your valued business!")) ;
	$t->set_var('lang_remark',$remark) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('email_action',$phpgw->link("/$app/${tran}list.php","filter=$filter")) ;
	$t->set_var('lang_email',lang('DONE'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php","filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','items',report);
	ExecMethod('ck-api.process.process_footer') ;

?>
