<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: ialist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-inv' ;
	$tran = 'ia' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}il"			);
	$ckapi[phrases] = array('lang_title'	=> lang("List of Inventory Adjustment (IA)") ,
				'lang_add'	=> lang("Add Inventory Adjustment") ,	);
	$ckapi[columns] = array('transdate'	=> lang('IA Date') ,
				'source'	=> lang('Source Info') ,
				'description'	=> lang('Description') ,
				'id'		=> lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'reverse'	=> "/$app/${tran}reverse.php" ,
				'delete'	=> "/$app/${tran}delete.php"	) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_reverse'	=> lang("Reverse") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")			) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;
	ExecMethod('ck-api.process.process_footer') ;

?>
