<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.ia.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class ia {

//---- Inventory Adjustment List SQL Formation

    function ia_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$sql =  "SELECT * from ${pre}il WHERE substring(source,1,2)='IA' $where order by ".$order." ".$sort;
	return $sql ;
	}

//---- Inventory Adjustment Read

    function ia_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("SELECT * from ${pre}il where id=$id");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$phpgw->db->query("SELECT * from ${pre}inv_trans WHERE trans_id='$id'");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['part'.$i]	=	$phpgw->db->f('parts_id') ;
		$dt['qty'.$i]	=	$phpgw->db->f('qty') ;
		if ($op=="reverse")	$dt['qty'.$i] = -$phpgw->db->f('qty') ;
		}
	if ($ckapi[params_post][op]=="view")	$dt[controltot] = lang("N/A") ;
	return $dt ;
	}

//---- Inventory Adjustment Add Initialisation

    function ia_add_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$dt['part1'] = $dt['qty1'] = "";
	}

//---- Inventory Adjustment Validation Checks

    function ia_validate() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	$date=input2date( $dt[transdate] ) ;
	if ($date=="")				$err=lang("Invalid Inventory Adjustment Date");
	if ($dt["description"]=="")		$err=lang("IA Description Missing") ;
	$totalqty = $totalamt = 0 ;
	For ($i=1;isset($dt['part'.$i]);$i++) {
		$row = lang("Row") ; $rowi = "[$row $i]" ;
		if ($dt['qty'.$i] and !is_numeric($dt['qty'.$i]))
						$err=$rowi.lang("Invalid Qty, must be numeric");
		if ($dt['qty'.$i]==0)		$err=$rowi.lang("Invalid Qty, must be non-zero");
		$totalqty += $dt['qty'.$i] ;
		}
	if ($totalqty<>$dt[controltot])	$err=lang("Qty Total <> Inputted Control Total");
	if ($err)	$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Inventory Adjustment Header

    function ia_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_date',lang('Date :'));
	$t->set_var('lang_source',lang('Source :'));
	$t->set_var('lang_description',lang('Description :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('source',$dt[source]) ;
	$t->set_var('description',$dt[description]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->parse('out','report',True);
	}

//---- Write Inventory Adjustment Detail

    function ia_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_parts',lang('Part Number -- Description -- ID'));
	$t->set_var('lang_qty',lang('Quantity (+ve: increase stock, -ve: decrease stock)'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$part_list = part_selectlist("",'') ;
	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($dt['part'.$i]);$i++) {
		if ($i<>$rowno) {
			$part	=	$dt['part'.$i] ;
			$qty	=	$dt['qty'.$i];
			$j = ($delete and $i>$rowno) ? $i-1 : $i ;
			$t->set_var('part_fld','part'.$j) ;
			$t->set_var('qty_fld','qty'.$j);
			$t->set_var('parts_list',str_replace("'$part'","'$part' selected",$part_list));
			$t->set_var('qty',$qty) ;
			if ($posted)	$t->set_var('rowno',"done");	else	$t->set_var('rowno',$row_.$j);
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('part_fld','part'.$i) ;
		$t->set_var('parts_list',$part_list);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('qty',"") ;
		$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_controltot',lang('Quantity Control Total'));
	$t->set_var('controltot',$dt[controltot]) ;

	$t->parse('out','report',True);
	}

//---- Inventory Adjustment Post Initialisation

    function ia_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][source] = "IA" ;
	if ($ckapi[params_post][op]=="reverse")	$ckapi[params_post][op]="new" ;
	}

//---- Inventory Adjustment Post - PreCommit Routine

    function ia_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')		$phpgw->db->query("DELETE from ${pre}inv_trans where trans_id='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['part'.$i]);$i++) {
			$part	= $dt['part'.$i];
			$qty	= $dt['qty'.$i];
			$sql = "INSERT INTO ${pre}inv_trans (trans_id,parts_id,qty,transdate)" ;
			$sql.= "VALUES ('$id','$part','$qty','$dt[transdate]')" ;
			$phpgw->db->query($sql);
			}
		}
	}

//---- Inventory Adjustment Post - PostCommit Routine

    function ia_post_postcommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi[phrases][lang_tran] ;
	$actioned = $ckapi[phrases][actioned] ;
	$acd = lang('ACD') ;
	$note = lang("Please carry out appropriate accounting adjustment") ;
	$inform = lang("Please manually inform") ;
	$from = lang("Inventory System") ;
	$noreply = lang("No-Reply-Address") ;

	$sql = "SELECT description,email FROM ${pre}department WHERE name='$acd'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$deptdesc = $phpgw->db->f('description');
	$acdemail = $phpgw->db->f('email');
	$recipient = "$deptdesc < $acdemail >" ;
	$subject = "$lang_tran [id#$id] $actioned.  $note." ;
	$message = '' ;
	$headers = "From: $from < $noreply >\n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$successmsg = lang("Email advising inventory adjustment action successfully queued for despatch to") ;
	$failuremsg=lang("Email advising inventory adjustment action fails to deliver.")."  $inform";
	if ($result)	$msg = "<br>$successmsg $deptdesc." ;
		else	$msg = "<br>$failuremsg $deptdesc." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}

    }

?>