<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: journalerrlist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ledger' ;
	$tran = 'journalerrlist' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file(array('report'=>'confirm.tpl',  'question'=>'confirm.tpl'));
	$title = lang("List of Journals with Anomalies") ;
	$comment = lang("By definition, this list should be empty") ;

/*------------- Print List ----------------------------*/

	echo "<br><br><B>$title</b><br><br>" ;
	$sql = "SELECT a.id,source,description,sum(amount) as amount FROM ${pre}gl a, ${pre}acc_trans b " ;
	$sql.= "WHERE a.id=trans_id GROUP BY a.id,trans_id,source,description" ;
	$phpgw->db->query($sql);

	while ($phpgw->db->next_record()) {
		$amount = sprintf("%01.2f",$phpgw->db->f('amount')) ;
		if ($amount==0)		continue ;
		$id = $phpgw->db->f('id') ;
		$source = $phpgw->db->f('source') ;
		$desc = $phpgw->db->f('description') ;
		echo "Journal ID: $id;  Source: $source;  Description: $desc;  Net Dr/Cr Amount: $amount<br>" ;
		}

	$sql = "SELECT a.id,source,description,chart_id,b.amount FROM ${pre}gl a, ${pre}acc_trans b " ;
	$sql.= "WHERE a.id=trans_id and (chart_id=0 or b.amount=0)" ;
	$phpgw->db->query($sql);

	while ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$source = $phpgw->db->f('source') ;
		$desc = $phpgw->db->f('description') ;
		$chart_id = $phpgw->db->f('chart_id') ;
		$amount = sprintf("%01.2f",$phpgw->db->f('amount')) ;
		echo "Journal ID: $id;  Source: $source;  Description: $desc;  A/C id: $chart_id;  Entry Amount: $amount;<br>" ;
		}

	echo lang("<br>End of List<br>") ;

	$t->set_var('lang_confirm',$comment);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('yes_action',$phpgw->link("/$app/reportfilter.php"));
	$t->set_var('no_action',$phpgw->link("/$app/reportfilter.php"));
	$t->set_var('lang_yes',lang('Done'));
	$t->set_var('lang_no',lang('Done'));
	$t->pparse('out','report',True);
	ExecMethod('ck-api.process.process_footer') ;

?>
