<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: bulkpayrollemail.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'bulkpayroll' ;
	$enable_nm = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$yes = ($_GET["yes"]) ? $_GET["yes"] : $_POST["yes"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-payroll'));
	$t->set_file('screen','confirm.tpl') ;
	$t->set_file('report',"$script.tpl") ;
	$t->set_block('report','recur_row','recur_section');
	$t->set_block('report','nonrecur_row','nonrecur_section');
	$t->set_block('report','rdtn_row','rdtn_section');
	$t->set_block('report','cntr_row','cntr_section');
	$t->set_block('report','done','done_section');
	$t->set_var('done_section',"") ;
	$charset = lang('charset') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$logofile = $ckapi[hostsys][dataarea]."/images/logo.png" ;
	$logourl = $phpgw->link("/ck-admin/logoview_image.php","imgfile=$logofile") ;	
	$t->set_var('logo',$logourl);
	$logtitle = lang("Salary Advice Email Despatch Log") ;
	if ($yes)	echo "<br><br><b>$logtitle</b><br><br>" ;

/*------------- Setup Advice Caption/Legend Details ----------------------------*/

	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;

	$lang_from = strtolower(lang('from')) ;
	$lang_to = strtolower(lang('to')) ;
	$frommarker = $lang_from.'::' ;
	$tomarker = $lang_to.'::' ;
	$phpgw->db->query("SELECT * FROM ${pre}gl WHERE id='$id'");
	$phpgw->db->next_record();
	$desc = $phpgw->db->f('description') ;
	list($dummy,$fromto) = explode($frommarker,$desc) ;
	list($datefrom,$dateto) = explode($tomarker,$fromto) ;
	$datefrom = trim($datefrom);
	$dateto = trim($dateto);

	$t->set_var('lang_advice',strtoupper(lang('CONFIDENTIAL SALARY ADVICE')));
	$t->set_var('lang_start',lang('Payroll Period Start'));
	$t->set_var('start',$datefrom) ;
	$t->set_var('lang_end',lang('Payroll Period End'));
	$t->set_var('end',$dateto) ;
	$t->set_var('lang_sname',lang('Staff Name'));

	$t->set_var('lang_eaid',lang("Recurring Item"));
	$t->set_var('lang_basis',lang("Basis of Calculation"));
	$t->set_var('lang_qty',lang("Quantity"));
	$t->set_var('lang_unit',lang("Unit"));
	$t->set_var('lang_unitamt',lang("Unit Amount"));
	$t->set_var('lang_rate',lang("Pay Rate"));
	$t->set_var('lang_amount',lang("Amount"));
	$t->set_var('lang_comment',lang("Comment"));
	$t->set_var('lang_total',lang('Total Recurring'));

	$t->set_var('lang_nreaid',lang("Non-Recurring Allowance/Deduction"));
	$t->set_var('lang_nrapproved_by',lang("Approved By"));
	$t->set_var('lang_nrbasis',lang("Basis of Calculation"));
	$t->set_var('lang_nrqty',lang("Quantity"));
	$t->set_var('lang_nrunit',lang("Unit"));
	$t->set_var('lang_nrunitamt',lang("Unit Amount"));
	$t->set_var('lang_nrrate',lang("Pay Rate"));
	$t->set_var('lang_nramount',lang("Amount"));
	$t->set_var('lang_nrcomment',lang("Comment"));
	$t->set_var('lang_nrtotal',lang('Total Non-Recurring (Expense/Allowance Claim)'));

	$t->set_var('lang_rdtnid',lang("Summary Level Reduction"));
	$t->set_var('lang_rdbaseamt',lang("Base (A)"));
	$t->set_var('lang_rdfloor',lang("Floor (B)"));
	$t->set_var('lang_rdrate',lang("Rate (C)"));
	$t->set_var('lang_rdsubtract',lang("Subtract (D)"));
	$t->set_var('lang_rdamount',lang("Amount ((A-B)*C-D)"));
	$t->set_var('lang_rdremark',lang("Remark"));
	$t->set_var('lang_rdtotal',lang("Total Reduction"));
	$t->set_var('lang_net',lang("Net Payroll This Period"));

	$t->set_var('lang_cntrid',lang("Company Contribution"));
	$t->set_var('lang_ctbaseamt',lang("Base (A)"));
	$t->set_var('lang_ctfloor',lang("Floor (B)"));
	$t->set_var('lang_ctrate',lang("Rate (C)"));
	$t->set_var('lang_ctsubtract',lang("Subtract (D)"));
	$t->set_var('lang_ctamount',lang("Amount ((A-B)*C-D)"));
	$t->set_var('lang_ctremark',lang("Remark"));
	$t->set_var('lang_cttotal',lang("Total Contribution"));
	$eaid_sl = eaid_selectlist('','','long') ;
	$rdtnid_sl = rdtnid_selectlist('','','long') ;
	$cntrid_sl = cntrid_selectlist('','','long') ;

	$sql =	"SELECT distinct a.empid,b.name,c.prefix,c.suffix " ;
	$sql.=	"FROM ${pre}pyrohist a,${pre}employee b,${pre}email c " ;
	$sql.=	"WHERE trans_id='$id' and b.id=a.empid and c.empid=a.empid and emailcode='BUSI'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0)	echo lang("No salary advice selected for despatch") ;
		else	For ($i=1;$phpgw->db->next_record();$i++) $senditem[$i]=$phpgw->db->Record ;

For ($i=1;isset($senditem[$i]);$i++) {
	$t->set_var('recur_section',"");
	$t->set_var('nonrecur_section',"");
	$t->set_var('rdtn_section',"");
	$t->set_var('cntr_section',"");

	$empid = $senditem[$i][empid] ;
	$staffname = $senditem[$i][name] ;
	$t->set_var('sname',$staffname) ;
	$staffemail = $senditem[$i][prefix]."@".$senditem[$i][suffix] ;
	$tot_rcamount = $tot_nramount = $tot_rdamount = $tot_ctamount = 0 ;
	$sql = "SELECT * FROM ${pre}pyrohist WHERE trans_id='$id' and empid='$empid' ";
	$phpgw->db->query($sql);
	For ($j=1;$phpgw->db->next_record();$j++) {
		/*-------------Print Advice Body --------------------------------------------*/
		$type = $phpgw->db->f('type') ;
		switch ($type) :
			case "PYRC" :
				$amount = - $phpgw->db->f('amount') ;
				$marker = $phpgw->db->f('codeid')."'>" ;
				$pieces = explode($marker,$eaid_sl) ;
				$pcs = explode(" -- ",$pieces[1]) ;
				$t->set_var(array(
						'eaid'		=> $pcs[0],
						'basis'		=> $phpgw->db->f('basis'),
						'qty'		=> $phpgw->db->f('qty'),
						'unit'		=> $phpgw->db->f('unit'),
						'unitamt'	=> $phpgw->db->f('unitamt'),
						'rate'		=> $phpgw->db->f('rate'),
						'amount'	=> $amount,
						'comment'	=> lang('recurring'),
									 ));
				$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
				$t->set_var('tr_color',$tr_color) ;
				$t->parse('recur_section','recur_row',true);
				$tot_rcamount += $amount ;
				break ;
			case "PYNR" :
				$amount = - $phpgw->db->f('amount') ;
				$marker = $phpgw->db->f('codeid')."'>" ;
				$pieces = explode($marker,$eaid_sl) ;
				$pcs = explode(" -- ",$pieces[1]) ;
				$t->set_var(array(
						'nreaid'	=> $pcs[0],
						'nrapproved_by'	=> $phpgw->db->f('approved_by'),
						'nrbasis'	=> $phpgw->db->f('basis'),
						'nrqty'		=> $phpgw->db->f('qty'),
						'nrunit'	=> $phpgw->db->f('unit'),
						'nrunitamt'	=> $phpgw->db->f('unitamt'),
						'nrrate'	=> $phpgw->db->f('rate'),
						'nramount'	=> $amount,
						'nrcomment'	=> $phpgw->db->f('comment'),
									 ));
				$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
				$t->set_var('tr_color',$tr_color) ;
				$t->parse('nonrecur_section','nonrecur_row',true);
				$tot_nramount += $amount ;
				break ;
			case "RDTN" :
				$amount = $phpgw->db->f('amount') ;
				$pieces = explode($phpgw->db->f('codeid'),$rdtnid_sl) ;
				$pcs = explode(" -- ",$pieces[1]) ;
				$t->set_var(array(
						'rdtnid'	=> $pcs[1],
						'rdbaseamt'	=> $phpgw->db->f('base'),
						'rdfloor'	=> $phpgw->db->f('floor'),
						'rdrate'	=> $phpgw->db->f('rate'),
						'rdsubtract'	=> $phpgw->db->f('subtract'),
						'rdamount'	=> $amount,
						'rdremark'	=> $phpgw->db->f('comment'),
									 ));
				$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
				$t->set_var('tr_color',$tr_color) ;
				$t->parse('rdtn_section','rdtn_row',true);
				$tot_rdamount += $amount ;
				break ;
			case "NETP" :	$t->set_var('net',$phpgw->db->f('amount')) ;	break ;
			case "CTDR" :	break ;
			case "CTCR" :
				$amount = $phpgw->db->f('amount') ;
				$pieces = explode($phpgw->db->f('codeid'),$cntrid_sl) ;
				$pcs = explode(" -- ",$pieces[1]) ;
				$t->set_var(array(
						'cntrid'	=> $pcs[1],
						'ctbaseamt'	=> $phpgw->db->f('base'),
						'ctfloor'	=> $phpgw->db->f('floor'),
						'ctrate'	=> $phpgw->db->f('rate'),
						'ctsubtract'	=> $phpgw->db->f('subtract'),
						'ctamount'	=> $amount,
						'ctremark'	=> $phpgw->db->f('comment'),
									 ));
				$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
				$t->set_var('tr_color',$tr_color) ;
				$t->parse('cntr_section','cntr_row',true);
				$tot_ctamount += $amount ;
				break ;
			endswitch ;
		}

	$t->set_var('tot_rcamount',$tot_rcamount);
	$t->set_var('tot_nramount',$tot_nramount);
	$t->set_var('tot_rdamount',$tot_rdamount);
	$t->set_var('tot_ctamount',$tot_ctamount);
	$t->set_var('lang_thank',lang("Thank you for your continuing effort")) ;

	if ($yes) {
		$err = "" ; $error=lang("Error") ; $noemail=lang("No email sent") ;
		$advicemsg = lang("Salary Advice for staff") ;
		$successmsg = lang("Email successfully queued for delivery to") ;
		$failuremsg = lang("Email fails to deliver to") ;
		if (!$staffemail)				$err = lang("Staff email missing") ;
		if (!$comemail)					$err = lang("Company return email missing");
		if ($err)	echo "$advicemsg, $staffname -- $noemail -- $error: $err<br>" ;
	   	else {
			$recipient = "$staffname < $staffemail >" ;
			$subject = lang("Confidential Salary Advice for period from %1 to %2",$datefrom,$dateto) ;
			$bdmarker = "CK-ERP_".md5(uniqid(time())) ;
			$headers = "From: $company < $comemail >\n" ;
			$headers.= "Bcc: $company < $comemail >\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ;
			$headers.= "MIME-Version: 1.0\n" ;
			$headers.= "Content-Type: multipart/mixed; boundary=\"$bdmarker\"\n" ;
			$message = "--$bdmarker\n" ;
			$message.= "Content-Type: text/html; charset=$charset\n" ;
			$message.= "Content-Transfer-Encoding: 7bit\n" ;
			$contentid = md5(uniqid(time())) ;
			$message.= str_replace($logourl,"cid:$contentid",$t->parse('out','report',true)) ;
			$message.= "--$bdmarker\n" ;
			$message.= "Content-Type: image/png\n" ;
			$message.= "Content-Transfer-Encoding: base64\n" ;
			$message.= "Content-ID: $contentid\n\n" ;
			$fd = fopen("$logofile","r");
			$message.= chunk_split(base64_encode(fread($fd,filesize($logofile))))."\n";
			$message.= "--$bdmarker--\n" ;

/*			$message = $t->parse('out','report',true) ;
			$headers = "From: $company < $comemail >\n" ;
			$headers.= "Content-Type: text/html; charset=$charset\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ; */
			$result = mail($recipient,$subject,$message,$headers) ;
			if ($result)	echo "$advicemsg, $staffname -- $successmsg $staffemail<br>" ;
				else	echo "$advicemsg, $staffname -- $failuremsg $staffemail<br>" ;
			}
		}

	}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "filter=$filter" ;
	if (!$yes) {
		$t->set_var('lang_confirm',lang("Are you sure you want to email Salary Advice (sample below)")) ;
		$t->set_var('lang_yes',lang("Email Salary Advice")) ;
		$t->set_var('lang_no',lang("Done")) ;
		$t->set_var('no_action',$phpgw->link("/$app/${tran}list.php",$getstr)) ;
		$getstr.= "&id=$id&datefrom=$datefrom&dateto=$dateto" ;
		$t->set_var('yes_action',$phpgw->link("/$app/${tran}email.php",$getstr)) ;
		$t->pparse('out','screen',true);
		$t->pparse('out','report',true);
		}
	   else	{
		$t->set_var('lang_confirm',lang("Despatch Completed")) ;
		$t->set_var('lang_yes',lang("Done")) ;
		$t->set_var('lang_no',lang("Done")) ;
		$t->set_var('yes_action',$phpgw->link("/$app/${tran}list.php",$getstr)) ;
		$t->set_var('no_action',$phpgw->link("/$app/${tran}list.php",$getstr)) ;
		$t->pparse('out','screen',true);
		}
	ExecMethod('ck-api.process.process_footer') ;

?>
