<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.payroll.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class payroll {

//---- Payroll List SQL Formation

    function payroll_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$lang_from = lang('from') ;
	$lang_to = lang('to') ;
	$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
	$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
	$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
	$topos = "position('$tomarker' in description)+$tomarkerlen" ;
	$descdatefrom = "substring(description,$frompos,10)" ;
	$descdateto = "substring(description,$topos,10)" ;

	if (substr_count($where,"datefrom")>0) {
		list($dummy,$datestr) = explode("datefrom",$where) ;
		list($dummy,$datefrom) = explode("'",$datestr) ;
		}
	if (substr_count($where,"dateto")>0) {
		list($dummy,$datestr) = explode("dateto",$where) ;
		list($dummy,$dateto) = explode("'",$datestr) ;
		}
	$where = "" ;
	if ($datefrom)	$where .= " AND $descdatefrom>='$datefrom' and $descdatefrom<='$dateto' ";
	if ($dateto)	$where .= " AND $descdateto>='$datefrom' and $descdateto<='$dateto' ";

	$user = $ckapi[hostsys][username];
	$sql =	"SELECT name as staff,$descdatefrom as datefrom,$descdateto as dateto," ;
	$sql.=	"description,b.id,empid " ;
	$sql.=	"FROM ${pre}pyrohist a, ${pre}gl b, ${pre}employee c " ;
	$sql.=	"WHERE 1=1 $where and username='$user' and source='PYRO' and trans_id=b.id and " ;
	$sql.=	"type='NETP' and empid=c.id " ;
	$sql.=	"order by $order $sort" ;

	return $sql ;
	}

//---- Payroll List Link Adjustement

    function payroll_list_adjust() {
	global $ckapi,$phpgw ;

	$t = &$ckapi[objects][template] ;
	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	$id = $ckapi[params_list][dt][id] ;
	$filter = $ckapi[params_list][filter] ;
	$empid = $ckapi[params_list][dt][empid] ;
	$description = $ckapi[params_list][dt][description] ;
	$getstr = "id=$id&empid=$empid&description=$description&filter=$filter" ;
	$t->set_var('view',$phpgw->link("/$app/${tran}view.php",$getstr));
	}

//---- Payroll Read

    function payroll_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;

	if ($op=="view")	{$dt = $this->payroll_past_read() ; return $dt ;}
	$user = $ckapi[hostsys][username];
	$sql = "SELECT a.id FROM ${pre}payroll a, ${pre}employee b " ;
	$sql.= "WHERE a.empid=b.id and b.username='$user'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$id=$phpgw->db->f('id');

	$phpgw->db->query("SELECT * FROM ${pre}payroll WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$phpgw->db->query("SELECT * FROM ${pre}pyrc_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['eaid'.$i]		=	$phpgw->db->f('pyrcodeid') ;
		$dt['qty'.$i]		=	$phpgw->db->f('qty') ;
		$dt['rate'.$i]		=	$phpgw->db->f('rate') ;
		$dt['amount'.$i]	=	$phpgw->db->f('amount') ;
		$dt['comment'.$i]	=	$phpgw->db->f('comment') ;
		}
	$sql = "SELECT * FROM ${pre}pynr_trans WHERE empid='$dt[empid]' and approved_by<>'' ORDER BY id";
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['nreaid'.$i]	=	$phpgw->db->f('pyrcodeid') ;
		$dt['nrapproved_by'.$i]	=	$phpgw->db->f('approved_by') ;
		$dt['nrqty'.$i]		=	$phpgw->db->f('qty') ;
		$dt['nrunit'.$i]	=	$phpgw->db->f('unit') ;
		$dt['nrunitamt'.$i]	=	$phpgw->db->f('unitamt') ;
		$dt['nrrate'.$i]	=	$phpgw->db->f('rate') ;
		$dt['nramount'.$i]	=	$phpgw->db->f('amount') ;
		$dt['nrcomment'.$i]	=	$phpgw->db->f('comment') ;
		}
	$phpgw->db->query("SELECT * FROM ${pre}rdtn_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++)	$dt['rdtnid'.$i] = $phpgw->db->f('rdtnid') ;
	$phpgw->db->query("SELECT * FROM ${pre}cntr_trans WHERE pyroid='$id' ORDER BY id");
	For ($i=1;$phpgw->db->next_record();$i++)	$dt['cntrid'.$i] = $phpgw->db->f('cntrid') ;

	return $dt ;
	}


//---- Payroll Read

    function payroll_past_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$empid = ($_GET["empid"]) ? $_GET["empid"] : $_POST["empid"] ;

	$phpgw->db->query("SELECT * FROM ${pre}payroll WHERE empid='$empid'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$sql = "SELECT * FROM ${pre}pyrohist WHERE trans_id='$id' and empid='$empid' and type='PYRC'";
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['eaid'.$i]		=	$phpgw->db->f('codeid') ;
		$dt['basis'.$i]		=	$phpgw->db->f('basis') ;
		$dt['qty'.$i]		=	$phpgw->db->f('qty') ;
		$dt['unit'.$i]		=	$phpgw->db->f('unit') ;
		$dt['unitamt'.$i]	=	$phpgw->db->f('unitamt') ;
		$dt['rate'.$i]		=	$phpgw->db->f('rate') ;
		$dt['amount'.$i]	=	-$phpgw->db->f('amount') ;
		$dt['comment'.$i]	=	$phpgw->db->f('comment') ;
		}
	$sql = "SELECT * FROM ${pre}pyrohist WHERE trans_id='$id' and empid='$empid' and type='PYNR'" ;
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['nreaid'.$i]	=	$phpgw->db->f('codeid') ;
		$dt['nrapproved_by'.$i]	=	$phpgw->db->f('approved_by') ;
		$dt['nrbasis'.$i]	=	$phpgw->db->f('basis') ;
		$dt['nrqty'.$i]		=	$phpgw->db->f('qty') ;
		$dt['nrunit'.$i]	=	$phpgw->db->f('unit') ;
		$dt['nrunitamt'.$i]	=	$phpgw->db->f('unitamt') ;
		$dt['nrrate'.$i]	=	$phpgw->db->f('rate') ;
		$dt['nramount'.$i]	=	-$phpgw->db->f('amount') ;
		$dt['nrcomment'.$i]	=	$phpgw->db->f('comment') ;
		}
	$sql = "SELECT * FROM ${pre}pyrohist WHERE trans_id='$id' and empid='$empid' and type='RDTN'" ;
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['rdtnid'.$i] = $phpgw->db->f('codeid') ;
		$dt['rdbase'.$i] = $phpgw->db->f('base') ;
		$dt['rdfloor'.$i] = $phpgw->db->f('floor') ;
		$dt['rdrate'.$i] = $phpgw->db->f('rate') ;
		$dt['rdsubtract'.$i] = $phpgw->db->f('subtract') ;
		$dt['rdamount'.$i] = $phpgw->db->f('amount') ;
		$dt['rdcomment'.$i] = $phpgw->db->f('comment') ;
		}
	$sql = "SELECT * FROM ${pre}pyrohist WHERE trans_id='$id' and empid='$empid' and type='CTCR'" ;
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['cntrid'.$i] = $phpgw->db->f('codeid') ;
		$dt['ctbase'.$i] = $phpgw->db->f('base') ;
		$dt['ctfloor'.$i] = $phpgw->db->f('floor') ;
		$dt['ctrate'.$i] = $phpgw->db->f('rate') ;
		$dt['ctsubtract'.$i] = $phpgw->db->f('subtract') ;
		$dt['ctamount'.$i] = $phpgw->db->f('amount') ;
		$dt['ctcomment'.$i] = $phpgw->db->f('comment') ;
		}
	return $dt ;
	}
//---- Write Payroll Header

    function payroll_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$tran = $ckapi[params][tran] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_block('report','nrdetail','nrdetail_section');
	$t->set_block('report','rdtn','rdtn_section');
	$t->set_block('report','cntr','cntr_section');

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('mndfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('smdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('wkdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * $phpgw->db->f('dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;
	$t->set_var('lang_empid',lang('Employee'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_salary',lang('Current Basic Salary'));
	$t->set_var('lang_period',lang('Current Pay Period'));
	$t->set_var('lang_daypay',lang('Imputed Current Daily Pay'));
	$t->set_var('lang_hourpay',lang('Imputed Current Hourly Pay'));
	$t->set_var('employee_selectlist',employee_selectlist("WHERE id=$dt[empid]",'')) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('salary',$dt[salary]) ;
	$t->set_var('period',$dt[period]) ;
	$t->set_var('daypay',$dt[daypay]) ;
	$t->set_var('hourpay',$dt[hourpay]) ;
	$t->parse('out','report',True);
	}


//---- Write Payroll Detail

    function payroll_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_eaid',lang("Recurring Item"));
	$t->set_var('lang_basis',lang("Basis of Calculation"));
	$t->set_var('lang_qty',lang("Quantity"));
	$t->set_var('lang_unit',lang("Unit"));
	$t->set_var('lang_unitamt',lang("Unit Amount"));
	$t->set_var('lang_rate',lang("Pay Rate"));
	$t->set_var('lang_amount',lang("Amount"));
	$t->set_var('lang_comment',lang("Comment"));
	$t->set_var('lang_total',lang('Total Recurring'));

	$t->set_var('lang_nreaid',lang("Non-Recurring Allowance/Deduction"));
	$t->set_var('lang_nrapproved_by',lang("Approved By"));
	$t->set_var('lang_nrbasis',lang("Basis of Calculation"));
	$t->set_var('lang_nrqty',lang("Quantity"));
	$t->set_var('lang_nrunit',lang("Unit"));
	$t->set_var('lang_nrunitamt',lang("Unit Amount"));
	$t->set_var('lang_nrrate',lang("Pay Rate"));
	$t->set_var('lang_nramount',lang("Amount"));
	$t->set_var('lang_nrcomment',lang("Comment"));
	$t->set_var('lang_nrtotal',lang('Total Non-Recurring (Expense/Allowance Claim)'));

	$t->set_var('lang_reductn',lang("Summary Level Reduction"));
	$t->set_var('lang_rdtnid',lang("Reduction Type"));
	$t->set_var('lang_rdbaseamt',lang("Base"));
	$t->set_var('lang_rdfloor',lang("Floor"));
	$t->set_var('lang_rdrate',lang("Rate"));
	$t->set_var('lang_rdsubtract',lang("Subtract"));
	$t->set_var('lang_rdamount',lang("Amount"));
	$t->set_var('lang_rdremark',lang("Remark"));
	$t->set_var('lang_rdtotal',lang("Total Reduction"));
	$t->set_var('lang_net',lang("Net Payroll This Period"));

	$t->set_var('lang_contri',lang("Company Contribution"));
	$t->set_var('lang_cntrid',lang("Contribution Type"));
	$t->set_var('lang_ctbaseamt',lang("Base"));
	$t->set_var('lang_ctfloor',lang("Floor"));
	$t->set_var('lang_ctrate',lang("Rate"));
	$t->set_var('lang_ctsubtract',lang("Subtract"));
	$t->set_var('lang_ctamount',lang("Amount"));
	$t->set_var('lang_ctremark',lang("Remark"));
	$t->set_var('lang_cttotal',lang("Total Contribution"));

	$float = ($ckapi[hostsys][dbtype]=="mysql") ? "double" : "float" ;
	$user = $ckapi[hostsys][username];
	$temp = "pyr".$user.time() ;
	$phpgw->db->query("CREATE TABLE $temp (pyrcodeid int,amount $float)");

	$tot_amount = 0 ;	$t->set_var('detail_section','') ;
	For ($i=1;isset($dt['eaid'.$i]);$i++) {
		if ($period=='PAST') {
			$eaid	=	$dt['eaid'.$i] ;
			$basis	=	$dt['basis'.$i] ;
			$qty	=	$dt['qty'.$i] ;
			$unit	=	$dt['unit'.$i] ;
			$unitamt=	$dt['unitamt'.$i] ;
			$rate	=	$dt['rate'.$i] ;
			$amount	=	$dt['amount'.$i] ;
			}
		   else {
			$qty = 1 ;
			$eaid	=	$dt['eaid'.$i] ;
			$phpgw->db->query("SELECT * from ${pre}pyrcode where id='$eaid'");
			$phpgw->db->next_record();
			$basis		= $phpgw->db->f('basis') ;
			$unit		= $phpgw->db->f('unit') ;
			$unitamt	= (substr_count($basis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
			$rate		= $phpgw->db->f('rate') ;
			if (substr_count($basis,'qty')>0)	$qty = $dt['qty'.$i];
			if (substr_count($basis,'bs')>0)	$unitamt = $dt[salary] ;
			if (substr_count($basis,'hp')>0)	$unitamt = $dt[hourpay] ;
			if (substr_count($basis,'dp')>0)	$unitamt = $dt[daypay] ;
			$amount = sprintf("%01.2f",sprintf("%01.4f",$qty*$unitamt*$rate)) ;
			if (substr_count($basis,'amt')>0)	$amount=$dt['amount'.$i];
			}
		$t->set_var('eaid_selectlist',eaid_selectlist("WHERE id=$eaid",'','short')) ;
		$t->set_var('basis',$basis) ;
		$t->set_var('qty',$qty) ;
		$t->set_var('unit',$unit) ;
		$t->set_var('unitamt',$unitamt) ;
		$t->set_var('rate',$rate) ;
		$t->set_var('amount',$amount) ;
		$dt['qty'.$j] = $qty ;
		$dt['amount'.$j] = $amount ;
		$t->set_var('comment',lang('recurring')) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);

		$phpgw->db->query("INSERT INTO $temp(pyrcodeid,amount) VALUES('$eaid','$amount')");
		$tot_amount += $amount ;
		}
	$t->set_var('tot_amount',$tot_amount) ;

	$tot_nramount = 0 ;	$t->set_var('nrdetail_section','') ;
	For ($i=1;isset($dt['nreaid'.$i]);$i++) {
		if ($period=='PAST') {
			$nreaid		=	$dt['nreaid'.$i] ;
			$nrbasis	=	$dt['nrbasis'.$i] ;
			$nrqty		=	$dt['nrqty'.$i] ;
			$nrunit		=	$dt['nrunit'.$i] ;
			$nrunitamt	=	$dt['nrunitamt'.$i] ;
			$nrrate		=	$dt['nrrate'.$i] ;
			$nramount	=	$dt['nramount'.$i] ;
			$nrcomment	=	$dt['nrcomment'.$i] ;
			}
		   else {
			$nrqty = 1 ;
			$nreaid	=	$dt['nreaid'.$i] ;
			$phpgw->db->query("SELECT * from ${pre}pyrcode where id='$nreaid'");
			$phpgw->db->next_record();
			$nrbasis	= $phpgw->db->f('basis') ;
			$nrunit		= $phpgw->db->f('unit') ;
			$nrunitamt	= (substr_count($nrbasis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
			$nrrate		= $phpgw->db->f('rate') ;
			if (substr_count($nrbasis,'qty')>0)	$nrqty = $dt['nrqty'.$i];
			if (substr_count($nrbasis,'bs')>0)	$nrunitamt = $dt[salary] ;
			if (substr_count($nrbasis,'hp')>0)	$nrunitamt = $dt[hourpay] ;
			if (substr_count($nrbasis,'dp')>0)	$nrunitamt = $dt[daypay] ;
			$nramount = sprintf("%01.2f",sprintf("%01.4f",$nrqty*$nrunitamt*$nrrate)) ;
			if (substr_count($nrbasis,'amt')>0)	$nramount=$dt['nramount'.$i];
			}
		$t->set_var('nreaid_selectlist',eaid_selectlist("WHERE id=$nreaid",'','short')) ;
		$t->set_var('nrapproved_by',$dt['nrapproved_by'.$i]) ;
		$t->set_var('nrbasis',$nrbasis) ;
		$t->set_var('nrqty',$nrqty) ;
		$t->set_var('nrunit',$nrunit) ;
		$t->set_var('nrunitamt',$nrunitamt) ;
		$t->set_var('nrrate',$nrrate) ;
		$t->set_var('nramount',$nramount) ;
		$dt['nrqty'.$j] = $nrqty ;
		$dt['nramount'.$j] = $nramount ;
		$t->set_var('nrcomment',$dt['nrcomment'.$i]) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('nrdetail_section','nrdetail', True);

		$phpgw->db->query("INSERT INTO $temp(pyrcodeid,amount) VALUES('$nreaid','$nramount')");
		$tot_nramount += $nramount ;
		}
	$t->set_var('tot_nramount',$tot_nramount) ;

	$tot_rdamount = 0 ;	$t->set_var('rdtn_section','') ;
	For ($i=1;isset($dt['rdtnid'.$i]);$i++) {
		if ($period=='PAST') {
			$rdtnid		=	$dt['rdtnid'.$i] ;
			$rdbaseamt	=	$dt['rdbase'.$i] ;
			$rdfloor	=	$dt['rdfloor'.$i] ;
			$rdrate		=	$dt['rdrate'.$i] ;
			$rdsubtract	=	$dt['rdsubtract'.$i] ;
			$rdamount	=	$dt['rdamount'.$i] ;
			$rdremark	=	$dt['rdcomment'.$i] ;
			}
		   else {
			$rdtnid = $dt['rdtnid'.$i] ;
			$sql =	"SELECT sum(amount) as exemamt from $temp a,${pre}rdtnexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
			$sql.=		"and amount>=min and amount<=max" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemamt = $phpgw->db->f('exemamt') ;
			$sql =	"SELECT sum(min) as exemmin from $temp a,${pre}rdtnexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
			$sql.=		"and amount<min and actmin='lmt'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemmin = $phpgw->db->f('exemmin') ;
			$sql =	"SELECT sum(max) as exemmax from $temp a,${pre}rdtnexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
			$sql.=		"and amount>max and actmax='lmt'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemmax = $phpgw->db->f('exemmax') ;
			$rdbaseamt = $tot_amount+$tot_nramount-$exemamt-$exemmin-$exemmax ;

			$sql =	"SELECT max(step) as rdstep from ${pre}rdtnrate a,${pre}reductn b " ;
			$sql.=	"WHERE ($rdbaseamt-floor)>=step and rdtnid='$rdtnid' and b.id='$rdtnid'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$rdstep = $phpgw->db->f('rdstep') ;
			$sql =	"SELECT floor,rate,subtract,min,actmin,max,actmax " ;
			$sql.=	"FROM ${pre}rdtnrate a, ${pre}reductn b " ;
			$sql.=	"WHERE step='$rdstep' and rdtnid='$rdtnid' and b.id='$rdtnid'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$rdfloor = $phpgw->db->f('floor') ;
			$rdrate = $phpgw->db->f('rate') ;
			$rdsubtract = $phpgw->db->f('subtract') ;
			$rdmin = $phpgw->db->f('min') ;
			$rdactmin = $phpgw->db->f('actmin') ;
			$rdmax = $phpgw->db->f('max') ;
			$rdactmax = $phpgw->db->f('actmax') ;
			$rdamount = sprintf("%01.2f",($rdbaseamt-$rdfloor) * $rdrate - $rdsubtract) ;
			$rdremark = "" ;
			if ($rdamount<$rdmin) {
				$rdamount = ($rdactmin=="lmt") ? $rdmin : 0 ;
				$rdremark = ($rdactmin=="lmt") ? lang('Set to Min') : lang('Min Reject') ;
				}
			if ($rdamount>$rdmax) {
				$rdamount = ($rdactmax=="lmt") ? $rdmax : 0 ;
				$rdremark = ($rdactmax=="lmt") ? lang('Set to Max') : lang('Max Reject') ;
				}
			}
		$t->set_var('rdtnid_selectlist',rdtnid_selectlist("WHERE id=$rdtnid",'','short')) ;
		$t->set_var('rdbaseamt',$rdbaseamt) ;
		$t->set_var('rdfloor',$rdfloor) ;
		$t->set_var('rdrate',$rdrate) ;
		$t->set_var('rdsubtract',$rdsubtract) ;
		$t->set_var('rdamount',$rdamount) ;
		$t->set_var('rdremark',$rdremark) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('rdtn_section','rdtn', True);
		$tot_rdamount += $rdamount ;
		}
	$t->set_var('tot_rdamount',$tot_rdamount) ;
	$t->set_var('net',$tot_amount+$tot_nramount-$tot_rdamount) ;

	$tot_ctamount = 0 ;	$t->set_var('cntr_section','') ;
	For ($i=1;isset($dt['cntrid'.$i]);$i++) {
		if ($period=='PAST') {
			$cntrid		=	$dt['cntrid'.$i] ;
			$ctbaseamt	=	$dt['ctbase'.$i] ;
			$ctfloor	=	$dt['ctfloor'.$i] ;
			$ctrate		=	$dt['ctrate'.$i] ;
			$ctsubtract	=	$dt['ctsubtract'.$i] ;
			$ctamount	=	$dt['ctamount'.$i] ;
			$ctremark	=	$dt['ctcomment'.$i] ;
			}
		   else {
			$cntrid = $dt['cntrid'.$i] ;
			$sql =	"SELECT sum(amount) as exemamt from $temp a,${pre}cntrexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
			$sql.=		"and amount>=min and amount<=max" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemamt = $phpgw->db->f('exemamt') ;
			$sql =	"SELECT sum(min) as exemmin from $temp a,${pre}cntrexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
			$sql.=		"and amount<min and actmin='lmt'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemmin = $phpgw->db->f('exemmin') ;
			$sql =	"SELECT sum(max) as exemmax from $temp a,${pre}cntrexem b " ;
			$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
			$sql.=		"and amount>max and actmax='lmt'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$exemmax = $phpgw->db->f('exemmax') ;
			$ctbaseamt = $tot_amount+$tot_nramount-$exemamt-$exemmin-$exemmax ;

			$sql =	"SELECT max(step) as ctstep from ${pre}cntrrate a,${pre}contri b " ;
			$sql.=	"WHERE ($ctbaseamt-floor)>=step and cntrid='$cntrid' and b.id='$cntrid'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$ctstep = $phpgw->db->f('ctstep') ;
			$sql =	"SELECT floor,rate,subtract,min,actmin,max,actmax " ;
			$sql.=	"FROM ${pre}cntrrate a, ${pre}contri b " ;
			$sql.=	"WHERE step='$ctstep' and cntrid='$cntrid' and b.id='$cntrid'" ;
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$ctfloor = $phpgw->db->f('floor') ;
			$ctrate = $phpgw->db->f('rate') ;
			$ctsubtract = $phpgw->db->f('subtract') ;
			$ctmin = $phpgw->db->f('min') ;
			$ctactmin = $phpgw->db->f('actmin') ;
			$ctmax = $phpgw->db->f('max') ;
			$ctactmax = $phpgw->db->f('actmax') ;
			$ctamount = sprintf("%01.2f",($ctbaseamt-$ctfloor) * $ctrate - $ctsubtract) ;
			$ctremark = "" ;
			if ($ctamount<$ctmin) {
				$ctamount = ($ctactmin=="lmt") ? $ctmin : 0 ;
				$ctremark = ($ctactmin=="lmt") ? lang('Set to Min') : lang('Min Reject') ;
				}
			if ($ctamount>$ctmax) {
				$ctamount = ($ctactmax=="lmt") ? $ctmax : 0 ;
				$ctremark = ($ctactmax=="lmt") ? lang('Set to Max') : lang('Max Reject') ;
				}
			}
		$t->set_var('cntrid_selectlist',cntrid_selectlist("WHERE id=$cntrid",'','short')) ;
		$t->set_var('ctbaseamt',$ctbaseamt) ;
		$t->set_var('ctfloor',$ctfloor) ;
		$t->set_var('ctrate',$ctrate) ;
		$t->set_var('ctsubtract',$ctsubtract) ;
		$t->set_var('ctamount',$ctamount) ;
		$t->set_var('ctremark',$ctremark) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('cntr_section','cntr', True);
		$tot_ctamount += $ctamount ;
		}
	$t->set_var('tot_ctamount',$tot_ctamount) ;
	$t->set_var('net',$tot_amount+$tot_nramount-$tot_rdamount) ;

	$t->parse('out','report',True);

	$phpgw->db->query("DROP TABLE $temp");

	}

    }

?>

